/*
 *  TOPPERS/JSP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Just Standard Profile Kernel
 * 
 *  Copyright (C) 2000-2003 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 *  Copyright (C) 2001-2003 by Industrial Technology Institute,
 *                              Miyagi Prefectural Government, JAPAN
 *  Copyright (C) 2001-2003 by Dep. of Computer Science and Engineering
 *                   Tomakomai National College of Technology, JAPAN
 *  Copyright (C) 2003 by Katsuhiro Amano
 * 
 *  嵭Ԥϡʲ (1)(4) ξ狼Free Software Foundation 
 *  ˤäƸɽƤ GNU General Public License  Version 2 ˵
 *  ҤƤ˸¤ꡤܥեȥܥեȥ
 *  ѤΤޤࡥʲƱˤѡʣѡۡʰʲ
 *  ѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơŬѲǽ
 *  ޤơʤݾڤԤʤޤܥեȥѤˤľ
 *  ŪޤϴŪʤ»˴ؤƤ⡤Ǥʤ
 * 
 *  @(#) $Id: cpu_config.c,v 1.9 2003/12/11 07:00:10 honda Exp $
 */

#include "jsp_kernel.h"
#include "check.h"
#include "task.h"

#include <hw_serial.h>

/*
 *  ץå¸⥸塼H8ѡ
 */

/*
 *  󥿥ƥȤǤγߥޥ
 */

UB	int_intmask = 0;

/*
 *  ߥͥȥ
 */

UW	intnest = 0;

/*
 *  ٥ơ֥νfor RedBoot
 */
#ifdef REDBOOT
#define VECTOR_TABLE_ADDR 	0x00fffd20
#define JMP_OPECODE		0x5a000000
extern void	vectors(void);

static void
vector_table_copy(void)
{
	unsigned int n = 0x100/sizeof(unsigned int);		/* ٥ơ֥륵 */
	unsigned int *o = (unsigned int *)VECTOR_TABLE_ADDR;	/* ٥ơ֥륳ԡ */
	unsigned int *i = (unsigned int *)vectors;		/* ٥ơ֥륳ԡ */

    while (n -- > 0)
        *o ++ = JMP_OPECODE | (*i ++);		/* jmp̿ղ */

}
#endif	/* of #ifdef REDBOOT */

/*
 *  ץå¸ν
 */

void
cpu_initialize()
{
	SCI_initialize(SYSTEM_PORTID);

#ifdef REDBOOT
	vector_table_copy();
#endif	/* of #ifdef REDBOOT */
	}

/*
 *  ץå¸νλ
 */

void
cpu_terminate()
{
}

/*
 * ϿƤʤߤȯȸƤӽФ
 */

void cpu_experr(EXCSTACK *sp)
{
    syslog(LOG_EMERG, "Unexpected interrupt.");
    syslog(LOG_EMERG, "PC  = %08x SP  = %08x", sp->pc, sp - 32);
    syslog(LOG_EMERG, "ER0 = %08x ER1 = %08x ER2 = %08x ER3 = %08x",
                       sp->er0, sp->er1, sp->er2, sp->er3);
    syslog(LOG_EMERG, "ER4 = %08x ER5 = %08x ER6 = %08x",
                       sp->er4, sp->er5, sp->er6);
    while(1)
    	;
}

/*
 *   ƥʸλ
 */

void
cpu_putc(char c)
{
    if (c == '\n') {
        SCI_wait_putchar(SYSTEM_SCI, '\r');
    }
    SCI_wait_putchar(SYSTEM_SCI, c);
}

/*
 *  local_memcpy
 *
 *    ɸ C 饤֥ memcpy Ʊॳԡؿ
 *    󥯻˥顼ȯ뤿ᡢ̾ѤƤ롣
 *    ޤ󥯥ץȤκǸιԤ
 *
 *       PROVIDE(_memcpy = _local_memcpy);
 *
 *    ɲä
 */

void *
local_memcpy (void *out, const void *in, unsigned int n)
{
    char *o = out;
    const char *i = in;

    while (n -- > 0)
        *o ++ = *i ++;
    return out;
}
