/*
 *  TOPPERS/JSP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Just Standard Profile Kernel
 * 
 *  Copyright (C) 2000-2004 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 *  Copyright (C) 2001-2004 by Dep. of Computer Science and Engineering
 *                   Tomakomai National College of Technology, JAPAN
 *
 *  嵭Ԥϡʲ (1)(4) ξ狼Free Software Foundation 
 *  ˤäƸɽƤ GNU General Public License  Version 2 ˵
 *  ҤƤ˸¤ꡤܥեȥܥեȥ
 *  ѤΤޤࡥʲƱˤѡʣѡۡʰʲ
 *  ѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơŬѲǽ
 *  ޤơʤݾڤԤʤޤܥեȥѤˤľ
 *  ŪޤϴŪʤ»˴ؤƤ⡤Ǥʤ
 * 
 *  @(#) $Id: ethernet.h,v 1.1.1.1 2004/04/21 00:43:22 abe Exp abe $
 */

/*
 * Copyright (c) 1982, 1986, 1989, 1993
 *	The Regents of the University of California.  All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 3. All advertising materials mentioning features or use of this software
 *    must display the following acknowledgement:
 *	This product includes software developed by the University of
 *	California, Berkeley and its contributors.
 * 4. Neither the name of the University nor the names of its contributors
 *    may be used to endorse or promote products derived from this software
 *    without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE REGENTS AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 *
 * Fundamental constants relating to ethernet.
 *
 * $FreeBSD: src/sys/net/ethernet.h,v 1.9.2.1 1999/08/29 16:28:13 peter Exp $
 *
 */

#ifndef _ETHERNET_H_
#define _ETHERNET_H_

#ifdef SUPPORT_ETHER

/*
 *  եĹ
 */

#define ETHER_ADDR_LEN		6	/* Ethernet (MAC) Address	*/
#define ETHER_TYPE_LEN		2	/* Type		*/
#define ETHER_CRC_LEN		4	/* CRC		*/

/*
 *  ե졼Ĺ (Ethernet إå CRC ޤ)
 */

#define ETHER_MIN_LEN		64
#define ETHER_MAX_LEN		(IF_MTU + sizeof(T_ETHER_HDR) + ETHER_CRC_LEN)

/*
 *  Ethernet إå
 */

#ifndef IF_ETHER_NIC_HDR_ALIGN
#error IF_ETHER_NIC_HDR_ALIGN expected.
#endif	/* of #ifndef IF_ETHER_NIC_HDR_ALIGN */

typedef struct t_ether_header {

#if IF_ETHER_NIC_HDR_ALIGN != 0

	UB	align[IF_ETHER_NIC_HDR_ALIGN];	/* 饤Ĵ */

#endif	/* of #if IF_ETHER_NIC_HDR_ALIGN != 0 */

	UB	dhost[ETHER_ADDR_LEN];
	UB	shost[ETHER_ADDR_LEN];
	UH	type;
	} T_ETHER_HDR;

#define GET_ETHER_HDR(nbuf)		((T_ETHER_HDR*)((nbuf)->buf))

/*
 *  MAC ɥ쥹
 */

#define ETHER_MCAST_ADDR	0x01	/* ޥ㥹ȡɥ쥹	*/
#define ETHER_LOCAL_ADDR	0x02	/* 롦ɥ쥹		*/

typedef struct t_ether_addr {
	UB	lladdr[ETHER_ADDR_LEN];
	} T_ETHER_ADDR;

/*
 *  Type ե
 */

#define ETHER_TYPE_IP	0x0800	/* IPv4	*/
#define ETHER_TYPE_ARP	0x0806	/* ARP	*/
#define ETHER_TYPE_IPV6	0x86dd	/* IPv6	*/

/*
 *  󥿥եޥ
 */

#define T_IF_HDR		T_ETHER_HDR		/* 󥿥եΥإå				*/
#define T_IF_ADDR		T_ETHER_ADDR		/* 󥿥եΥɥ쥹			*/
#define IF_MTU			1500			/* 󥿥ե MTU				*/
#define IF_HDR_ALIGN		2			/* إåΥ饤ñ				*/
#define IF_OUTPUT(o,d,g,t)	ether_output(o,d,g,t)	/* 󥿥եνϴؿ			*/
#define IF_RAW_OUTPUT(o,t)	ether_raw_output(o,t)	/* 󥿥եνϴؿɥ쥹̵	*/
#define IF_SET_PROTO(b,p)	(GET_ETHER_HDR(b)->type = htons(p))
							/* 󥿥եΥץȥؿ		*/
#define IF_SOFTC_TO_IFADDR(s)	((T_IF_ADDR*)(s)->ifaddr.lladdr)
							/* եȥ󤫤 MAC ɥ쥹Ф	*/

/* IPv4 ط */

#define IF_IPV4_ADDR_LOCAL	ether_ipv4_addr_local	/* 󥿥ե IPv4 ɥ쥹			*/
#define IF_IPV4_ADDR_LOCAL_MASK	ether_ipv4_addr_local_mask
							/* 󥿥ե IPv4 ֥ͥåȥޥ		*/
#define IF_IPV4_ADDR_LOCAL_BC	((ether_ipv4_addr_local & ether_ipv4_addr_local_mask) | ~ether_ipv4_addr_local_mask)
							/* 󥿥ե IPv4 ֥ɥ㥹ȥɥ쥹	*/
#define IF_PROTO_IP		ETHER_TYPE_IP		/* 󥿥ե IP ץȥ		*/
#define IF_PROTO_ARP		ETHER_TYPE_ARP		/* 󥿥ե ARP ץȥ		*/

/*
 *  ѿ
 */

extern UW ether_ipv4_addr_local;			/* 󥿥ե IPv4 ɥ쥹			*/
extern UW ether_ipv4_addr_local_mask;			/* 󥿥ե IPv4 ֥ͥåȥޥ		*/

/*
 *  ͥåȥ󥿥ե˰¸ʤեȥ
 */

struct t_if_softc {
	T_IF_ADDR		ifaddr;			/* ͥåȥ󥿥եΥɥ쥹	*/
	UH			timer;			/* ॢ			*/
	T_IF_ETHER_NIC_SOFTC	*sc;			/* ǥХ¸Υեȥ	*/
	ID			semid_txb_ready;	/* ޥե				*/
	ID			semid_rxb_ready;	/* ޥե				*/
	};

#ifndef T_IF_SOFTC_DEFINED

typedef struct t_if_softc T_IF_SOFTC;

#define T_IF_SOFTC_DEFINED

#endif	/* of #ifndef T_IF_SOFTC_DEFINED */

/*
 *  
 */

#ifndef T_NET_BUF_DEFINED

typedef struct t_net_buf T_NET_BUF;

#define T_NET_BUF_DEFINED

#endif	/* of #ifndef T_NET_BUF_DEFINED */

/*
 *  ؿ
 */

extern ER ether_output (T_NET_BUF *data, VP dst, T_IF_ADDR *gw, TMO tmout);
extern ER ether_raw_output (T_NET_BUF *data, TMO tmout);

#endif	/* of #ifdef SUPPORT_ETHER */

#endif	/* of #ifndef _ETHERNET_H_ */
