/*
 *  TOPPERS/JSP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Just Standard Profile Kernel
 * 
 *  Copyright (C) 2000-2003 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 *  Copyright (C) 2001-2003 by Dep. of Computer Science and Engineering
 *                   Tomakomai National College of Technology, JAPAN
 *
 *  嵭Ԥϡʲ (1)(4) ξ狼Free Software Foundation 
 *  ˤäƸɽƤ GNU General Public License  Version 2 ˵
 *  ҤƤ˸¤ꡤܥեȥܥեȥ
 *  ѤΤޤࡥʲƱˤѡʣѡۡʰʲ
 *  ѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơŬѲǽ
 *  ޤơʤݾڤԤʤޤܥեȥѤˤľ
 *  ŪޤϴŪʤ»˴ؤƤ⡤Ǥʤ
 * 
 *  @(#) $Id: dbg_cons.c,v 1.1.1.1 2004/04/21 00:45:44 abe Exp abe $
 */

/* 
 *  ǥХå󥽡
 */

#include <t_services.h>
#include "kernel_id.h"

#include <stdlib.h>

#include "../kernel/jsp_kernel.h"
#include "../kernel/task.h"

#include <tinet_defs.h>
#include <tinet_config.h>

#include <net/net.h>
#include <net/if.h>
#include <net/if_ppp.h>
#include <net/if_loop.h>
#include <net/ethernet.h>
#include <net/net.h>
#include <net/route.h>
#include <net/net_buf.h>
#include <net/net_timer.h>
#include <net/ppp_var.h>
#include <net/ppp_fsm.h>
#include <net/ppp_lcp.h>
#include <net/ppp_ipcp.h>
#include <net/ppp_modem.h>
#include <net/net_count.h>

#include <netinet/in.h>
#include <netinet/in_itron.h>
#include <netinet/if_ether.h>
#include <netinet/tcp.h>
#include <netinet/tcp_timer.h>
#include <netinet/tcp_var.h>
#include <netinet/tcp_fsm.h>

#include <netapp/netapp.h>
#include <netapp/echo.h>
#include <netapp/discard.h>
#include <netapp/dbg_cons.h>

#define DBG_LINE_SIZE	63

/*
 *  ؿ
 */

extern const char *itron_strerror (ER ercd);

/*
 *  task_status -- ξ֤ν
 */

static const char task_stat_str[][sizeof("SUSPENDED")] = {
	"DORMANT",		/* ٻ߾		*/
	"RUNNABLE",		/* ¹ԤǤ	*/
	"WAINTING",		/* Ԥ		*/
	"SUSPENDED",		/* Ԥ		*/

	"SLEEP",		/* Ԥ				*/
	"WOBJ",			/* Ʊ֥̿ȤФԤ	*/
	"WOBJCB",		/* ʬԤ塼ˤĤʤäƤ롣	*/
	};

static void
task_status (UB *line)
{
	TCB	*tcb;
	int	ix, st, sx;

	cons_printf(CONSOLE_PORTID,
	             "TASK Status\n"
	             "ID PI State\n");
	for (ix = TMIN_TSKID; ix <= tmax_tskid; ix ++) {
		tcb = get_tcb(ix);
		cons_printf(CONSOLE_PORTID, "%2d %2d ", ix, tcb->priority);
		st = tcb->tstat;
		for (sx = 0; st; sx ++) {
			if (st & 0x01) {
				cons_printf(CONSOLE_PORTID, "%s", task_stat_str[sx]);
				if (st & 0xfe)
					cons_printf(CONSOLE_PORTID, "|");
				}
			st >>= 1;
			}
		cons_printf(CONSOLE_PORTID, "\n");
		}
	}

/*
 *  tcp_status -- TCP ξ֤ν
 */

static const char tcp_fsm_str[][sizeof("ESTABLISHED")] = {
	"CLOSED",		/* 			*/
	"LISTEN",		/* ưץ			*/
	"SYN_SENT",		/* ǽưץSYN Ѥ	*/
	"SYN_RECVD",		/* ưץSYN Ѥ	*/
	"ESTABLISHED",		/* ͥߴλ		*/
	"CLOSE_WAIT",		/* ꤫ FIN APP νλԤ	*/
	"FIN_WAIT_1",		/* APP λFIN ѤߡACK Ԥ	*/
	"CLOSING",		/* ƱFIN 򴹺ѤߡACK Ԥ	*/
	"LAST_ACK",		/* APP λACK Ԥ			*/
	"FIN_WAIT_2",		/* ꤫ FIN Ԥ			*/
	"TIME_WAIT",		/* ꤫ FIN ѤߡԤ	*/
	};

static void
tcp_status (UB *line)
{
	T_TCP_CCEP*	cep;
	T_TCP_CREP*	rep;
	int		len, cnt;

	cons_printf(CONSOLE_PORTID,
	             "TCP CEP Status\n"
	             "ID Snd-Q Rcv-Q Local Address         Foreign Address       State\n");
	for (cep = tcp_ccep; cep < &tcp_ccep[tmax_tcp_ccepid]; cep ++)
		if (cep->fsm_state == TCP_FSM_CLOSED) {
			cons_printf(CONSOLE_PORTID,
			             "%2d     0     0"
			             " -                    "
			             " -                    "
			             " CLOSED\n",
			             GET_TCP_CCEPID(cep));
			}
		else if (cep->fsm_state == TCP_FSM_LISTEN) {
			cons_printf(CONSOLE_PORTID, "%2d     0     0 ", GET_TCP_CCEPID(cep));
			len  = put_ipv4addr(CONSOLE_PORTID, cep->myaddr.ipaddr, 0);
			cons_putchar(CONSOLE_PORTID, ':');
			len += cons_putnumber(CONSOLE_PORTID, cep->myaddr.portno, 10, radhex, 0, FALSE, ' ');
			for (len = 20 - len; len -- > 0; )
				cons_putchar(CONSOLE_PORTID, ' ');
			cons_printf(CONSOLE_PORTID,
			             " -                    "
			             " LISTEN\n");
			}
		else {
			cons_printf(CONSOLE_PORTID, "%2d %5d %5d ",
			             GET_TCP_CCEPID(cep), cep->sbuf_count, cep->rbuf_count);
			len  = put_ipv4addr(CONSOLE_PORTID, cep->myaddr.ipaddr, 0);
			cons_putchar(CONSOLE_PORTID, ':');
			len += cons_putnumber(CONSOLE_PORTID, cep->myaddr.portno, 10, radhex, 0, FALSE, ' ');
			for (len = 21 - len; len -- > 0; )
				cons_putchar(CONSOLE_PORTID, ' ');
			len  = put_ipv4addr(CONSOLE_PORTID, cep->dstaddr.ipaddr, 0);
			cons_putchar(CONSOLE_PORTID, ':');
			len += cons_putnumber(CONSOLE_PORTID, cep->dstaddr.portno, 10, radhex, 0, FALSE, ' ');
			for (len = 20 - len; len -- > 0; )
				cons_putchar(CONSOLE_PORTID, ' ');
			if (cep->fsm_state == TCP_FSM_TIME_WAIT)
				cons_printf(CONSOLE_PORTID, " %s(%d)\n", tcp_fsm_str[cep->fsm_state],
				                             cep->timer[TCP_TIM_2MSL] / TCP_SLOW_HZ);
			else
				cons_printf(CONSOLE_PORTID, " %s\n", tcp_fsm_str[cep->fsm_state]);
			}
	
	cons_printf(CONSOLE_PORTID,
	             "TCP REP Status\n"
	             "ID Local Address         CEP\n");
	for (rep = tcp_crep; rep < &tcp_crep[tmax_tcp_crepid]; rep ++) {
		cons_printf(CONSOLE_PORTID, "%2d ", GET_TCP_CREPID(rep));
		len  = put_ipv4addr(CONSOLE_PORTID, rep->myaddr.ipaddr, 0);
		cons_putchar(CONSOLE_PORTID, ':');
		len += cons_putnumber(CONSOLE_PORTID, rep->myaddr.portno, 10, radhex, 0, FALSE, ' ');
		for (len = 21 - len; len -- > 0; )
			cons_putchar(CONSOLE_PORTID, ' ');
		cnt = 0;
		for (cep = tcp_ccep; cep < &tcp_ccep[tmax_tcp_ccepid]; cep ++) {
			if (cep->rep == rep) {
				if (cnt > 0)
					cons_printf(CONSOLE_PORTID, ",%d", GET_TCP_CCEPID(cep));
				else
					cons_printf(CONSOLE_PORTID, "%d", GET_TCP_CCEPID(cep));
				cnt ++;
				}
			}
		cons_putchar(CONSOLE_PORTID, '\n');
		}
	}

/*
 *  net_count_struct -- ͥåȥ׾
 */

static void
net_count_struct (char *name, T_NET_COUNT *item)
{
	cons_printf(CONSOLE_PORTID, "\n%s\n", name);
	cons_printf(CONSOLE_PORTID, "\tƥåȿ\t%lu\n", item->in_octets);
	cons_printf(CONSOLE_PORTID, "\tƥåȿ\t%lu\n", item->out_octets);
	cons_printf(CONSOLE_PORTID, "\tХåȿ\t%lu\n", item->in_packets);
	cons_printf(CONSOLE_PORTID, "\tХåȿ\t%lu\n", item->out_packets);
	cons_printf(CONSOLE_PORTID, "\t顼Хåȿ\t%lu\n", item->in_err_packets);
	cons_printf(CONSOLE_PORTID, "\t顼Хåȿ\t%lu\n", item->out_err_packets);
	}

/*
 *  net_count -- ͥåȥ׾
 */

static void
net_count (UB *line)
{
	int		ix, size;
	T_NET_BUF_ENTRY	*entry;
	SYSTIM		now;

	syscall(get_tim(&now));
	cons_printf(CONSOLE_PORTID, "ͥåȥ׾\tв[ms]\t%lu\n", now);

#ifdef SUPPORT_PPP

	net_count_struct("HDLC", &net_count_hdlc);
	cons_printf(CONSOLE_PORTID, "\nPPP\n");
	cons_printf(CONSOLE_PORTID, "\tƥåȿ\t%lu\n",		net_count_ppp.in_octets);
	cons_printf(CONSOLE_PORTID, "\tƥåȿ\t%lu\n",		net_count_ppp.out_octets);
	cons_printf(CONSOLE_PORTID, "\tХåȿ\t%lu\n",		net_count_ppp.in_packets);
	cons_printf(CONSOLE_PORTID, "\tХåȿ\t%lu\n",		net_count_ppp.out_packets);
	cons_printf(CONSOLE_PORTID, "\t顼Хåȿ\t%lu\n",	net_count_ppp.in_err_packets);
	cons_printf(CONSOLE_PORTID, "\t顼Хåȿ\t%lu\n",	net_count_ppp.out_err_packets);
	cons_printf(CONSOLE_PORTID, "\tnet_buf ƼԿ\t%lu\n",	net_count_ppp_no_bufs);

	cons_printf(CONSOLE_PORTID, "\nLCP\n");
	cons_printf(CONSOLE_PORTID, "\tƥåȿ\t%lu\n",		net_count_ppp_lcp_in_octets);
	cons_printf(CONSOLE_PORTID, "\tХåȿ\t%lu\n",		net_count_ppp_lcp_in_packets);

	cons_printf(CONSOLE_PORTID, "\nIPCP\n");
	cons_printf(CONSOLE_PORTID, "\tƥåȿ\t%lu\n",		net_count_ppp_ipcp_in_octets);
	cons_printf(CONSOLE_PORTID, "\tХåȿ\t%lu\n",		net_count_ppp_ipcp_in_packets);

	cons_printf(CONSOLE_PORTID, "\nPAP\n");
	cons_printf(CONSOLE_PORTID, "\tƥåȿ\t%lu\n",		net_count_ppp_upap_in_octets);
	cons_printf(CONSOLE_PORTID, "\tХåȿ\t%lu\n",		net_count_ppp_upap_in_packets);

#endif	/* of #ifdef SUPPORT_PPP */

#ifdef SUPPORT_ETHER

	net_count_struct("ͥå", &net_count_ether);
	net_count_struct("ARP", &net_count_arp);

#endif	/* of #ifdef SUPPORT_ETHER */

	net_count_struct("IP", &net_count_ip4);
	net_count_struct("ICMP", &net_count_icmp4);
	net_count_struct("UDP", &net_count_udp);

#ifdef SUPPORT_ETHER

	net_count_struct("NIC", &net_count_ether_nic);
	cons_printf(CONSOLE_PORTID, "\tꥸ\t%lu\n",			net_count_ether_nic_cols);
	cons_printf(CONSOLE_PORTID, "\tꥻåȿ\t%lu\n",			net_count_ether_nic_resets);
	cons_printf(CONSOLE_PORTID, "\tnet_buf ƼԿ\t%lu\n",		net_count_ether_nic_no_bufs);
	cons_printf(CONSOLE_PORTID, "\tޥեֵѾ¥С\t%lu\n",	net_count_ether_nic_rxb_qovrs);
	cons_printf(CONSOLE_PORTID, "\tޥեֵѾ¥С\t%lu\n",	net_count_ether_nic_txb_qovrs);
	cons_printf(CONSOLE_PORTID, "\tॢȿ	\t%lu\n",		net_count_ether_nic_timeouts);

#endif	/* of #ifdef SUPPORT_ETHER */

	cons_printf(CONSOLE_PORTID, "\nTCP\n");
	cons_printf(CONSOLE_PORTID, "\tƥåȿ\t%lu\n",		net_count_tcp[NC_TCP_RECV_OCTETS]);
	cons_printf(CONSOLE_PORTID, "\tǡƥåȿ\t%lu\n",	net_count_tcp[NC_TCP_RECV_DATA_OCTETS]);
	cons_printf(CONSOLE_PORTID, "\tȿ\t%lu\n",		net_count_tcp[NC_TCP_RECV_SEGS]);
	cons_printf(CONSOLE_PORTID, "\tǡȿ\t%lu\n",	net_count_tcp[NC_TCP_RECV_DATA_SEGS]);
	cons_printf(CONSOLE_PORTID, "\t۵ޥȿ\t%lu\n",	net_count_tcp[NC_TCP_RECV_URG_SEGS]);
	cons_printf(CONSOLE_PORTID, "\tإå\t%lu\n",		net_count_tcp[NC_TCP_RECV_BAD_HEADERS]);
	cons_printf(CONSOLE_PORTID, "\tå\t%lu\n",	net_count_tcp[NC_TCP_RECV_BAD_CKSUMS]);
	cons_printf(CONSOLE_PORTID, "\tACK \t%lu\n",		net_count_tcp[NC_TCP_RECV_ACKS]);
	cons_printf(CONSOLE_PORTID, "\t¿ ACK \t%lu\n",		net_count_tcp[NC_TCP_RECV_DUP_ACKS]);
	cons_printf(CONSOLE_PORTID, "\tRST \t%lu\n",		net_count_tcp[NC_TCP_RECV_RSTS]);
	cons_printf(CONSOLE_PORTID, "\t¿ſ\t%lu\n",		net_count_tcp[NC_TCP_RECV_DUP_SEGS]);
	cons_printf(CONSOLE_PORTID, "\t˴\t%lu\n",		net_count_tcp[NC_TCP_RECV_DROP_SEGS]);
	cons_printf(CONSOLE_PORTID, "\tǡƥåȿ\t%lu\n",	net_count_tcp[NC_TCP_SEND_DATA_OCTETS]);
	cons_printf(CONSOLE_PORTID, "\t楻ȿ\t%lu\n",	net_count_tcp[NC_TCP_SEND_CNTL_SEGS]);
	cons_printf(CONSOLE_PORTID, "\tȿ\t%lu\n",		net_count_tcp[NC_TCP_SEND_SEGS]);
	cons_printf(CONSOLE_PORTID, "\tȿ\t%lu\n",		net_count_tcp[NC_TCP_SEND_REXMIT_SEGS]);
	cons_printf(CONSOLE_PORTID, "\tǡȿ\t%lu\n",	net_count_tcp[NC_TCP_SEND_DATA_SEGS]);
	cons_printf(CONSOLE_PORTID, "\t۵ޥȿ\t%lu\n",	net_count_tcp[NC_TCP_SEND_URG_SEGS]);
	cons_printf(CONSOLE_PORTID, "\tACK \t%lu\n",		net_count_tcp[NC_TCP_SEND_ACKS]);
	cons_printf(CONSOLE_PORTID, "\tRST \t%lu\n",		net_count_tcp[NC_TCP_SEND_RSTS]);
	cons_printf(CONSOLE_PORTID, "\tRTT \t%lu\n",		net_count_tcp[NC_TCP_RTT_UPDATES]);
	cons_printf(CONSOLE_PORTID, "\tưץ\t%lu\n",		net_count_tcp[NC_TCP_ACCEPTS]);
	cons_printf(CONSOLE_PORTID, "\tǽưץ\t%lu\n",		net_count_tcp[NC_TCP_CONNECTS]);

	cons_printf(CONSOLE_PORTID, "\nͥåȥХåե\n\t\t׵\t\tƥ顼\n");
	size = MIN_NET_BUF_SIZE;
	for (ix = get_num_net_buf_entry(); ix -- > 0; ) {
		entry = get_net_buf_entry(ix);
		cons_printf(CONSOLE_PORTID, "\t%lu\t%lu\t%lu\t%lu\n",
		                            entry->size,
		                            entry->requests,
		                            entry->allocs,
		                            entry->errors);
		size <<= 1;
		}
	}

/*
 *  ifconfig -- ͥåȥ󥿥եι
 */

static void
ifconfig (UB *line)
{
#ifdef SUPPORT_ETHER

	if (*(line = skip_blanks(line))) {
		UW	addr, mask;

		get_ipv4addr(&mask, skip_blanks(get_ipv4addr(&addr, line)));
		in4_add_ifaddr(addr, mask);
		}

#endif	/* of #ifdef SUPPORT_ETHER */

	cons_printf(CONSOLE_PORTID,
	            "Network Interface Configurations\n");

#ifdef SUPPORT_ETHER

	cons_printf(CONSOLE_PORTID,
	            "ether: %M\n",
	            IF_ETHER_NIC_GET_SOFTC()->ifaddr.lladdr);

#endif	/* of #ifdef SUPPORT_ETHER */

	cons_printf(CONSOLE_PORTID,
	            "inet:  %I, mask: %I, boadcast: %I\n",
	            IF_IPV4_ADDR_LOCAL,
	            IF_IPV4_ADDR_LOCAL_MASK,
	            IF_IPV4_ADDR_LOCAL_BC);
	}

#ifdef SUPPORT_ETHER

/*
 *  ifa_status -- ARP å
 */

static void
ifa_status (UB *line)
{
	T_ARP_ENTRY	*cache;
	int		ix;

	cons_printf(CONSOLE_PORTID,
	             "ARP Cache\n"
	             "IX Expire IP Address      MAC Address\n");

	/* expire ñ̤ [ms]*/
	cache = get_arp_cache();
	for (ix = 0; ix < NUM_ARP_ENTRY; ix ++) {
		if (cache[ix].expire != 0)
			cons_printf(CONSOLE_PORTID, "%2d %6d %15I %M\n",
			            ix, cache[ix].expire / NET_TIMER_HZ,
			                cache[ix].ip_addr, cache[ix].mac_addr);
		}
	}

/*
 *  routing_table_status -- ϩɽν
 */

static void
routing_table_status (UB *line)
{
	int	ix;

	if ('0' <= *(line = skip_blanks(line)) && *line <= '9') {
		UW	target, mask, gateway;

		ix = atoi(line);
		while ('0' <= *line && *line <= '9')
			line ++;
		line = get_ipv4addr(&target,  skip_blanks(line));
		line = get_ipv4addr(&mask,    skip_blanks(line));
		       get_ipv4addr(&gateway, skip_blanks(line));
		in4_add_route(ix, target, mask, gateway);
		}

	cons_printf(CONSOLE_PORTID,
	             "Routing Table Status\n"
	             "IX Target          Mask            Gateway\n");

	for (ix = 0; ix < NUM_ROUTE_ENTRY; ix ++) {
		cons_printf(CONSOLE_PORTID, "%2d %15I %15I %I\n",
		            ix,
		            routing_tbl[ix].target,
		            routing_tbl[ix].mask,
		            routing_tbl[ix].gateway);
		            
		}
	}

#endif	/* of #ifdef SUPPORT_ETHER */

/*
 *  network_status -- ͥåȥξ֤ν
 */

static void
network_status (UB *line)
{
	switch (*line) {

	case 't':		/* TCP status */
		tcp_status(line + 1);
		break;

	case 'c':		/* ͥåȥ׾ */
		net_count(line + 1);
		break;

#ifdef SUPPORT_ETHER

	case 'a':		/* IF ɥ쥹 */
		ifa_status(line + 1);
		break;

	case 'r':		/* 롼ƥ󥰾 */
		routing_table_status(line + 1);
		break;

#endif	/* of #ifdef SUPPORT_ETHER */

	default:
		syslog(LOG_NOTICE, "no such command: '%c%c'", *(line - 1), *line);
		break;
		}
	}

/*
 *  ǥХåޥɲ
 */

static void
dbg_parse (UB *line)
{
	UW	addr;
	ER	error;
	int	cepid;
	int	tmo;

	switch (*line) {

	case 'i':		/* initiate */

		if (*(line + 1) == 'f')
			ifconfig(line + 2);

#ifdef SUPPORT_PPP

#ifdef PPP_CFG_MODEM

		else if (lcp_fsm.state == PPP_FSM_STOPPED)
			dial();

#else	/* of #ifdef PPP_CFG_MODEM */

		else if (lcp_fsm.state == PPP_FSM_STOPPED)
			lcp_open(PPP_OPEN_ACTIVE);

#endif	/* of #ifdef PPP_CFG_MODEM */

#endif	/* of #ifdef SUPPORT_PPP */

		break;

#ifdef SUPPORT_PPP

	case 'd':		/* disconnect */
		if (lcp_fsm.state != PPP_FSM_STOPPED)
			lcp_close();
		break;

#endif	/* of #ifdef SUPPORT_PPP */

	case 'p':		/* ping or task status */

		if (*(line + 1) == 's')
			task_status(skip_blanks(line + 2));
		else {
			tmo = atoi(skip_blanks(get_ipv4addr(&addr, skip_blanks(line + 1))));
			if (tmo <= 0)
				tmo = 10;
			ping4(addr, tmo, 64);
			}
		break;

	case 'e':	/* echo client */
		if (*(line + 1) == 'u') {

			/* UDP echo */
			line += 2;
			if ((error = psnd_dtq(DTQ_UDP_ECHO_CLI, (VP_INT)line)) != E_OK)
				syslog(LOG_NOTICE, "[UDP ECHO CON] error: %s",
				       itron_strerror(error));
			}

		else if (*(line + 1) == 't') {

			/* TCP echo */
			line += 2;
			if ((error = psnd_dtq(DTQ_TCP_ECHO_CLI, (VP_INT)line)) != E_OK)
				syslog(LOG_NOTICE, "[TCP ECHO CON] error: %s",
				       itron_strerror(error));
			}

		else if (*(line + 1) == 's')
			tcp_echo_cli_valid = FALSE;
		break;

	case 'b':	/* discard client */
		if (*(line + 1) == 'u') {

			/* UDP discard */
			line += 2;
			if ((error = psnd_dtq(DTQ_UDP_DISCARD_CLI, (VP_INT)line)) != E_OK)
				syslog(LOG_NOTICE, "[UDP DISCARD CON] error: %s",
				       itron_strerror(error));
			}

		else if (*(line + 1) == 't') {

			/* TCP discard */
			line += 2;
			if ((error = psnd_dtq(DTQ_TCP_DISCARD_CLI, (VP_INT)line)) != E_OK)
				syslog(LOG_NOTICE, "[TCP DISCARD CON] error: %s",
				       itron_strerror(error));
			}

		else if (*(line + 1) == 's')
			tcp_discard_cli_valid = FALSE;
		break;

	case 'c':		/* TCP cancel CEP */
		if (*(line + 1) == 'u') {

			/* cancel UDP */
			cepid = atoi(line = skip_blanks(line + 2));
			while ('0' <= *line && *line <= '9')
				line ++;
			if ((error = udp_can_cep(cepid, atoi(skip_blanks(line)))) != E_OK)
				syslog(LOG_NOTICE, "[UDP CAN CEP] error: %s",
				       itron_strerror(error));
			}

		else if (*(line + 1) == 't') {

			/* cancel TCP */
			cepid = atoi(line = skip_blanks(line + 2));
			while ('0' <= *line && *line <= '9')
				line ++;
			if ((error = tcp_can_cep(cepid, atoi(skip_blanks(line)))) != E_OK)
				syslog(LOG_NOTICE, "[TCP CAN CEP] error: %s",
				       itron_strerror(error));
			}
		break;

	case 'n':		/* network status */
		network_status(line + 1);
		break;

	case 'r':		/* release wait task */
		syscall(rel_wai(atoi(skip_blanks(line + 1))));
		break;
	case 'w':		/* wake up task */
		syscall(wup_tsk(atoi(skip_blanks(line + 1))));
		break;

	default:
		syslog(LOG_NOTICE, "no such command: '%c'", *line);
		break;
		}
	}

/*
 *  ǥХå󥽡륿
 */

void
dbg_con_task (VP_INT exinf)
{
	static UB line[DBG_LINE_SIZE + 1];

	int	len;
	ID	tskid;

	get_tid(&tskid);
	syslog(LOG_NOTICE, "[CONSOLE:%d] started.", tskid);
	syscall(serial_ctl_por(CONSOLE_PORTID,
	                       IOCTL_ECHO  | IOCTL_CRLF  |
	                       IOCTL_FCSND | IOCTL_FCANY | IOCTL_FCRCV));
	while (TRUE) {
		len = cons_getline(line, DBG_LINE_SIZE);
		dbg_parse(line);
		}
	}
