/*
 *  TOPPERS/JSP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Just Standard Profile Kernel
 * 
 *  Copyright (C) 2000-2003 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 *  Copyright (C) 2001-2003 by Dep. of Computer Science and Engineering
 *                   Tomakomai National College of Technology, JAPAN
 * 
 *  嵭Ԥϡʲ (1)(4) ξ狼Free Software Foundation 
 *  ˤäƸɽƤ GNU General Public License  Version 2 ˵
 *  ҤƤ˸¤ꡤܥեȥܥեȥ
 *  ѤΤޤࡥʲƱˤѡʣѡۡʰʲ
 *  ѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơŬѲǽ
 *  ޤơʤݾڤԤʤޤܥեȥѤˤľ
 *  ŪޤϴŪʤ»˴ؤƤ⡤Ǥʤ
 * 
 *  @(#) $Id: netapp_subr.c,v 1.1.1.1 2004/04/21 00:45:44 abe Exp abe $
 */

/* 
 *  ͥåȥѥץॵݡȥ롼
 */

#include <s_services.h>
#include <t_services.h>

#include <stdarg.h>

#include <tinet_defs.h>
#include <tinet_config.h>

#include <net/if.h>
#include <net/if_ppp.h>
#include <net/if_loop.h>
#include <net/ethernet.h>
#include <net/net_buf.h>

#include <netapp/netapp.h>

/*
 *  cons_putchar -- ꥢݡȤؤʸ
 */

void
cons_putchar (ID portid, char ch)
{
	serial_wri_dat(portid, &ch, 1);
	}

/*
 *  ꥢݡȤؤνʸϥ饤֥
 */

/*
 *  ѴΤѴɽ
 */

const char radhex[] = "0123456789abcdef";
const char radHEX[] = "0123456789ABCDEF";

/*
 *  cons_putnumber -- cons_printf οѴ
 */

int
cons_putnumber(ID portid, ULONGEST val, int radix,
         const char *radchar, int width, BOOL minus, char padchar)
{
	char	digits[24];
	int	ix, pad, pchars;

	ix = 0;
	do {
		digits[ix ++] = radchar[val % radix];
		val /= radix;
		} while (val != 0);

	if (minus)
		digits[ix ++] = '-';

	if (width > ix)
		pchars = width;
	else
		pchars = ix;

	for (pad = ix; pad < width; pad ++)
		cons_putchar(portid, padchar);

	while (ix -- > 0)
		cons_putchar(portid, digits[ix]);

	return pchars;
	}

/*
 *  put_ipv4addr -- IPv4 ɥ쥹
 */

int
put_ipv4addr (ID portid, UW addr, int width)
{
	int len = 3;	/* 3  '.' ʸ */

	len += cons_putnumber(portid, (addr >> 24) & 0xff, 10, radhex, 0, FALSE, ' '); 
	cons_putchar(portid, '.');
	len += cons_putnumber(portid, (addr >> 16) & 0xff, 10, radhex, 0, FALSE, ' '); 
	cons_putchar(portid, '.');
	len += cons_putnumber(portid, (addr >>  8) & 0xff, 10, radhex, 0, FALSE, ' '); 
	cons_putchar(portid, '.');
	len += cons_putnumber(portid,  addr        & 0xff, 10, radhex, 0, FALSE, ' '); 

	for ( ; len < width; len ++)
		cons_putchar(portid, ' ');

	return len;
	}

/*
 *  macaddr -- MAC ɥ쥹
 */

static int
macaddr (ID portid, char *mac, int width)
{
	int oct, len;

	for (oct = 5; oct -- > 0; ) {
		cons_putnumber(portid, *mac ++, 16, radhex, 2, FALSE, '0'); 
		cons_putchar(portid, ':');
		}
	cons_putnumber(portid, *mac, 16, radhex, 2, FALSE, '0'); 

	for (len = 17; len < width; len ++)
		cons_putchar(portid, ' ');

	return len;
	}

/*
 *  ФΥޥ
 */

#ifdef LONGLONG_TYPE

#ifdef LONG_TYPE

#define GET_ARG(ap,lf)	((lf > 1) ? va_arg(ap, LONGLONG_TYPE)	\
			 (lf      ? va_arg(ap, LONG_TYPE)	\
			          : va_arg(ap, int)))

#else	/* of #ifdef LONG_TYPE */

#define GET_ARG(ap,lf)	((lf > 1) ? va_arg(ap, LONGLONG_TYPE)	\
			          : va_arg(ap, int))

#endif	/* of #ifdef LONG_TYPE */

#else	/* of #ifdef LONGLONG_TYPE */

#ifdef LONG_TYPE

#define GET_ARG(ap,lf)	 (lf      ? va_arg(ap, LONG_TYPE)	\
			          : va_arg(ap, int))

#else	/* of #ifdef LONG_TYPE */

#define GET_ARG(ap,lf)	(va_arg(ap, int))

#endif	/* of #ifdef LONG_TYPE */

#endif	/* of #ifdef LONGLONG_TYPE */

/*
 *  cons_printf -- ꥢݡȤؤνʸ
 */

void
cons_printf (ID portid, const char *fmt, ...)
{
	va_list	ap;
	LONGEST	val;
	char	padchar, *str;
	int	ch, width, longflag;

	va_start(ap, fmt);
	while ((ch = *fmt ++) != '\0') {
		if (ch != '%') {		/* 񼰻ʳ */
			cons_putchar(portid, (char)ch);
			continue;
			}

		width = longflag = 0;
		padchar = ' ';
		if ((ch = *fmt ++) == '0') {	/* ̷ 0 */
			padchar = '0';
			ch = *fmt ++;
			}

		while ('0' <= ch && ch <= '9') {	/*  */
			width = width * 10 + ch - '0';
			ch = *fmt ++;
			}

		while (ch == 'l') {		/* long (long) λ */
			longflag ++;
			ch = *fmt ++;
			}

		switch (ch) {
		case 'd':
			val = GET_ARG(ap, longflag);
			if (val >= 0)
				cons_putnumber(portid,  val, 10, radhex, width, FALSE, padchar);
			else
				cons_putnumber(portid, -val, 10, radhex, width, TRUE, padchar);
			break;

		case 'u':
			val = GET_ARG(ap, longflag);
			cons_putnumber(portid, val, 10, radhex, width, FALSE, padchar);
			break;

		case 'x':
			val = GET_ARG(ap, longflag);
			cons_putnumber(portid, val, 16, radhex, width, FALSE, padchar);
			break;

		case 'X':
			val = GET_ARG(ap, longflag);
			cons_putnumber(portid, val, 16, radHEX, width, FALSE, padchar);
			break;

		case 'c':
			ch = va_arg(ap, char);
			cons_putchar(portid, (char)ch);
			break;

		case 's':
			str = va_arg(ap, char*);
			while ((ch = *str ++) != '\0')
				cons_putchar(portid, (char)ch);
			break;

		case 'I':
			val = GET_ARG(ap, longflag);
			put_ipv4addr(portid, val, width);
			break;

		case 'M':
			str = va_arg(ap, char*);
			macaddr(portid, str, width);
			break;

		case '%':
			cons_putchar(portid, '%');
			break;

		case '0':
			fmt --;
			break;

		default:
			break;
			}

		}
	va_end(ap);
	}

/*
 *  skip_blanks --  TAB 򥹥åפ롣
 */

UB *
skip_blanks (UB *line)
{
	while (*line == ' ' || *line == '\t')
		line ++;
	return line;
	}

/*
 *  get_ipv4addr -- ʸ IPv4 ɥ쥹 UW ͤѴ롣
 */

UB *
get_ipv4addr (UW *addr, UB *line)
{
	int oct;

	*addr = 0;
	while ('0' <= *line && *line <= '9') {
		oct = 0;
		while ('0' <= *line && *line <= '9')
			oct = oct * 10 + (*line ++) - '0';
		*addr = (*addr << 8) | (oct & 0xff);
		if (*line == '.')
			line ++;
		}
	return line;
	}

/*
 *  ǥХå
 */

int
cons_getline (UB *line, int size)
{
	UB	ch;
	int	len;

	len = size;
	while (size > 0) {
		if (serial_rea_dat(CONSOLE_PORTID, &ch, sizeof(UB)) > 0) {
			if (ch == '\r') {
				cons_putchar(CONSOLE_PORTID, '\n');
				break;
				}
			else if (ch == '\b') {
				if (size < len) {
					line --;
					size ++;
					}
				}
			else {
				*line ++ = ch;
				size --;
				}
			}
		}
	*line = '\0';
	return len - size;
	}

/*
 *  get_int -- Ѵ
 */

char *
get_int (int *val, UB *line)
{
	int sign = 1;

	line = skip_blanks(line);
	if (*line == '-') {
		sign = -1;
		line ++;
		}
	else if (*line == '+')
		line ++;

	line = skip_blanks(line);
	*val = 0;
	while ('0' <= *line && *line <= '9') {
		*val = *val * 10 + *line - '0';
		line ++;
		}

	*val = *val * sign;
	return line;
	}

/*
 *  get_xuint -- ʤ (16) Ѵ
 */

char *
get_xuint (unsigned int *val, UB *line)
{
	line = skip_blanks(line);
	*val = 0;
	while (1) {
		if      ('0' <= *line && *line <= '9')
			*val = (*val << 4) + *line - '0';
		else if ('a' <= *line && *line <= 'f')
			*val = (*val << 4) + *line - 'a' + 10;
		else if ('A' <= *line && *line <= 'F')
			*val = (*val << 4) + *line - 'A' + 10;
		else
			break;
		line ++;
		}
	return line;
	}
