/*
 *  TOPPERS/JSP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Just Standard Profile Kernel
 * 
 *  Copyright (C) 2000-2003 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 *  Copyright (C) 2001-2003 by Dep. of Computer Science and Engineering
 *                   Tomakomai National College of Technology, JAPAN
 * 
 *  嵭Ԥϡʲ (1)(4) ξ狼Free Software Foundation 
 *  ˤäƸɽƤ GNU General Public License  Version 2 ˵
 *  ҤƤ˸¤ꡤܥեȥܥեȥ
 *  ѤΤޤࡥʲƱˤѡʣѡۡʰʲ
 *  ѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơŬѲǽ
 *  ޤơʤݾڤԤʤޤܥեȥѤˤľ
 *  ŪޤϴŪʤ»˴ؤƤ⡤Ǥʤ
 * 
 *  @(#) $Id: ping.c,v 1.1.1.1 2004/04/21 00:45:44 abe Exp abe $
 */

/* 
 *  ping -- ICMP ECHO å롣
 */

#include <t_services.h>

#include <tinet_defs.h>
#include <tinet_config.h>

#include <net/if.h>
#include <net/if_ppp.h>
#include <net/if_loop.h>
#include <net/ethernet.h>
#include <net/ppp_var.h>
#include <net/ppp_ipcp.h>
#include <net/net.h>
#include <net/net_timer.h>
#include <net/net_buf.h>

#include <netinet/in.h>
#include <netinet/in_var.h>
#include <netinet/ip.h>
#include <netinet/ip_var.h>
#include <netinet/ip_icmp.h>

/*
 *  ѿ
 */

static UH icmp_id = 0;
static UH curr_icmp_id;
static UH curr_icmp_len;
static SYSTIM icmp_start_time;

/*
 *  icmp_reply_timeout -- ICMP REPLY ॢȽ
 */

static void
icmp_reply_timeout (VP arg)
{
	syslog(LOG_NOTICE, "[PING] request timeout.");
	}

/*
 *  rec_icmp_reply -- ICMP REPLY å롣
 */

static void
rec_icmp_reply (T_NET_BUF *input)
{
	SYSTIM time;

	syscall(get_tim(&time));

	/* ICMP REPLY åؿȥॢȽؿ롣*/
	set_icmp_reply(NULL);
	untimeout(icmp_reply_timeout, NULL);

	syslog(LOG_NOTICE, "[PING] reply, %d [ms].",
	                   (time - icmp_start_time) * 1000 / SYSTIM_HZ);
	}

/*
 *  ping4 -- ICMP ECHO å롣
 */

void
ping4 (UW addr, int tmo, int len)
{
	T_ICMP4_HDR	*icmp4h;
	T_NET_BUF	*output;
	UB		*sdu;
	int		ix;

	/* Ѥ IP ǡ롣*/
	if (in_get_datagram(&output, ICMP4_HDR_SIZE + len,
	                    addr, IF_IPV4_ADDR_LOCAL, IPPROTO_ICMP, TMO_FEVR) != E_OK)
		return;

	/* ICMP إåꤹ롣*/
	icmp4h			= GET_ICMP4_HDR(output);
	icmp4h->type		= ICMP4_ECHO_REQUEST;
	icmp4h->code		= 0;
	icmp4h->data.id_seq.id	= htons(icmp_id);
	icmp4h->data.id_seq.seq	= 0;

	/* ǡꤹ롣*/
	sdu = GET_ICMP4_SDU(output) + len;
	for (ix = len; ix -- > 0; )
		*-- sdu = ('0' + icmp_id + ix) & 0xff;

	/* å׻롣*/
	icmp4h->sum = 0;
	icmp4h->sum = in_cksum(icmp4h, ICMP4_HDR_SIZE + len);

	/* åѤѿꤹ롣*/
	curr_icmp_id  = icmp_id ++;
	curr_icmp_len = len;

	/* ICMP REPLY åؿϿ롣*/
	set_icmp_reply(rec_icmp_reply);

	/* 塢ߤλ֤򵭲ॢȤꤹ롣*/
	ip_output(output, TMO_FEVR);

	syscall(get_tim(&icmp_start_time));
	timeout(icmp_reply_timeout, NULL, tmo * NET_TIMER_HZ);

	}
