/*
 *  TOPPERS/JSP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Just Standard Profile Kernel
 * 
 *  Copyright (C) 2000-2003 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 *  Copyright (C) 2001-2003 by Dep. of Computer Science and Engineering
 *                   Tomakomai National College of Technology, JAPAN
 *
 *  嵭Ԥϡʲ (1)(4) ξ狼Free Software Foundation 
 *  ˤäƸɽƤ GNU General Public License  Version 2 ˵
 *  ҤƤ˸¤ꡤܥեȥܥեȥ
 *  ѤΤޤࡥʲƱˤѡʣѡۡʰʲ
 *  ѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơŬѲǽ
 *  ޤơʤݾڤԤʤޤܥեȥѤˤľ
 *  ŪޤϴŪʤ»˴ؤƤ⡤Ǥʤ
 * 
 *  @(#) $Id: tcp_discard_cli.c,v 1.1.1.1 2004/04/21 00:45:44 abe Exp abe $
 */

/* 
 *  TCP DISCARD 饤
 */

#include <t_services.h>
#include "kernel_id.h"
#include "tinet_id.h"

#include <stdlib.h>

#include <net/net_timer.h>

#include <netinet/in.h>
#include <netinet/in_itron.h>

#include <netapp/netapp.h>
#include <netapp/echo.h>

/*
 *  ؿ
 */

#define ip2str	_tinet_ip2str

extern UB *ip2str (UB *buf, UW ipaddr);
extern const char *itron_strerror (ER ercd);

/*
 *  Хåե
 */

#define NUM_ECHO		20
#define NUM_REP_PAT		40
#define PAT_BEGIN		' '
#define PAT_END			'~'
#define SND_BUF_SIZE		((PAT_END - PAT_BEGIN + 1) * NUM_REP_PAT)

/*
 *  ѿ
 */

BOOL tcp_discard_cli_valid;

#ifdef USE_TCP_NON_BLOCKING

/*
 *  ѿ
 */

static T_IPV4EP		nblk_dst;
static T_IPV4EP		nblk_src;
static ER_UINT		nblk_error;

/*
 *  Υ֥å󥰥ΥХåؿ
 */

ER
callback_nblk_tcp_discard_cli (ID cepid, FN fncd, VP p_parblk)
{
	static UB addr[sizeof("123.123.123.123")];

	ER	error = E_OK;

	nblk_error = (ER)p_parblk;

	switch (fncd) {

	case TFN_TCP_CON_CEP:
		ip2str(addr, nblk_dst.ipaddr);
		/*syslog(LOG_NOTICE, "[TCP DISCARD CLI (NBLK) CBN] connect addr: %s:%d, error: %s",
		                   addr, nblk_dst.portno, itron_strerror(nblk_error));*/
		syscall(sig_sem(SEM_TCP_DISCARD_CLI_NBLK_READY));
		break;

	case TFN_TCP_CLS_CEP:
		if (nblk_error < 0)
			syslog(LOG_NOTICE, "[TCP DISCARD CLI (NBLK) CBN] close error: %s", itron_strerror(nblk_error));
		syscall(sig_sem(SEM_TCP_DISCARD_CLI_NBLK_READY));
		break;

	case TFN_TCP_ACP_CEP:
	case TFN_TCP_SND_DAT:
	case TFN_TCP_GET_BUF:
	case TFN_TCP_SND_OOB:
	default:
		error = E_PAR;
		break;
		}
	return error;
	}

/*
 *  send_tcp_discard -- DISCARD/TCP Ф˥å롣
 */

static void
send_tcp_discard (ID cepid, UW ipaddr, UH portno)
{
	static UB addr[sizeof("123.123.123.123")];
	static UB smsg[SND_BUF_SIZE];

	int	pat, slen, soff, echo, rep, scount, total;
	UB	*p;
	ER	error;
	SYSTIM	time;

	ip2str(addr, ipaddr);
	/*syslog(LOG_NOTICE, "[TCP DISCARD CLI (NBLK)] start, addr: %s:%d", addr, portno);*/

	nblk_src.ipaddr = IPV4_ADDRANY;
	nblk_src.portno = TCP_PORTANY;
	nblk_dst.ipaddr = ipaddr;
	nblk_dst.portno = portno;

	p = smsg;
	for (rep = NUM_REP_PAT; rep -- > 0; )
		for (pat = PAT_BEGIN; pat <= PAT_END; pat ++)
			*p ++ = pat;

	if ((error = tcp_con_cep(cepid, &nblk_src, &nblk_dst, TMO_NBLK)) != E_WBLK) {
		syslog(LOG_NOTICE, "[TCP DISCARD CLI (NBLK)] connect error: %s", itron_strerror(error));
		return;
		}

	/* ³λޤԤġ*/
	syscall(wai_sem(SEM_TCP_DISCARD_CLI_NBLK_READY));

	if (nblk_error != E_OK)
		syslog(LOG_NOTICE, "[TCP DISCARD CLI (NBLK)] connect error: %s", itron_strerror(nblk_error));
	else {
		get_tim(&time);
		syslog(LOG_NOTICE, "[TCP DISCARD CLI (NBLK)] connecting: %5d.%03d",
		                   time / SYSTIM_HZ, time % SYSTIM_HZ);

		scount = total = 0;
		for (echo = NUM_ECHO; echo -- > 0; ) {
			soff = 0;
			while (soff < SND_BUF_SIZE) {
				if ((slen = tcp_snd_dat(cepid, smsg + soff, sizeof(smsg) - soff, TMO_FEVR)) < 0) {
					syslog(LOG_NOTICE, "[TCP DISCARD CLI (NBLK)] send error: %s", itron_strerror(slen));
					goto cls_ret;
					}
				soff  += slen;
				total += slen;
				/*syslog(LOG_NOTICE, "[TCP DISCARD CLI (NBLK)] send cnt: %2d, len: %4d, off: %4d", ++ scount, slen, soff);*/
				dly_tsk(2500 + rand() % 1000);
				}
			}

	cls_ret:
		syslog(LOG_NOTICE, "[TCP DISCARD CLI (NBLK)] send total len: %d", total);

		if ((error = tcp_sht_cep(cepid)) < 0)
			syslog(LOG_NOTICE, "[TCP DISCARD CLI (NBLK)] shutdown error: %s", itron_strerror(error));

		if ((error = tcp_cls_cep(cepid, TMO_NBLK)) != E_WBLK)
			syslog(LOG_NOTICE, "[TCP DISCARD CLI (NBLK)] close error: %s", itron_strerror(error));

		/* λޤԤġ*/
		syscall(wai_sem(SEM_TCP_DISCARD_CLI_NBLK_READY));

		/*syslog(LOG_NOTICE, "[TCP DISCARD CLI (NBLK)] finished.");*/
		}
	}

#else	/* of #ifdef USE_TCP_NON_BLOCKING */

/*
 *  send_tcp_discard -- DISCARD/TCP Ф˥å롣
 */

static void
send_tcp_discard (ID cepid, UW ipaddr, UH portno)
{
	static UB smsg[SND_BUF_SIZE];

	T_IPV4EP	dst, src;
	int		pat, slen, soff, echo, rep, scount, total;
	UB		*p;
	ER		error;
	SYSTIM		time;

	src.ipaddr = IPV4_ADDRANY;
	src.portno = TCP_PORTANY;
	dst.ipaddr = ipaddr;
	dst.portno = portno;

	p = smsg;
	for (rep = NUM_REP_PAT; rep -- > 0; )
		for (pat = PAT_BEGIN; pat <= PAT_END; pat ++)
			*p ++ = pat;

	if ((error = tcp_con_cep(cepid, &src, &dst, 60 * 1000)) != E_OK) {
		syslog(LOG_NOTICE, "[TCP DISCARD CLI] connect error: %s", itron_strerror(error));
		return;
		}

	get_tim(&time);
	syslog(LOG_NOTICE, "[TCP DISCARD CLI] connecting: %5d.%03d",
	                   time / SYSTIM_HZ, time % SYSTIM_HZ);

	scount = total = 0;
	for (echo = NUM_ECHO; echo -- > 0; ) {
		soff = 0;
		while (soff < SND_BUF_SIZE) {
			if ((slen = tcp_snd_dat(cepid, smsg + soff, sizeof(smsg) - soff, TMO_FEVR)) < 0) {
				syslog(LOG_NOTICE, "[TCP DISCARD CLI] send error: %s", itron_strerror(slen));
				goto cls_ret;
				}
			soff  += slen;
			total += slen;
			/*syslog(LOG_NOTICE, "[TCP DISCARD CLI] send count: %3d, len: %4d, offset: %4d", ++ scount, slen, soff);*/
			dly_tsk(2500 + rand() % 1000);
			}
		}

cls_ret:
	syslog(LOG_NOTICE, "[TCP DISCARD CLI] send total len: %d", total);

	if ((error = tcp_sht_cep(cepid)) < 0)
		syslog(LOG_NOTICE, "[TCP DISCARD CLI] shutdown error: %s", itron_strerror(error));

	if ((error = tcp_cls_cep(cepid, TMO_FEVR)) < 0)
		syslog(LOG_NOTICE, "[TCP DISCARD CLI] close error: %s", itron_strerror(error));

	syslog(LOG_NOTICE, "[TCP DISCARD CLI] finished.");
	}

#endif	/* of #ifdef USE_TCP_NON_BLOCKING */

/*
 *  TCP DISCARD 饤
 */

void
tcp_discard_cli_task (VP_INT exinf)
{
	UB	*line;
	UW	addr, count;
	int	no;
	ID	tskid;
	UH	portno;

	get_tid(&tskid);
	syslog(LOG_NOTICE, "[TCP DISCARD CLI:%d,%d] started.", tskid, (ID)exinf);
	while (TRUE) {
		if (rcv_dtq(DTQ_TCP_DISCARD_CLI, (VP_INT*)&line) == E_OK) {
			line = skip_blanks(get_ipv4addr(&addr, skip_blanks(line)));
			if ('0' < *line && *line < '9') {
				line = get_int(&no, line);
				portno = (UH)no;
				}
			else {
				line ++;
				portno = 9;
				}
			line = skip_blanks(line);
			if (('0' < *line && *line < '9'))
				line = get_int(&no, line);
			else
				no = 1;
			tcp_discard_cli_valid = TRUE;
			for (count = no; count -- > 0; ) {
				if (!tcp_discard_cli_valid) {
					syslog(LOG_NOTICE, "[TCP DISCARD CLI] canceled.");
					break;
					}
				syslog(LOG_NOTICE, "[TCP DISCARD CLI] start    repeat: %d/%d", no - count, no);
				send_tcp_discard((ID)exinf, addr, portno);
				syslog(LOG_NOTICE, "[TCP DISCARD CLI] finished repeat: %d/%d", no - count, no);
				syscall(dly_tsk(500 + rand() % 2500));
				}
			}
		}
	}
