/*
 *  TOPPERS/JSP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Just Standard Profile Kernel
 * 
 *  Copyright (C) 2000-2003 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 *  Copyright (C) 2001-2003 by Dep. of Computer Science and Engineering
 *                   Tomakomai National College of Technology, JAPAN
 *
 *  嵭Ԥϡʲ (1)(4) ξ狼Free Software Foundation 
 *  ˤäƸɽƤ GNU General Public License  Version 2 ˵
 *  ҤƤ˸¤ꡤܥեȥܥեȥ
 *  ѤΤޤࡥʲƱˤѡʣѡۡʰʲ
 *  ѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơŬѲǽ
 *  ޤơʤݾڤԤʤޤܥեȥѤˤľ
 *  ŪޤϴŪʤ»˴ؤƤ⡤Ǥʤ
 * 
 *  @(#) $Id: tcp_discard_srv.c,v 1.1.1.1 2004/04/21 00:45:44 abe Exp abe $
 */

/* 
 *  DISCARD 
 */

#include <t_services.h>
#include "tinet_id.h"

#include <net/net_timer.h>

#include <netinet/in.h>
#include <netinet/in_itron.h>

#include <netapp/netapp.h>
#include <netapp/echo.h>

/*
 *  ؿ
 */

#define ip2str	_tinet_ip2str

extern UB *ip2str (UB *buf, UW ipaddr);
extern const char *itron_strerror (ER ercd);

/*
 *  TCP DISCARD Х
 */

#define BUF_SIZE		2048

#ifdef USE_COPYSAVE_API

void
tcp_discard_srv_task(VP_INT exinf)
{
	static UB addr[sizeof("123.123.123.123")];

	T_IPV4EP	dst;
	UB		*buf;
	ER_UINT		rlen;
	ER		error;
	int		count, total;
	ID		tskid;
	SYSTIM		time;

	get_tid(&tskid);
	syslog(LOG_NOTICE, "[TCP DISCARD SRV (CS):%d,%d] started.", tskid, (ID)exinf);
	while (TRUE) {
		if ((error = tcp_acp_cep((ID)exinf, TCP_DISCARD_SRV_REPID, &dst, TMO_FEVR)) == E_OK) {
			count = total = 0;
			ip2str(addr, dst.ipaddr);
			get_tim(&time);
			syslog(LOG_NOTICE, "[TCP DISCARD SRV] connected: %5d.%03d, from: %s:%d",
			                   time / SYSTIM_HZ, time % SYSTIM_HZ, addr, dst.portno);
			while ((rlen = tcp_rcv_buf((ID)exinf, (VP*)&buf, TMO_FEVR)) > 0) {
				/*syslog(LOG_NOTICE, "[TCP DISCARD SRV] count: %4d, len: %4d, data: %02x -> %02x",
				       ++ count, rlen, *buf, *(buf + rlen - 1));*/
				if ((error = tcp_rel_buf((ID)exinf, rlen)) != E_OK) {
					syslog(LOG_WARNING, "[TCP DISCARD SRV] tcp_rel_buf error: %s", itron_strerror(error));
					rlen = 0;
					break;
					}
				total += rlen;
				}
			if (rlen != 0)
				syslog(LOG_WARNING, "[TCP DISCARD SRV] tcp_rcv_buf error: %s", itron_strerror(rlen));
			if ((error = tcp_sht_cep((ID)exinf)) != E_OK)
				syslog(LOG_WARNING, "[TCP DISCARD SRV] tcp_sht_cep error: %s", itron_strerror(error));
			if ((error = tcp_cls_cep((ID)exinf, TMO_FEVR)) != E_OK)
				syslog(LOG_WARNING, "[TCP DISCARD SRV] tcp_cls_cep error: %s", itron_strerror(error));
			get_tim(&time);
			syslog(LOG_NOTICE, "[TCP DISCARD SRV] finished:  %5d.%03d, total count: %d, total len: %d",
			                   time / SYSTIM_HZ, time % SYSTIM_HZ, count, total);
			}
		else
			syslog(LOG_WARNING, "[TCP DISCARD SRV] tcp_acp_cep error: %s", itron_strerror(error));
		}
	}

#else	/* of #ifdef USE_COPYSAVE_API */

void
tcp_discard_srv_task(VP_INT exinf)
{
	static UB buf[BUF_SIZE], addr[sizeof("123.123.123.123")];

	T_IPV4EP	dst;
	ER_UINT		rlen;
	ER		error;
	int		count, total;
	ID		tskid;

	get_tid(&tskid);
	syslog(LOG_NOTICE, "[TCP DISCARD SRV:%d,%d] started.", tskid, (ID)exinf);
	while (TRUE) {
		if ((error = tcp_acp_cep((ID)exinf, TCP_DISCARD_SRV_REPID, &dst, TMO_FEVR)) == E_OK) {
			count = total = 0;
			ip2str(addr, dst.ipaddr);
			syslog(LOG_NOTICE, "[TCP DISCARD SRV] connected from: %s:%d", addr, dst.portno);
			while ((rlen = tcp_rcv_dat((ID)exinf, buf, BUF_SIZE - 1, TMO_FEVR)) > 0) {
				/*syslog(LOG_NOTICE, "[TCP DISCARD SRV] count: %4d, len: %4d, data: %02x -> %02x",
				       ++ count, rlen, *buf, *(buf + rlen - 1));*/
				total += rlen;
				}
			if (rlen != 0)
				syslog(LOG_WARNING, "[TCP DISCARD SRV] tcp_rcv_dat error: %s", itron_strerror(rlen));
			if ((error = tcp_sht_cep((ID)exinf)) != E_OK)
				syslog(LOG_WARNING, "[TCP DISCARD SRV] tcp_sht_cep error: %s", itron_strerror(error));
			if ((error = tcp_cls_cep((ID)exinf, TMO_FEVR)) != E_OK)
				syslog(LOG_WARNING, "[TCP DISCARD SRV] tcp_cls_cep error: %s", itron_strerror(error));
			syslog(LOG_NOTICE, "[TCP DISCARD SRV] closed, total count: %d, total len: %d", count, total);
			}
		else
			syslog(LOG_WARNING, "[TCP DISCARD SRV] tcp_acp_cep error: %s", itron_strerror(error));
		}
	}

#endif	/* of #ifdef USE_COPYSAVE_API */
