/*
 *  TOPPERS/JSP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Just Standard Profile Kernel
 * 
 *  Copyright (C) 2000-2003 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 *  Copyright (C) 2001-2003 by Dep. of Computer Science and Engineering
 *                   Tomakomai National College of Technology, JAPAN
 *
 *  嵭Ԥϡʲ (1)(4) ξ狼Free Software Foundation 
 *  ˤäƸɽƤ GNU General Public License  Version 2 ˵
 *  ҤƤ˸¤ꡤܥեȥܥեȥ
 *  ѤΤޤࡥʲƱˤѡʣѡۡʰʲ
 *  ѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơŬѲǽ
 *  ޤơʤݾڤԤʤޤܥեȥѤˤľ
 *  ŪޤϴŪʤ»˴ؤƤ⡤Ǥʤ
 * 
 *  @(#) $Id: tcp_echo_cli.c,v 1.1.1.1 2004/04/21 00:45:44 abe Exp abe $
 */

/* 
 *  TCP ECHO 饤
 *
 *    ʬΥ
 *    Υ֥å󥰥
 *    ʥԡ API
 */

#include <t_services.h>
#include "kernel_id.h"
#include "tinet_id.h"

#include <stdlib.h>

#include <net/net_timer.h>

#include <netinet/in.h>
#include <netinet/in_itron.h>

#include <netapp/netapp.h>
#include <netapp/echo.h>

/*
 *  ɽ
 */

/*#define SHOW_RCV_RANGE*/

/*
 *  ؿ
 */

#define ip2str	_tinet_ip2str

extern UB *ip2str (UB *buf, UW ipaddr);
extern const char *itron_strerror (ER ercd);

/*
 *  Хåե
 */

#define NUM_ECHO		20
#define NUM_REP_PAT		40
#define PAT_BEGIN		' '
#define PAT_END			'~'
#define SND_BUF_SIZE		((PAT_END - PAT_BEGIN + 1) * NUM_REP_PAT)
#define RCV_BUF_SIZE		(SND_BUF_SIZE*15/10)

/*
 *  ѿ
 */

BOOL tcp_echo_cli_valid;

#ifdef USE_TCP_NON_BLOCKING

/*
 *  ѿ
 */

static T_IPV4EP		nblk_dst;
static T_IPV4EP		nblk_src;
static ER_UINT		nblk_error;

/*
 *  Υ֥å󥰥ΥХåؿ
 */

ER
callback_nblk_tcp_echo_cli (ID cepid, FN fncd, VP p_parblk)
{
	static UB addr[sizeof("123.123.123.123")];

	ER	error = E_OK;

	nblk_error = (ER)p_parblk;

	switch (fncd) {

	case TFN_TCP_CON_CEP:
		ip2str(addr, nblk_dst.ipaddr);
		syscall(sig_sem(SEM_TCP_ECHO_CLI_NBLK_READY));
		break;

	case TFN_TCP_RCV_BUF:
		if (nblk_error < 0)
			syslog(LOG_NOTICE, "[TCP ECHO CLI CBN] recv buf error: %s", itron_strerror(nblk_error));
		syscall(sig_sem(SEM_TCP_ECHO_CLI_NBLK_READY));
		break;

	case TFN_TCP_CLS_CEP:
		if (nblk_error < 0)
			syslog(LOG_NOTICE, "[TCP ECHO CLI CBN] close error: %s", itron_strerror(nblk_error));
		syscall(sig_sem(SEM_TCP_ECHO_CLI_NBLK_READY));
		break;

	case TFN_TCP_RCV_DAT:
		if (nblk_error < 0)
			syslog(LOG_NOTICE, "[TCP ECHO CLI CBN] recv dat error: %s", itron_strerror(nblk_error));
		syscall(sig_sem(SEM_TCP_ECHO_CLI_NBLK_READY));
		break;

	case TFN_TCP_ACP_CEP:
	case TFN_TCP_SND_DAT:
	case TFN_TCP_GET_BUF:
	case TFN_TCP_SND_OOB:
	default:
		error = E_PAR;
		break;
		}
	return error;
	}

/*
 *  send_tcp_echo -- ECHO/TCP Ф˥å롣
 */

static void
send_tcp_echo (ID cepid, UW ipaddr, UH portno)
{
	static UB addr[sizeof("123.123.123.123")];
	static UB smsg[SND_BUF_SIZE];

	int	pat, slen, soff, echo, rep, scount, total;
	UB	*p;
	ER	error;
	SYSTIM	time;

	ip2str(addr, ipaddr);

	nblk_src.ipaddr = IPV4_ADDRANY;
	nblk_src.portno = TCP_PORTANY;
	nblk_dst.ipaddr = ipaddr;
	nblk_dst.portno = portno;

	p = smsg;
	for (rep = NUM_REP_PAT; rep -- > 0; )
		for (pat = PAT_BEGIN; pat <= PAT_END; pat ++)
			*p ++ = pat;

	if ((error = tcp_con_cep(cepid, &nblk_src, &nblk_dst, TMO_NBLK)) != E_WBLK) {
		syslog(LOG_NOTICE, "[TCP ECHO CLI SND] connect error: %s", itron_strerror(error));
		return;
		}

	/* ³λޤԤġ*/
	syscall(wai_sem(SEM_TCP_ECHO_CLI_NBLK_READY));

	if (nblk_error != E_OK)
		syslog(LOG_NOTICE, "[TCP ECHO CLI SND] connect error: %s", itron_strerror(nblk_error));
	else {
		get_tim(&time);
		syslog(LOG_NOTICE, "[TCP ECHO CLI SND] connecting: %5d.%03d",
		                   time / SYSTIM_HZ, time % SYSTIM_HZ);

		syscall(wup_tsk(TCP_ECHO_CLI_RCV_TASK));

		scount = total = 0;
		for (echo = NUM_ECHO; echo -- > 0; ) {
			soff = 0;
			while (soff < SND_BUF_SIZE) {
				if ((slen = tcp_snd_dat(cepid, smsg + soff, sizeof(smsg) - soff, TMO_FEVR)) < 0) {
					syslog(LOG_NOTICE, "[TCP ECHO CLI SND] send error: %s", itron_strerror(slen));
					goto cls_ret;
					}
				soff  += slen;
				total += slen;
				dly_tsk(500 + rand() % 1000);
				}
			}

	cls_ret:
		syslog(LOG_NOTICE, "[TCP ECHO CLI SND] send total len: %d", total);

		if ((error = tcp_sht_cep(cepid)) < 0)
			syslog(LOG_NOTICE, "[TCP ECHO CLI SND] shutdown error: %s", itron_strerror(error));

		/* λޤԤġ*/
		syscall(slp_tsk());

		if ((error = tcp_cls_cep(cepid, TMO_NBLK)) != E_WBLK)
			syslog(LOG_NOTICE, "[TCP ECHO CLI SND] close error: %s", itron_strerror(error));

		/* λޤԤġ*/
		syscall(wai_sem(SEM_TCP_ECHO_CLI_NBLK_READY));
		}
	}

/*
 *  TCP ECHO 饤ȼ
 */

#ifdef USE_COPYSAVE_API

void
tcp_echo_cli_rcv_task (VP_INT exinf)
{
	ID	tskid;
	int	roff, rcount, total, rlen;
	UB	*rmsg, head, tail;
	ER	error;
	SYSTIM	time;

	get_tid(&tskid);
	syslog(LOG_NOTICE, "[TCP ECHO CLI RCV(NBLK, CS):%d,%d] started.", tskid, (ID)exinf);
	while (TRUE) {
		syscall(slp_tsk());

		roff = rcount = total = 0;
		while (TRUE) {
			if ((error = tcp_rcv_buf((ID)exinf, (VP*)&rmsg, TMO_NBLK)) != E_WBLK) {
				syslog(LOG_NOTICE, "[TCP ECHO CLI RCV] get recv buf error: %s", itron_strerror(error));
				break;
				}

			/* ХåեγλޤԤġ*/
			syscall(wai_sem(SEM_TCP_ECHO_CLI_NBLK_READY));

			rlen = nblk_error;
			head = *rmsg;
			tail = *(rmsg + rlen - 1);
			if (rlen > 0) {
				roff  += rlen;
				total += rlen;
				count ++;

#ifdef SHOW_RCV_RANGE
				syslog(LOG_NOTICE, "[TCP ECHO CLI RCV] "
				                   "recv cnt: %2d, len: %4d, off: %4d, data: %02x -> %02x",
				                   ++ rcount, rlen, roff, head, tail);
#endif	/* of #ifdef SHOW_RCV_RANGE */

				}
			else
				break;
			if ((error = tcp_rel_buf((ID)exinf, rlen)) != E_OK)
				syslog(LOG_NOTICE, "[TCP ECHO CLI RCV] rel recv buf error: %s", itron_strerror(error));
			}
		get_tim(&time);
		syslog(LOG_NOTICE, "[TCP ECHO CLI RCV] recv total len: %d,  %5d.%03d",
		                   total, time / SYSTIM_HZ, time % SYSTIM_HZ);

		syscall(wup_tsk(TCP_ECHO_CLI_SND_TASK));
		}
	}

#else	/* of #ifdef USE_COPYSAVE_API */

void
tcp_echo_cli_rcv_task (VP_INT exinf)
{
	static UB rmsg[RCV_BUF_SIZE];

	ID	tskid;
	int	roff, rlen, rcount, total;
	UB	head, tail;
	ER	error;
	SYSTIM	time;

	get_tid(&tskid);
	syslog(LOG_NOTICE, "[TCP ECHO CLI RCV:%d,%d] started.", tskid, (ID)exinf);
	while (TRUE) {
		syscall(slp_tsk());

		roff = rcount = total = 0;
		while (TRUE) {
			if ((error = tcp_rcv_dat((ID)exinf, rmsg, sizeof(rmsg), TMO_NBLK)) != E_WBLK) {
				syslog(LOG_NOTICE, "[TCP ECHO CLI RCV] recv error: %s", itron_strerror(error));
				break;
				}

			/* λޤԤġ*/
			syscall(wai_sem(SEM_TCP_ECHO_CLI_NBLK_READY));

			rlen = nblk_error;
			head = *rmsg;
			tail = *(rmsg + rlen - 1);
			if (rlen > 0) {
				roff  += rlen;
				total += rlen;
				rcount ++;

#ifdef SHOW_RCV_RANGE
				syslog(LOG_NOTICE, "[TCP ECHO CLI RCV] "
				                   "recv cnt: %2d, len: %4d, off: %4d, data: %02x -> %02x",
				                   rcount, rlen, roff, head, tail);
#endif	/* of #ifdef SHOW_RCV_RANGE */

				}
			else
				break;
			}
		get_tim(&time);
		syslog(LOG_NOTICE, "[TCP ECHO CLI RCV] recv total len: %d,  %5d.%03d",
		                   total, time / SYSTIM_HZ, time % SYSTIM_HZ);

		syscall(wup_tsk(TCP_ECHO_CLI_SND_TASK));
		}
	}

#endif	/* of #ifdef USE_COPYSAVE_API */

#else	/* of #ifdef USE_TCP_NON_BLOCKING */

/*
 *  send_tcp_echo -- ECHO/TCP Ф˥å롣
 */

static void
send_tcp_echo (ID cepid, UW ipaddr, UH portno)
{
	static UB smsg[SND_BUF_SIZE];

	T_IPV4EP	dst, src;
	int		pat, slen, soff, echo, rep, scount, total;
	UB		*p;
	ER		error;
	SYSTIM		time;

	src.ipaddr = IPV4_ADDRANY;
	src.portno = TCP_PORTANY;
	dst.ipaddr = ipaddr;
	dst.portno = portno;

	p = smsg;
	for (rep = NUM_REP_PAT; rep -- > 0; )
		for (pat = PAT_BEGIN; pat <= PAT_END; pat ++)
			*p ++ = pat;

	if ((error = tcp_con_cep(cepid, &src, &dst, 60 * 1000)) != E_OK) {
		syslog(LOG_NOTICE, "[TCP ECHO CLI SND] connect error: %s", itron_strerror(error));
		return;
		}

	get_tim(&time);
	syslog(LOG_NOTICE, "[TCP ECHO CLI SND] connecting: %5d.%03d",
	                   time / SYSTIM_HZ, time % SYSTIM_HZ);

	syscall(wup_tsk(TCP_ECHO_CLI_RCV_TASK));

	scount = total = 0;
	for (echo = NUM_ECHO; echo -- > 0; ) {
		soff = 0;
		while (soff < SND_BUF_SIZE) {
			if ((slen = tcp_snd_dat(cepid, smsg + soff, sizeof(smsg) - soff, TMO_FEVR)) < 0) {
				syslog(LOG_NOTICE, "[TCP ECHO CLI SND] send error: %s", itron_strerror(slen));
				goto cls_ret;
				}
			soff  += slen;
			total += slen;
			scount ++;

#ifdef SHOW_RCV_RANGE
			syslog(LOG_NOTICE, "[TCP ECHO CLI SND] send count: %3d, len: %4d, offset: %4d",
			                   scount, slen, soff);
#endif	/* of #ifdef SHOW_RCV_RANGE */

			dly_tsk(500 + rand() % 1000);
			}
		}

cls_ret:
	syslog(LOG_NOTICE, "[TCP ECHO CLI SND] send total len: %d", total);

	syscall(wai_sem(SEMID_RCV_WAIT));

	if ((error = tcp_sht_cep(cepid)) < 0)
		syslog(LOG_NOTICE, "[TCP ECHO CLI SND] shutdown error: %s", itron_strerror(error));

	if ((error = tcp_cls_cep(cepid, TMO_FEVR)) < 0)
		syslog(LOG_NOTICE, "[TCP ECHO CLI SND] close error: %s", itron_strerror(error));
	}

/*
 *  TCP ECHO 饤ȼ
 */

#ifdef USE_COPYSAVE_API

void
tcp_echo_cli_rcv_task (VP_INT exinf)
{
	ID	tskid;
	int	roff, rlen, rcount, total, error;
	UB	*rmsg;
	SYSTIM	time;

	get_tid(&tskid);
	syslog(LOG_NOTICE, "[TCP ECHO CLI RCV (CS):%d,%d] started.", tskid, (ID)exinf);
	while (TRUE) {
		syscall(slp_tsk());

		roff = rcount = total = 0;
		while (roff < SND_BUF_SIZE * NUM_ECHO) {
			if ((rlen = tcp_rcv_buf((ID)exinf, (VP*)&rmsg, 120 * 1000)) < 0) {
				syslog(LOG_NOTICE, "[TCP ECHO CLI RCV] get recv buf error: %s", itron_strerror(rlen));
				break;
				}
			else if (rlen > 0) {
				roff  += rlen;
				total += rlen;
				rcount ++;

#ifdef SHOW_RCV_RANGE
				syslog(LOG_NOTICE, "[TCP ECHO CLI RCV] recv count: %3d, len: %4d, offset: %4d, data: %02x -> %02x",
				       rcount, rlen, roff, *rmsg, *(rmsg + rlen - 1));
#endif	/* of #ifdef SHOW_RCV_RANGE */

				}
			else
				break;
			if ((error = tcp_rel_buf((ID)exinf, rlen)) != E_OK)
				syslog(LOG_NOTICE, "[TCP ECHO CLI RCV] rel recv buf error: %s", itron_strerror(error));
			}
		get_tim(&time);
		syslog(LOG_NOTICE, "[TCP ECHO CLI RCV] recv total len: %d,  %5d.%03d",
		                   total, time / SYSTIM_HZ, time % SYSTIM_HZ);

		sig_sem(SEMID_RCV_WAIT);
		}
	}

#else	/* of #ifdef USE_COPYSAVE_API */

void
tcp_echo_cli_rcv_task (VP_INT exinf)
{
	static UB rmsg[RCV_BUF_SIZE];

	ID	tskid;
	int	roff, rlen, rcount, total;
	SYSTIM	time;

	get_tid(&tskid);
	syslog(LOG_NOTICE, "[TCP ECHO CLI RCV:%d,%d] started.", tskid, (ID)exinf);
	while (TRUE) {
		syscall(slp_tsk());

		roff = rcount = total = 0;
		while (roff < SND_BUF_SIZE * NUM_ECHO) {
			if ((rlen = tcp_rcv_dat((ID)exinf, rmsg, sizeof(rmsg), 120 * 1000)) < 0) {
				syslog(LOG_NOTICE, "[TCP ECHO CLI RCV] recv error: %s", itron_strerror(rlen));
				break;
				}
			else if (rlen > 0) {
				roff  += rlen;
				total += rlen;
				rcount ++;

#ifdef SHOW_RCV_RANGE
				syslog(LOG_NOTICE, "[TCP ECHO CLI RCV] recv count: %3d, len: %4d, offset: %4d, data: %02x -> %02x",
				       rcount, rlen, roff, *rmsg, *(rmsg + rlen - 1));
#endif	/* of #ifdef SHOW_RCV_RANGE */

				}
			else
				break;
			}
		get_tim(&time);
		syslog(LOG_NOTICE, "[TCP ECHO CLI RCV] recv total len: %d,  %5d.%03d",
		                   total, time / SYSTIM_HZ, time % SYSTIM_HZ);

		sig_sem(SEMID_RCV_WAIT);
		}
	}

#endif	/* of #ifdef USE_COPYSAVE_API */

#endif	/* of #ifdef USE_TCP_NON_BLOCKING */

/*
 *  TCP ECHO 饤
 */

/*#define AUTO_INITIATE	"172.31.1.97"*/

#ifdef AUTO_INITIATE

void
tcp_echo_cli_snd_task (VP_INT exinf)
{
	UW	addr;
	ID	tskid;

	get_tid(&tskid);
	syslog(LOG_NOTICE, "[TCP ECHO CLI SND:%d,%d] started.", tskid, (ID)exinf);
	ipv4_addr(&addr, AUTO_INITIATE);
	while (TRUE) {
		send_tcp_echo((ID)exinf, addr, 7);
		syscall(dly_tsk((3 + rand() % 3) * 1000));
		}
	}

#else	/* of #ifdef AUTO_INITIATE */

void
tcp_echo_cli_snd_task (VP_INT exinf)
{
	UB	*line;
	UW	addr, count;
	int	no;
	ID	tskid;
	UH	portno;

	get_tid(&tskid);
	syslog(LOG_NOTICE, "[TCP ECHO CLI SND:%d,%d] started.", tskid, (ID)exinf);
	while (TRUE) {
		if (rcv_dtq(DTQ_TCP_ECHO_CLI, (VP_INT*)&line) == E_OK) {
			line = skip_blanks(get_ipv4addr(&addr, skip_blanks(line)));
			if ('0' < *line && *line < '9') {
				line = get_int(&no, line);
				portno = (UH)no;
				}
			else {
				line ++;
				portno = 7;
				}
			line = skip_blanks(line);
			if (('0' < *line && *line < '9'))
				line = get_int(&no, line);
			else
				no = 1;
			tcp_echo_cli_valid = TRUE;
			for (count = no; count -- > 0; ) {
				if (!tcp_echo_cli_valid) {
					syslog(LOG_NOTICE, "[TCP ECHO CLI SND] canceled.");
					break;
					}
				syslog(LOG_NOTICE, "[TCP ECHO CLI SND] start    repeat: %d/%d", no - count, no);
				send_tcp_echo((ID)exinf, addr, portno);
				syslog(LOG_NOTICE, "[TCP ECHO CLI SND] finished repeat: %d/%d", no - count, no);
				syscall(dly_tsk(500 + rand() % 2500));
				}
			}
		}
	}

#endif	/* of #ifdef AUTO_INITIATE */
