/*
 *  TOPPERS/JSP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Just Standard Profile Kernel
 * 
 *  Copyright (C) 2000-2003 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 *  Copyright (C) 2001-2003 by Dep. of Computer Science and Engineering
 *                   Tomakomai National College of Technology, JAPAN
 *
 *  嵭Ԥϡʲ (1)(4) ξ狼Free Software Foundation 
 *  ˤäƸɽƤ GNU General Public License  Version 2 ˵
 *  ҤƤ˸¤ꡤܥեȥܥեȥ
 *  ѤΤޤࡥʲƱˤѡʣѡۡʰʲ
 *  ѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơŬѲǽ
 *  ޤơʤݾڤԤʤޤܥեȥѤˤľ
 *  ŪޤϴŪʤ»˴ؤƤ⡤Ǥʤ
 * 
 *  @(#) $Id: tcp_echo_srv1.c,v 1.1.1.1 2004/04/21 00:45:44 abe Exp abe $
 */

/* 
 *  TCP ECHO  #1
 *
 *    Ʊ췿
 *    Υ֥å󥰥
 *    ʥԡ API
 */

#include <t_services.h>
#include "kernel_id.h"
#include "tinet_id.h"

#include <netinet/in.h>
#include <netinet/in_itron.h>

#include <netapp/netapp.h>
#include <netapp/echo.h>

/*
 *  ɽ
 */

/*#define SHOW_RCV_RANGE*/

/*
 *  ͥˡλ
 */

/*#define USE_TCP_SHT_CEP*/

/*
 *  ؿ
 */

#define ip2str	_tinet_ip2str

extern UB *ip2str (UB *buf, UW ipaddr);
extern const char *itron_strerror (ER ercd);

/*
 *  ѿ
 */

/*
 *  !!
 *  BUF_SIZE  TCP 
 *  ɥХåե + ɥХåե
 *  礭ʤСǥåɥåǽ롣
 */

#define BUF_SIZE	2048 * 3

static T_IPV4EP		dst;

#ifdef USE_TCP_NON_BLOCKING

static UB 		buffer[BUF_SIZE];
static ER		nblk_error = E_OK;
static int		nblk_slen  = 0;
static int		nblk_rlen  = 0;

#else	/* of #ifdef USE_TCP_NON_BLOCKING */

#ifdef USE_COPYSAVE_API

#else	/* of #ifdef USE_COPYSAVE_API */

static UB 		buffer[BUF_SIZE];

#endif	/* of #ifdef USE_COPYSAVE_API */

#endif	/* of #ifdef USE_TCP_NON_BLOCKING */

#ifdef USE_TCP_NON_BLOCKING

/*
 *  Υ֥å󥰥ΥХåؿ
 */

ER
callback_nblk_tcp_echo_srv (ID cepid, FN fncd, VP p_parblk)
{
	static UB addr[sizeof("123.123.123.123")];

	ER	error = E_OK;

	switch (fncd) {

	case TFN_TCP_ACP_CEP:
		nblk_error = (ER)p_parblk;
		ip2str(addr, dst.ipaddr);
		syscall(sig_sem(SEM_TCP_ECHO_SRV_NBLK_READY));
		break;

	case TFN_TCP_RCV_DAT:
		if ((nblk_rlen = (ER)p_parblk) < 0)
			syslog(LOG_NOTICE, "[TCP ECHO SRV CBN] recv error: %s",
			                   itron_strerror(nblk_rlen));
		syscall(sig_sem(SEM_TCP_ECHO_SRV_NBLK_READY));
		break;

	case TFN_TCP_SND_DAT:
		if ((nblk_slen = (ER)p_parblk) < 0)
			syslog(LOG_NOTICE, "[TCP ECHO SRV CBN] send error: %s",
			                   itron_strerror(nblk_slen));
		syscall(sig_sem(SEM_TCP_ECHO_SRV_NBLK_READY));
		break;

	case TFN_TCP_CLS_CEP:
		if ((nblk_error = (ER)p_parblk) < 0)
			syslog(LOG_NOTICE, "[TCP ECHO SRV CBN] clse error: %s",
			                   itron_strerror(nblk_error));
		syscall(sig_sem(SEM_TCP_ECHO_SRV_NBLK_READY));
		break;

	case TFN_TCP_RCV_BUF:
		if ((nblk_rlen = (ER)p_parblk) < 0)
			syslog(LOG_NOTICE, "[TCP ECHO SRV CBN] rbuf error: %s",
			                   itron_strerror(nblk_rlen));
		syscall(sig_sem(SEM_TCP_ECHO_SRV_NBLK_READY));
		break;

	case TFN_TCP_GET_BUF:
		if ((nblk_slen = (ER)p_parblk) < 0)
			syslog(LOG_NOTICE, "[TCP ECHO SRV CBN] sbuf error: %s",
			                   itron_strerror(nblk_slen));
		syscall(sig_sem(SEM_TCP_ECHO_SRV_NBLK_READY));
		break;

	case TFN_TCP_CON_CEP:
	case TFN_TCP_SND_OOB:
	default:
		error = E_PAR;
		break;
		}
	return error;
	}

#ifdef USE_COPYSAVE_API

void
tcp_echo_srv_task(VP_INT exinf)
{
	static UB addr[sizeof("123.123.123.123")];

	int	rblen, sblen, rlen, slen;
	int	soff, count, total;
	UB	*rbuf, *sbuf, head, tail;
	ID	tskid;
	ER	error = E_OK;

	get_tid(&tskid);
	syslog(LOG_NOTICE, "[TCP ECHO SRV (NBLK, CS):%d,%d] started.", tskid, (ID)exinf);
	while (TRUE) {
		if ((error = tcp_acp_cep((ID)exinf, TCP_ECHO_SRV_REPID, &dst, TMO_NBLK)) != E_WBLK) {
			syslog(LOG_NOTICE, "[TCP ECHO SRV ACP] error: %s", itron_strerror(error));
			continue;
			}

		/* ꤫³ޤԤġ*/
		syscall(wai_sem(SEM_TCP_ECHO_SRV_NBLK_READY));

		if (nblk_error == E_OK) {
			ip2str(addr, dst.ipaddr);
			syslog(LOG_NOTICE, "[TCP ECHO SRV ACP] connected from %s:%d", addr, dst.portno);
			}
		else {
			syslog(LOG_NOTICE, "[TCP ECHO SRV ACP] error: %s", itron_strerror(nblk_error));
			continue;
			}

		rlen = count = total = 0;
		while (TRUE) {
			if ((error = tcp_rcv_buf((ID)exinf, (VP *)&rbuf, TMO_NBLK)) != E_WBLK) {
				syslog(LOG_NOTICE, "[TCP ECHO SRV RCV] error: %s",
				                   itron_strerror(error));
				break;
				}

			/* ޤԤġ*/
			syscall(wai_sem(SEM_TCP_ECHO_SRV_NBLK_READY));

			rblen = nblk_rlen;

			if (rblen < 0) {	/* 顼 */
				syslog(LOG_NOTICE, "[TCP ECHO SRV RCV] error: %s", 
				                   itron_strerror(rblen));
				break;
				}
			else if (rblen == 0)	/* λ */
				break;

			/* ХåեλĤˤꡢĹĴ롣*/
			if (rblen > BUF_SIZE - rlen)
				rblen = BUF_SIZE - rlen;
			total += rblen;
			rlen   = rblen;

			head = *rbuf;
			tail = *(rbuf + rblen - 1);
			count ++;

#ifdef SHOW_RCV_RANGE */
			syslog(LOG_NOTICE, "[TCP ECHO SRV RCV] "
			                   "count: %4d, len: %4d, data %02x -> %02x",
			                   count, rblen, head, tail);
#endif	/* of #ifdef SHOW_RCV_RANGE */

			/*
			 *  ٥Хåե˥ǡܤľХåե
			 *  񤭹⤦ȤƤ⡢ǥåɥå뤳Ȥ롣
			 */
			memcpy(buffer, rbuf, rblen);

			if ((error = tcp_rel_buf((ID)exinf, rlen)) < 0) {
				syslog(LOG_NOTICE, "[TCP ECHO SRV REL] error: %s",
				                   itron_strerror(error));
				break;
				}

			soff = 0;
			while (rlen > 0) {

				if ((error = tcp_get_buf((ID)exinf, (VP *)&sbuf, TMO_NBLK)) != E_WBLK) {
					syslog(LOG_NOTICE, "[TCP ECHO SRV GET] error: %s",
					                   itron_strerror(error));
					goto err_fin;
					}

				/* ХåեγλޤԤġ*/
				syscall(wai_sem(SEM_TCP_ECHO_SRV_NBLK_READY));

				if ((sblen = nblk_slen) < 0) {
					syslog(LOG_NOTICE, "[TCP ECHO SRV GET] error: %s",
					                   itron_strerror(sblen));
					goto err_fin;
					}

				slen = sblen < rlen ? sblen : rlen;
				
				memcpy(sbuf, rbuf + soff, slen);

				if ((error = tcp_snd_buf((ID)exinf, slen)) != E_OK) {
					syslog(LOG_NOTICE, "[TCP ECHO SRV SND] error: %s",
					                   itron_strerror(error));
					goto err_fin;
					}

				rlen -= slen;
				soff += slen;
				}
			}
	err_fin:

#ifdef USE_TCP_SHT_CEP
		if ((error = tcp_sht_cep((ID)exinf)) != E_OK)
			syslog(LOG_NOTICE, "[TCP ECHO SRV SHT] error: %s", itron_strerror(error));
#endif	/* of #ifdef USE_TCP_SHT_CEP */

		if ((error = tcp_cls_cep((ID)exinf, TMO_NBLK)) != E_WBLK)
			syslog(LOG_NOTICE, "[TCP ECHO SRV CLS] error: %s", itron_strerror(error));

		/* λޤԤġ*/
		syscall(wai_sem(SEM_TCP_ECHO_SRV_NBLK_READY));

		syslog(LOG_NOTICE, "[TCP ECHO SRV FIN] finished, cnt: %d, len: %d", count, total);
		}
	}

#else	/* of #ifdef USE_COPYSAVE_API */

void
tcp_echo_srv_task(VP_INT exinf)
{
	static UB addr[sizeof("123.123.123.123")];

	int	rlen, slen;
	int	soff, count, total;
	ID	tskid;
	ER	error;
	UB	head, tail;

	get_tid(&tskid);
	syslog(LOG_NOTICE, "[TCP ECHO SRV (NBLK):%d,%d] started.", tskid, (ID)exinf);
	while (TRUE) {
		if ((error = tcp_acp_cep((ID)exinf, TCP_ECHO_SRV_REPID, &dst, TMO_NBLK)) != E_WBLK) {
			syslog(LOG_NOTICE, "[TCP ECHO SRV ACP] error: %s", itron_strerror(error));
			continue;
			}

		/* ꤫³ޤԤġ*/
		syscall(wai_sem(SEM_TCP_ECHO_SRV_NBLK_READY));

		if (nblk_error == E_OK) {
			ip2str(addr, dst.ipaddr);
			syslog(LOG_NOTICE, "[TCP ECHO SRV ACP] connected from %s:%d", addr, dst.portno);
			}
		else {
			syslog(LOG_NOTICE, "[TCP ECHO SRV ACP] error: %s", itron_strerror(nblk_error));
			continue;
			}

		count = total = 0;
		while (TRUE) {
			if ((error = tcp_rcv_dat((ID)exinf, buffer, BUF_SIZE - 1, TMO_NBLK)) != E_WBLK) {
				syslog(LOG_NOTICE, "[TCP ECHO SRV RCV] error: %s",
				                   itron_strerror(error));
				break;
				}

			/* λޤԤġ*/
			syscall(wai_sem(SEM_TCP_ECHO_SRV_NBLK_READY));

			rlen = nblk_rlen;
			if (rlen < 0) {
				syslog(LOG_NOTICE, "[TCP ECHO SRV RCV] error: %s",
				                   itron_strerror(rlen));
				break;
				}
			else if (rlen == 0)
				break;

			head = *buffer;
			tail = *(buffer + rlen - 1);
			count ++;

#ifdef SHOW_RCV_RANGE
			syslog(LOG_NOTICE, "[TCP ECHO SRV RCV] "
			                   "count: %4d, len: %4d, data %02x -> %02x",
			                   count, rlen, head, tail);
#endif	/* of #ifdef SHOW_RCV_RANGE */

			total += rlen;
			soff = 0;
			while (rlen > 0) {
				if ((error = tcp_snd_dat((ID)exinf, &buffer[soff], rlen, TMO_NBLK)) != E_WBLK) {
					syslog(LOG_NOTICE, "[TCP ECHO SRV SND] error: %s",
					                   itron_strerror(error));
					goto err_fin;
					}

				/* λޤԤġ*/
				syscall(wai_sem(SEM_TCP_ECHO_SRV_NBLK_READY));

				slen = nblk_slen;
				if (slen < 0) {
					syslog(LOG_NOTICE, "[TCP ECHO SRV SND] error: %s",
					                   itron_strerror(slen));
					goto err_fin;
					}

				rlen -= slen;
				soff += slen;
				}
			}
	err_fin:

#ifdef USE_TCP_SHT_CEP
		if ((error = tcp_sht_cep((ID)exinf)) != E_OK)
			syslog(LOG_NOTICE, "[TCP ECHO SRV SHT] error: %s", itron_strerror(error));
#endif	/* of #ifdef USE_TCP_SHT_CEP */

		if ((error = tcp_cls_cep((ID)exinf, TMO_NBLK)) != E_WBLK)
			syslog(LOG_NOTICE, "[TCP ECHO SRV CLS] error: %s", itron_strerror(error));

		/* λޤԤġ*/
		syscall(wai_sem(SEM_TCP_ECHO_SRV_NBLK_READY));

		syslog(LOG_NOTICE, "[TCP ECHO SRV FIN] finished, cnt: %d, len: %d", count, total);
		}
	}

#endif	/* of #ifdef USE_COPYSAVE_API */

#else	/* of #ifdef USE_TCP_NON_BLOCKING */

#ifdef USE_COPYSAVE_API

void
tcp_echo_srv_task(VP_INT exinf)
{
	static UB addr[sizeof("123.123.123.123")];

	int	rblen, sblen, rlen, slen;
	int	soff, count, total;
	UB	*rbuf, *sbuf, head, tail;
	ID	tskid;
	ER	error = E_OK;

	get_tid(&tskid);
	syslog(LOG_NOTICE, "[TCP ECHO SRV (CS):%d,%d] started.", tskid, (ID)exinf);
	while (TRUE) {
		if (tcp_acp_cep((ID)exinf, TCP_ECHO_SRV_REPID, &dst, TMO_FEVR) != E_OK) {
			syslog(LOG_NOTICE, "[TCP ECHO SRV ACP] error: %s", itron_strerror(error));
			continue;
			}

		count = total = 0;
		ip2str(addr, dst.ipaddr);
		syslog(LOG_NOTICE, "[TCP ECHO SRV ACP] connected from %s:%d", addr, dst.portno);
		while (TRUE) {
			if ((rblen = tcp_rcv_buf((ID)exinf, (VP *)&rbuf, TMO_FEVR)) <= 0) {
				if (rblen != E_OK)
					syslog(LOG_NOTICE, "[TCP ECHO SRV RCV] error: %s",
					                   itron_strerror(rblen));
				break;
				}

			head = *rbuf;
			tail = *(rbuf + rblen - 1);
			count ++;

#ifdef SHOW_RCV_RANGE
			syslog(LOG_NOTICE, "[TCP ECHO SRV RCV] "
			                   "count: %4d, len: %4d, data %02x -> %02x",
			                   count, rblen, head, tail);
#endif	/* of #ifdef SHOW_RCV_RANGE */

			rlen   = rblen;
			total += rblen;
			soff = 0;
			while (rlen > 0) {

				if ((sblen = tcp_get_buf((ID)exinf, (VP *)&sbuf, TMO_FEVR)) < 0) {
					syslog(LOG_NOTICE, "[TCP ECHO SRV GET] error: %s",
					                   itron_strerror(sblen));
					goto err_fin;
					}
			
				slen = rlen < sblen ? rlen : sblen;
				memcpy(sbuf, rbuf + soff, slen);
				if ((error = tcp_snd_buf((ID)exinf, slen)) != E_OK) {
					syslog(LOG_NOTICE, "[TCP ECHO SRV SND] error: %s",
					                   itron_strerror(error));
					goto err_fin;
					}

				rlen -= slen;
				soff += slen;
				}

			if ((error = tcp_rel_buf((ID)exinf, rblen)) < 0) {
				syslog(LOG_NOTICE, "[TCP ECHO SRV REL] error: %s", itron_strerror(error));
				break;
				}
			}
	err_fin:

#ifdef USE_TCP_SHT_CEP
		if ((error = tcp_sht_cep((ID)exinf)) != E_OK)
			syslog(LOG_NOTICE, "[TCP ECHO SRV SHT] error: %s", itron_strerror(error));
#endif	/* of #ifdef USE_TCP_SHT_CEP */

		if ((error = tcp_cls_cep((ID)exinf, TMO_FEVR)) != E_OK)
			syslog(LOG_NOTICE, "[TCP ECHO SRV CLS] error: %s", itron_strerror(error));

		syslog(LOG_NOTICE, "[TCP ECHO SRV FIN] finished, cnt: %d, len: %d", count, total);
		}
	}

#else	/* of #ifdef USE_COPYSAVE_API */

void
tcp_echo_srv_task(VP_INT exinf)
{
	static UB addr[sizeof("123.123.123.123")];

	int	rlen, slen;
	int	soff, count, total;
	ID	tskid;
	ER	error = E_OK;

	get_tid(&tskid);
	syslog(LOG_NOTICE, "[TCP ECHO SRV:%d,%d] started.", tskid, (ID)exinf);
	while (TRUE) {
		if (tcp_acp_cep((ID)exinf, TCP_ECHO_SRV_REPID, &dst, TMO_FEVR) != E_OK) {
			syslog(LOG_NOTICE, "[TCP ECHO SRV ACP] error: %s", itron_strerror(error));
			continue;
			}

		count = total = 0;
		ip2str(addr, dst.ipaddr);
		syslog(LOG_NOTICE, "[TCP ECHO SRV ACP] connected from: %s:%d", addr, dst.portno);
		while (TRUE) {
			if ((rlen = tcp_rcv_dat((ID)exinf, buffer, BUF_SIZE - 1, TMO_FEVR)) <= 0) {
				if (rlen != E_OK)
					syslog(LOG_NOTICE, "[TCP ECHO SRV RCV] error: %s",
					                   itron_strerror(rlen));
				break;
				}

			count ++;

#ifdef SHOW_RCV_RANGE
			syslog(LOG_NOTICE, "[TCP ECHO SRV RCV] "
			                   "count: %4d, len: %4d, data %02x -> %02x",
			                   count, rlen, *buffer, *(buffer + rlen - 1));
#endif	/* of #ifdef SHOW_RCV_RANGE */

			total += rlen;
			soff = 0;
			while (rlen > 0) {
				if ((slen = tcp_snd_dat((ID)exinf, &buffer[soff], rlen, TMO_FEVR)) < 0) {
					syslog(LOG_NOTICE, "[TCP ECHO SRV SND] error: %s",
					                   itron_strerror(slen));
					goto err_fin;
					}
				rlen -= slen;
				soff += slen;
				}
			}
	err_fin:

#ifdef USE_TCP_SHT_CEP
		if ((error = tcp_sht_cep((ID)exinf)) != E_OK)
			syslog(LOG_NOTICE, "[TCP ECHO SRV SHT] error: %s", itron_strerror(error));
#endif	/* of #ifdef USE_TCP_SHT_CEP */

		if ((error = tcp_cls_cep((ID)exinf, TMO_FEVR)) != E_OK)
			syslog(LOG_NOTICE, "[TCP ECHO SRV CLS] error: %s", itron_strerror(error));

		syslog(LOG_NOTICE, "[TCP ECHO SRV FIN] finished, cnt: %d, len: %d", count, total);
		}
	}

#endif	/* of #ifdef USE_COPYSAVE_API */

#endif	/* of #ifdef USE_TCP_NON_BLOCKING */
