/*
 *  TOPPERS/JSP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Just Standard Profile Kernel
 * 
 *  Copyright (C) 2000-2003 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 *  Copyright (C) 2001-2003 by Dep. of Computer Science and Engineering
 *                   Tomakomai National College of Technology, JAPAN
 *
 *  嵭Ԥϡʲ (1)(4) ξ狼Free Software Foundation 
 *  ˤäƸɽƤ GNU General Public License  Version 2 ˵
 *  ҤƤ˸¤ꡤܥեȥܥեȥ
 *  ѤΤޤࡥʲƱˤѡʣѡۡʰʲ
 *  ѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơŬѲǽ
 *  ޤơʤݾڤԤʤޤܥեȥѤˤľ
 *  ŪޤϴŪʤ»˴ؤƤ⡤Ǥʤ
 * 
 *  @(#) $Id: tcp_echo_srv2.c,v 1.1.1.1 2004/04/21 00:45:44 abe Exp abe $
 */

/* 
 *  TCP ECHO  #2
 *
 *    ʬΥ
 *    Υ֥å󥰥
 */

#include <jsp_services.h>
#include "kernel_id.h"
#include "tinet_id.h"

#include <netinet/in.h>
#include <netinet/in_itron.h>

#include <netapp/netapp.h>
#include <netapp/echo.h>

/*
 *  ؿ
 */

#define ip2str	_tinet_ip2str

extern UB *ip2str (UB *buf, UW ipaddr);
extern const char *itron_strerror (ER ercd);

/*
 *  ѿ
 */

/*
 *  !!
 *  BUF_SIZE  TCP 
 *  ɥХåե + ɥХåե
 *  礭ʤСǥåɥåǽ롣
 */

#define BUF_SIZE	2048 * 3

static UB 		buffer[BUF_SIZE];	/* Хåե		*/
static UB 		*rptr = buffer;		/* ݥ		*/
static UB 		*sptr = buffer;		/* ݥ		*/
static int		chars;			/* Хåեʸ	*/
static int		rcv_count;		/* 		*/
static int		snd_count;		/* 		*/
static int		rcv_total;		/* ʸ		*/
static int		snd_total;		/* ʸ		*/
static BOOL		ena_rcv;		/* ǽե饰	*/
static T_IPV4EP		dst;			/* ³		*/

#ifdef USE_TCP_NON_BLOCKING

static ER		rcv_error = E_OK;	/* Υ֥å󥰥륨顼 */
static ER		snd_error = 1;		/* Υ֥å󥰥륨顼 */

/*
 *  Υ֥å󥰥ΥХåؿ
 */

ER
callback_nblk_tcp_echo_srv (ID cepid, FN fncd, VP p_parblk)
{
	static UB addr[sizeof("123.123.123.123")];

	ER	error = E_OK;
	int	last, slen, rlen;
	UB	head, tail;

	switch (fncd) {

	case TFN_TCP_ACP_CEP:
		rcv_error = (ER)p_parblk;
		if (rcv_error == E_OK) {
			sptr = rptr = buffer;
			snd_count = snd_total = rcv_count = rcv_total = chars = 0;
			snd_error = 1;
			ena_rcv   = TRUE;
			ip2str(addr, dst.ipaddr);
			syslog(LOG_NOTICE, "[TCP ECHO SRV (NBLK) CBN] connected from: %s:%d", addr, dst.portno);
			}
		else
			syslog(LOG_NOTICE, "[TCP ECHO SRV (NBLK) CBN] accept error: %s\n", itron_strerror(rcv_error));

		syscall(sig_sem(SEM_TCP_ECHO_SRV_RCV_READY));
		break;

	case TFN_TCP_SND_DAT:
		slen = snd_error = (ER)p_parblk;
		if (slen > 0) {
			head = *sptr;
			tail = *(sptr + slen - 1);
			syslog(LOG_NOTICE, "[TCP ECHO SRV (NBLK) CBN] send len: %4d, data %02x -> %02x",
			                   slen, head, tail);
			snd_count ++;
			snd_total += slen;

			syscall(wai_sem(SEM_TCP_ECHO_SRV_LOCK));

			/* ݥ󥿤ʤ롣*/
			if (sptr - buffer + slen >= sizeof(buffer))
				sptr -= sizeof(buffer) - slen;
			else
				sptr += slen;

			/* Хåեʸ򸺤餹*/
			last   = chars;
			chars -= slen;
			/*syslog(LOG_NOTICE, "[TCP ECHO SRV (NBLK) CBN] chars: %4d", chars);*/

 			/* ХåեʸС򵯾롣*/
			if (chars > 0 || (!ena_rcv && chars == 0)) {
				/*syslog(LOG_NOTICE, "[TCP ECHO SRV (NBLK) CBN] more chars: %4d", chars);*/
				sig_sem(SEM_TCP_ECHO_SRV_SND_READY);
				}

 			/* ǽǡХåե˶ǤС򵯾롣*/
			if (ena_rcv && last == sizeof(buffer) && sizeof(buffer) - chars > 0) {
				/*syslog(LOG_NOTICE, "[TCP ECHO SRV (NBLK) CBN] wake up recv");*/
				syscall(sig_sem(SEM_TCP_ECHO_SRV_RCV_READY));
				}

			syscall(sig_sem(SEM_TCP_ECHO_SRV_LOCK));
			}
		else {
			syslog(LOG_NOTICE, "[TCP ECHO SRV (NBLK) CBN] send error = %s", itron_strerror(snd_error));
			sig_sem(SEM_TCP_ECHO_SRV_SND_READY);
			}
		break;

	case TFN_TCP_RCV_DAT:
		rlen = rcv_error = (ER)p_parblk;
		if (rlen > 0) {
			head = *rptr;
			tail = *(rptr + rlen - 1);
			syslog(LOG_NOTICE, "[TCP ECHO SRV (NBLK) CBN] recv len: %4d, data %02x -> %02x",
			                   rlen, head, tail);
			rcv_count ++;
			rcv_total += rlen;

			syscall(wai_sem(SEM_TCP_ECHO_SRV_LOCK));

			/* ݥ󥿤ʤ롣*/
			if (rptr - buffer + rlen >= sizeof(buffer))
				rptr -= sizeof(buffer) - rlen;
			else
				rptr += rlen;

			/* Хåեʸ䤹*/
			last   = chars;
			chars += rlen;
			/*syslog(LOG_NOTICE, "[TCP ECHO SRV (NBLK) CBN] chars: %4d", chars);*/

 			/* ХåեʸС򵯾롣*/
			if (last == 0 && chars > 0) {
				/*syslog(LOG_NOTICE, "[TCP ECHO SRV (NBLK) CBN] wake up send");*/
				sig_sem(SEM_TCP_ECHO_SRV_SND_READY);
				}

 			/* Хåե˶С򵯾롣*/
			if (sizeof(buffer) - chars > 0) {
				/*syslog(LOG_NOTICE, "[TCP ECHO SRV (NBLK) CBN] more buffs: %4d", sizeof(buffer) - chars);*/
				sig_sem(SEM_TCP_ECHO_SRV_RCV_READY);
				}

			syscall(sig_sem(SEM_TCP_ECHO_SRV_LOCK));
			}
		else {
			if (rlen < 0)
				syslog(LOG_NOTICE, "[TCP ECHO SRV (NBLK) CBN] recv error = %s", itron_strerror(rcv_error));
			sig_sem(SEM_TCP_ECHO_SRV_RCV_READY);
			}
		break;

	case TFN_TCP_CLS_CEP:
		snd_error = (ER)p_parblk;
		if (snd_error == E_OK)
			/*syslog(LOG_NOTICE, "[TCP ECHO SRV (NBLK) CBN] closed.")*/;
		else
			syslog(LOG_NOTICE, "[TCP ECHO SRV (NBLK) CBN] close error = %s", itron_strerror(snd_error));

		syslog(LOG_NOTICE, "[TCP ECHO SRV (NBLK) SND] rcv cnt: %d len: %d, snd cnt: %d len: %d",
		                   rcv_count, rcv_total, snd_count, snd_total);

		sig_sem(SEM_TCP_ECHO_SRV_CLS_READY);
		break;

	case TFN_TCP_CON_CEP:
	case TFN_TCP_GET_BUF:
	case TFN_TCP_RCV_BUF:
	case TFN_TCP_SND_OOB:
	default:
		error = E_PAR;
		}
	return error;
	}

/*
 *  TCP ECHO м (Υ֥å󥰥)
 */

void
tcp_echo_srv_rcv_task(VP_INT exinf)
{
	ER	error;
	ID	tskid;
	int	blen;

	get_tid(&tskid);
	syslog(LOG_NOTICE, "[TCP ECHO SRV (NBLK) RCV:%d,%d] started.", tskid, (ID)exinf);
	syscall(act_tsk(TCP_ECHO_SRV_SND_TASK));
	while (TRUE) {
		if ((error = tcp_acp_cep((ID)exinf, TCP_ECHO_SRV_REPID, &dst, TMO_NBLK)) != E_WBLK) {
			syslog(LOG_NOTICE, "[TCP ECHO SRV (NBLK) RCV] accept error = %s", itron_strerror(error));
			continue;
			}

		/* ͥߴλޤԤġ*/
		syscall(wai_sem(SEM_TCP_ECHO_SRV_RCV_READY));

		/* ԤäƤ֤˥顼ˤʤä顢ͥγԤ롣*/
		if (rcv_error != E_OK)
			continue;

		while (TRUE) {

			/* ׻롣*/
			syscall(wai_sem(SEM_TCP_ECHO_SRV_LOCK));
			if (sptr > rptr)
				blen = sptr - rptr;
			else
				blen = sizeof(buffer) - (rptr - buffer);
			syscall(sig_sem(SEM_TCP_ECHO_SRV_LOCK));

			/* 롣*/
			if ((error = tcp_rcv_dat((ID)exinf, rptr, blen, TMO_NBLK)) != E_WBLK) {
				syslog(LOG_NOTICE, "[TCP ECHO SRV (NBLK) RCV] recv error = %s", itron_strerror(error));
				break;
				}

			/* Хåե˶ǤޤԤġ*/
			syscall(wai_sem(SEM_TCP_ECHO_SRV_RCV_READY));

			/* ԤäƤ֤ˡʸ 0 ˤʤ뤫顼ˤʤä齪λ롣*/
			if (rcv_error < 0) {
				syslog(LOG_NOTICE, "[TCP ECHO SRV (NBLK) RCV] finished on error.");
				break;
				}
			else if (rcv_error == 0) {
				syslog(LOG_NOTICE, "[TCP ECHO SRV (NBLK) RCV] finished.");
				break;
				}

			}

		/* λ */
		ena_rcv = FALSE;

		/* ХåեʸΤԤäƤ򵯾롣*/
		if (chars == 0) {
			syslog(LOG_NOTICE, "[TCP ECHO SRV (NBLK) CBN] wake up send");
			sig_sem(SEM_TCP_ECHO_SRV_SND_READY);
			}

		/* ͥǴλޤԤġ*/
		syscall(wai_sem(SEM_TCP_ECHO_SRV_CLS_READY));
		}
	}

/*
 *  TCP ECHO  (Υ֥å󥰥)
 */

void
tcp_echo_srv_snd_task(VP_INT exinf)
{
	ER	error;
	ID	tskid;
	int	blen;

	get_tid(&tskid);
	syslog(LOG_NOTICE, "[TCP ECHO SRV (NBLK) SND:%d,%d] started.", tskid, (ID)exinf);
	while (TRUE) {

		while (TRUE) {

			/* ХåեʸޤԤġ*/
			syscall(wai_sem(SEM_TCP_ECHO_SRV_SND_READY));

			/* ԤäƤ֤˥顼ˤʤä齪λ롣*/
			if (snd_error <= 0) {
				syslog(LOG_NOTICE, "[TCP ECHO SRV (NBLK) SND] finished on error.");
				break;
				}

			/* λǡХåեʸʤнλ롣*/
			if (!ena_rcv && chars == 0) {
				syslog(LOG_NOTICE, "[TCP ECHO SRV (NBLK) SND] finished.");
				break;
				}

			/* ׻롣*/
			syscall(wai_sem(SEM_TCP_ECHO_SRV_LOCK));
			if (rptr > sptr)
				blen = rptr - sptr;
			else
				blen = sizeof(buffer) - (sptr - buffer);
			syscall(sig_sem(SEM_TCP_ECHO_SRV_LOCK));

			/* 롣*/
			if ((error = tcp_snd_dat((ID)exinf, sptr, blen, TMO_NBLK)) != E_WBLK) {
				syslog(LOG_NOTICE, "[TCP ECHO SRV (NBLK) SND] send error = %s", itron_strerror(error));
				break;
				}
			}

		/* Хåե˶ǤԤäƤ򵯾롣*/
		if (chars == sizeof(buffer)) {
			syslog(LOG_NOTICE, "[TCP ECHO SRV (NBLK) CBN] wake up recv");
			sig_sem(SEM_TCP_ECHO_SRV_SND_READY);
			}

		if ((error = tcp_sht_cep((ID)exinf)) != E_OK)
			syslog(LOG_NOTICE, "[TCP ECHO SRV (NBLK) SND] shutdown error = %s", itron_strerror(error));

		if ((error = tcp_cls_cep((ID)exinf, TMO_NBLK)) != E_WBLK) {
			syslog(LOG_NOTICE, "[TCP ECHO SRV (NBLK) SND] close error = %s", itron_strerror(error));
			}

		pol_sem(SEM_TCP_ECHO_SRV_SND_READY);
		pol_sem(SEM_TCP_ECHO_SRV_RCV_READY);
		}
	}

#else	/* of #ifdef USE_TCP_NON_BLOCKING */

/*
 *  TCP ECHO м
 */

void
tcp_echo_srv_rcv_task(VP_INT exinf)
{
	UB		addr[sizeof("123.123.123.123")];
	ER_UINT		rlen;
	ER		error;
	int		blen, last;
	ID		tskid;
	UB		head, tail;

	get_tid(&tskid);
	syslog(LOG_NOTICE, "[TCP ECHO SRV RCV:%d,%d] started.", tskid, (ID)exinf);
	syscall(act_tsk(TCP_ECHO_SRV_SND_TASK));
	while (TRUE) {
		if ((error = tcp_acp_cep((ID)exinf, (ID)exinf, &dst, TMO_FEVR)) != E_OK)
			syslog(LOG_NOTICE, "[TCP ECHO SRV RCV] accept error = %s", itron_strerror(error));
		else {
			sptr = rptr = buffer;
			snd_count = snd_total = rcv_count = rcv_total = chars = 0;
			ena_rcv   = TRUE;
			ip2str(addr, dst.ipaddr);
			syslog(LOG_NOTICE, "[TCP ECHO SRV RCV] connected from: %s:%d", addr, dst.portno);
			while (TRUE) {

				/* ׻롣*/
				syscall(wai_sem(SEM_TCP_ECHO_SRV_LOCK));
				if (sptr > rptr)
					blen = sptr - rptr;
				else
					blen = sizeof(buffer) - (rptr - buffer);
				syscall(sig_sem(SEM_TCP_ECHO_SRV_LOCK));

				/* 롣*/
				if ((rlen = tcp_rcv_dat((ID)exinf, rptr, blen, TMO_FEVR)) <= 0) {
					if (rlen < 0)
						syslog(LOG_NOTICE, "[TCP ECHO SRV RCV] fininsed on error = %s", itron_strerror(rlen));
					else
						syslog(LOG_NOTICE, "[TCP ECHO SRV RCV] finished.");
					break;
					}
				head = *rptr;
				tail = *(rptr + rlen - 1);
				syslog(LOG_NOTICE, "[TCP ECHO SRV RCV] len: %4d, data %02x -> %02x", rlen, head, tail);
				rcv_count ++;
				rcv_total += rlen;

				syscall(wai_sem(SEM_TCP_ECHO_SRV_LOCK));

				/* ݥ󥿤ʤ롣*/
				if (rptr - buffer + rlen >= sizeof(buffer))
					rptr -= sizeof(buffer) - rlen;
				else
					rptr += rlen;

				/* Хåեʸ䤹*/
				last   = chars;
				chars += rlen;
				syslog(LOG_NOTICE, "[TCP ECHO SRV RCV] chars: %4d", chars);

 				/* ХåեʸС򵯾롣*/
				if (last == 0 && chars > 0) {
					syslog(LOG_NOTICE, "[TCP ECHO SRV RCV] wake up send");
					sig_sem(SEM_TCP_ECHO_SRV_SND_READY);
					}

 				/* Хåե˶С򵯾롣*/
				if (sizeof(buffer) - chars > 0) {
					syslog(LOG_NOTICE, "[TCP ECHO SRV RCV] more buffs: %4d", sizeof(buffer) - chars);
					sig_sem(SEM_TCP_ECHO_SRV_RCV_READY);
					}

				syscall(sig_sem(SEM_TCP_ECHO_SRV_LOCK));

				/* Хåե˶ǤޤԤġ*/
				syscall(wai_sem(SEM_TCP_ECHO_SRV_RCV_READY));
				}

			/* λ */
			ena_rcv = FALSE;

			/* ХåեʸΤԤäƤ򵯾롣*/
			if (chars == 0) {
				syslog(LOG_NOTICE, "[TCP ECHO SRV (NBLK) CBN] wake up send");
				sig_sem(SEM_TCP_ECHO_SRV_SND_READY);
				}


			/* ͥǤλޤԤġ*/
			syscall(wai_sem(SEM_TCP_ECHO_SRV_CLS_READY));
			}
		}
	}

/*
 *  TCP ECHO 
 */

void
tcp_echo_srv_snd_task(VP_INT exinf)
{
	ER_UINT		slen;
	int		blen, last;
	ID		tskid;
	ER		error;
	UB		head, tail;

	get_tid(&tskid);
	syslog(LOG_NOTICE, "[TCP ECHO SRV SND:%d,%d] started.", tskid, (ID)exinf);
	while (TRUE) {
		while (TRUE) {

			/* ХåեʸޤԤġ*/
			syscall(wai_sem(SEM_TCP_ECHO_SRV_SND_READY));

			/* λǡХåեʸʤнλ롣*/
			if (!ena_rcv && chars == 0) {
				syslog(LOG_NOTICE, "[TCP ECHO SRV SND] finished.");
				break;
				}

			/* ׻롣*/
			syscall(wai_sem(SEM_TCP_ECHO_SRV_LOCK));
			if (rptr > sptr)
				blen = rptr - sptr;
			else
				blen = sizeof(buffer) - (sptr - buffer);
			syscall(sig_sem(SEM_TCP_ECHO_SRV_LOCK));

			if ((slen = tcp_snd_dat((ID)exinf, sptr, blen, TMO_FEVR)) <= 0) {
				syslog(LOG_NOTICE, "[TCP ECHO SRV SND] send error = %s", itron_strerror(slen));
				break;
				}

			head = *sptr;
			tail = *(sptr + slen - 1);
			syslog(LOG_NOTICE, "[TCP ECHO SRV SND] len: %4d, data %02x -> %02x", slen, head, tail);
			snd_count ++;
			snd_total += slen;

			syscall(wai_sem(SEM_TCP_ECHO_SRV_LOCK));

			/* ݥ󥿤ʤ롣*/
			if (sptr - buffer + slen >= sizeof(buffer))
				sptr -= sizeof(buffer) - slen;
			else
				sptr += slen;

			/* Хåեʸ򸺤餹*/
			last   = chars;
			chars -= slen;
			syslog(LOG_NOTICE, "[TCP ECHO SRV SND] chars: %4d", chars);

 			/* ХåեʸС򵯾롣*/
			if (chars > 0) {
				syslog(LOG_NOTICE, "[TCP ECHO SRV SND] more chars: %4d", chars);
				sig_sem(SEM_TCP_ECHO_SRV_SND_READY);
				}

 			/* ǽǡХåե˶ǤС򵯾롣*/
			if (ena_rcv && last == sizeof(buffer) && sizeof(buffer) - chars > 0) {
				syslog(LOG_NOTICE, "[TCP ECHO SRV SND] wake up recv");
				sig_sem(SEM_TCP_ECHO_SRV_RCV_READY);
				}

			syscall(sig_sem(SEM_TCP_ECHO_SRV_LOCK));
			}

		/* Хåե˶ǤԤäƤ򵯾롣*/
		if (chars == sizeof(buffer)) {
			syslog(LOG_NOTICE, "[TCP ECHO SRV (NBLK) CBN] wake up recv");
			sig_sem(SEM_TCP_ECHO_SRV_SND_READY);
			}

		if ((error = tcp_sht_cep((ID)exinf)) != E_OK)
			syslog(LOG_NOTICE, "[TCP ECHO SRV SND] shtudown error = %s", itron_strerror(error));

		if ((error = tcp_cls_cep((ID)exinf, TMO_FEVR)) != E_OK)
			syslog(LOG_NOTICE, "[TCP ECHO SRV SND] close error = %s", itron_strerror(error));

		syslog(LOG_NOTICE, "[TCP ECHO SRV SND] rcv cnt: %d len: %d, snd cnt: %d len: %d",
		                   rcv_count, rcv_total, snd_count, snd_total);

		sig_sem(SEM_TCP_ECHO_SRV_CLS_READY);

		pol_sem(SEM_TCP_ECHO_SRV_SND_READY);
		pol_sem(SEM_TCP_ECHO_SRV_RCV_READY);
		}
	}

#endif	/* of #ifdef USE_TCP_NON_BLOCKING */
