/*
 *  TOPPERS/JSP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Just Standard Profile Kernel
 * 
 *  Copyright (C) 2000-2003 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 *  Copyright (C) 2001-2003 by Dep. of Computer Science and Engineering
 *                   Tomakomai National College of Technology, JAPAN
 *
 *  嵭Ԥϡʲ (1)(4) ξ狼Free Software Foundation 
 *  ˤäƸɽƤ GNU General Public License  Version 2 ˵
 *  ҤƤ˸¤ꡤܥեȥܥեȥ
 *  ѤΤޤࡥʲƱˤѡʣѡۡʰʲ
 *  ѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơŬѲǽ
 *  ޤơʤݾڤԤʤޤܥեȥѤˤľ
 *  ŪޤϴŪʤ»˴ؤƤ⡤Ǥʤ
 * 
 *  @(#) $Id: udp_discard_cli.c,v 1.1.1.1 2004/04/21 00:45:44 abe Exp abe $
 */

/* 
 *  UDP DISCARD 饤
 */

#include <t_services.h>
#include "kernel_id.h"
#include "tinet_id.h"

#include <stdlib.h>

#include <tinet_defs.h>
#include <tinet_config.h>

#include <net/if.h>
#include <net/if_ppp.h>
#include <net/if_loop.h>
#include <net/ethernet.h>
#include <net/net_timer.h>

#include <netinet/in.h>
#include <netinet/ip.h>
#include <netinet/udp.h>
#include <netinet/in_itron.h>

#include <netapp/netapp.h>
#include <netapp/discard.h>

/*
 *  ؿ
 */

#define ip2str		_tinet_ip2str
#define in_strtfn	_tinet_in_strtfn

extern UB *ip2str (UB *buf, UW ipaddr);
extern const char *in_strtfn (FN fncd);
extern const char *itron_strerror (ER ercd);

/*
 * ѿ
 */

#define PAT_BEGIN	' '
#define PAT_END		'~'

/*
 *  send_udp_discard -- DISCARD/UDP Ф˥å롣
 */

static void
send_udp_discard (ID cepid, UW ipaddr, UH portno)
{
	static UB smsg[IF_MTU - IP4_UDP_HDR_SIZE];

	T_IPV4EP	dst, src;
	int		pat, slen, scount, total, len;
	UB		*p;
	SYSTIM		time;

	src.ipaddr = IPV4_ADDRANY;
	src.portno = UDP_PORTANY;
	dst.ipaddr = ipaddr;
	dst.portno = portno;

	p = smsg;
	for (slen = IF_MTU - IP4_UDP_HDR_SIZE; slen > 0; )
		for (pat = PAT_BEGIN; slen > 0 && pat <= PAT_END; pat ++, slen --)
			*p ++ = pat;

	get_tim(&time);
	syslog(LOG_NOTICE, "[UDP DISCARD CLI] sending: %5d.%03d",
	                   time / SYSTIM_HZ, time % SYSTIM_HZ);

	scount = total = 0;
	for (slen = IF_MTU - IP4_UDP_HDR_SIZE; slen > 0; slen --) {
		if ((len = udp_snd_dat(cepid, &dst, (VP)smsg, slen, TMO_FEVR)) < 0) {
			syslog(LOG_NOTICE, "[UDP DISCARD CLI] send error: %s", itron_strerror(len));
			goto cls_ret;
			}
		total += len;
		scount ++;
		dly_tsk(rand() % 500);
		}

cls_ret:
	syslog(LOG_NOTICE, "[UDP DISCARD CLI] send total len: %d", total);
	}

/*
 *  UDP DISCARD 饤
 */

void
udp_discard_cli_task (VP_INT exinf)
{
	UB	*line;
	UW	addr;
	ID	tskid;
	int	portno = 9;

	get_tid(&tskid);
	syslog(LOG_NOTICE, "[UDP DISCARD CLI:%d,%d] started.", tskid, (ID)exinf);
	while (TRUE) {
		if (rcv_dtq(DTQ_UDP_DISCARD_CLI, (VP_INT*)&line) == E_OK) {
			line = skip_blanks(get_ipv4addr(&addr, skip_blanks(line)));
			if ('0' < *line && *line < '9')
				line = get_int(&portno, line);
			send_udp_discard((ID)exinf, addr, portno);
			}
		}
	}
