/*
 *  TOPPERS/JSP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Just Standard Profile Kernel
 * 
 *  Copyright (C) 2000-2003 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 *  Copyright (C) 2001-2003 by Dep. of Computer Science and Engineering
 *                   Tomakomai National College of Technology, JAPAN
 *
 *  嵭Ԥϡʲ (1)(4) ξ狼Free Software Foundation 
 *  ˤäƸɽƤ GNU General Public License  Version 2 ˵
 *  ҤƤ˸¤ꡤܥեȥܥեȥ
 *  ѤΤޤࡥʲƱˤѡʣѡۡʰʲ
 *  ѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơŬѲǽ
 *  ޤơʤݾڤԤʤޤܥեȥѤˤľ
 *  ŪޤϴŪʤ»˴ؤƤ⡤Ǥʤ
 * 
 *  @(#) $Id: udp_echo_cli.c,v 1.1.1.1 2004/04/21 00:45:44 abe Exp abe $
 */

/* 
 *  UDP ECHO 饤
 */

#include <t_services.h>
#include "kernel_id.h"
#include "tinet_id.h"

#include <netinet/in.h>
#include <netinet/in_itron.h>

#include <netapp/netapp.h>
#include <netapp/echo.h>

/*
 *  ؿ
 */

#define ip2str		_tinet_ip2str
#define in_strtfn	_tinet_in_strtfn

extern UB *ip2str (UB *buf, UW ipaddr);
extern const char *in_strtfn (FN fncd);
extern const char *itron_strerror (ER ercd);

/*
 * ѿ
 */

#define BUF_SIZE	2048

static UB		udp_buf[BUF_SIZE];
static T_IPV4EP		dst;

#ifdef USE_UDP_NON_BLOCKING

/*
 *  Υ֥å󥰥ΥХåؿ
 */

ER
callback_nblk_udp_echo_cli (ID cepid, FN fncd, VP p_parblk)
{
	static UB addr[sizeof("123.123.123.123")];

	ER_UINT		len;

	len = (ER_UINT)p_parblk;
	if (len < 0)	/* 0 ʲξϡ顼 */
		syslog(LOG_NOTICE, "[UDP ECHO CLI CB] recv, fncd: %s, error: %s",
		       in_strtfn(fncd), itron_strerror(len));
	else if (fncd == TFN_UDP_RCV_DAT) {
		ip2str(addr, dst.ipaddr);
		udp_buf[len] = '\0';
		syslog(LOG_NOTICE, "[UDP ECHO CLI CB] recv, len: %d, msg: '%s'", len, udp_buf);
		}
	else if (fncd == TFN_UDP_SND_DAT) {
		syscall(wup_tsk(UDP_ECHO_CLI_TASK));
		}
	return E_OK;
	}

/*
 *  send_udp_echo -- ECHO/UDP Ф˥å (Υ֥å󥰥)
 */

static void
send_udp_echo (ID cepid, UW ipaddr, UB *line)
{
	int len, error;

	dst.ipaddr = ipaddr;
	dst.portno = 7;
	len         = strlen(line);
	syslog(LOG_NOTICE, "[UDP ECHO CLI] send, len: %d, msg: '%s'", len, line);
	error = udp_snd_dat(cepid, &dst, (VP)line, len, TMO_NBLK);
	syscall(slp_tsk());
	error = udp_rcv_dat(cepid, &dst, (VP)udp_buf, sizeof(udp_buf), TMO_NBLK);
	}

#else	/* of #ifdef USE_UDP_NON_BLOCKING */

#ifdef USE_UDP_CALL_BACK

/*
 *  Хåؿ
 */

ER
callback_udp_echo_cli (ID cepid, FN fncd, VP p_parblk)
{
	static UB addr[sizeof("123.123.123.123")];

	ER_UINT	len;

	if ((int)(len = udp_rcv_dat(cepid, &dst, (VP)udp_buf, sizeof(udp_buf), TMO_FEVR)) >= 0) {
		*(udp_buf + len) = '\0';
		ip2str(addr, dst.ipaddr);
		syslog(LOG_NOTICE, "[UDP ECHO CLI CB] recv, len: %d, msg: '%s'", len, udp_buf);
		}
	else
		syslog(LOG_NOTICE, "[UDP ECHO CLI CB] recv, error: %s", itron_strerror(len));

	return E_OK;
	}

/*
 *  send_udp_echo -- ECHO/UDP Ф˥å (Хåؿ)
 */

static void
send_udp_echo (ID cepid, UW ipaddr, UB *line)
{
	ER_UINT	len;
	dst.ipaddr = ipaddr;
	dst.portno = 7;
	len        = strlen(line);

	syslog(LOG_NOTICE, "[UDP ECHO CLI] send, len: %d, msg: '%s'", len, line);
	if ((int)(len = udp_snd_dat(cepid, &dst, (VP)line, len, TMO_FEVR)) < 0)
		syslog(LOG_NOTICE, "[UDP ECHO CLI] send, error: %s", itron_strerror(len));
	}

#else	/* of #ifdef USE_UDP_CALL_BACK */

/*
 *  send_udp_echo -- ECHO/UDP Ф˥å (Хåؿ̤)
 */

static void
send_udp_echo (ID cepid, UW ipaddr, UB *line)
{
	ER_UINT	len;

	dst.ipaddr = ipaddr;
	dst.portno = 7;
	len         = strlen(line);

	syslog(LOG_NOTICE, "[UDP ECHO CLI] send, len: %d, msg: '%s'", len, line);

	if ((int)(len = udp_snd_dat(cepid, &dst, (VP)line, len, TMO_FEVR)) < 0)
		syslog(LOG_NOTICE, "[UDP ECHO CLI] send, error: %s", itron_strerror(len));

	if ((int)(len = udp_rcv_dat(cepid, &dst, (VP)udp_buf, sizeof(udp_buf), 10*1000)) >= 0) {
		*(udp_buf + len) = '\0';
		syslog(LOG_NOTICE, "[UDP ECHO CLI] recv, len: %d, msg: '%s'", len, udp_buf);
		}
	else
		syslog(LOG_NOTICE, "[UDP ECHO CLI] recv, error: %s", itron_strerror(len));
	}

#endif	/* of #ifdef USE_UDP_CALL_BACK */

#endif	/* of #ifdef USE_UDP_NON_BLOCKING */

/*
 *  UDP ECHO 饤
 */

void
udp_echo_cli_task (VP_INT exinf)
{
	UB	*line;
	UW	addr;
	ID	tskid;

	get_tid(&tskid);
	syslog(LOG_NOTICE, "[UDP ECHO CLI:%d,%d] started.", tskid, (ID)exinf);
	while (TRUE) {
		if (rcv_dtq(DTQ_UDP_ECHO_CLI, (VP_INT*)&line) == E_OK) {
			line = skip_blanks(get_ipv4addr(&addr, skip_blanks(line)));
			send_udp_echo((ID)exinf, addr, line);
			}
		}
	}
