/*
 *  TOPPERS/JSP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Just Standard Profile Kernel
 * 
 *  Copyright (C) 2000-2003 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 *  Copyright (C) 2001-2003 by Dep. of Computer Science and Engineering
 *                   Tomakomai National College of Technology, JAPAN
 *
 *  嵭Ԥϡʲ (1)(4) ξ狼Free Software Foundation 
 *  ˤäƸɽƤ GNU General Public License  Version 2 ˵
 *  ҤƤ˸¤ꡤܥեȥܥեȥ
 *  ѤΤޤࡥʲƱˤѡʣѡۡʰʲ
 *  ѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơŬѲǽ
 *  ޤơʤݾڤԤʤޤܥեȥѤˤľ
 *  ŪޤϴŪʤ»˴ؤƤ⡤Ǥʤ
 * 
 *  @(#) $Id: udp_echo_srv.c,v 1.1.1.1 2004/04/21 00:45:44 abe Exp abe $
 */

/* 
 *  UDP ECHO 
 */

#include <t_services.h>
#include "kernel_id.h"
#include "tinet_id.h"

#include <netinet/in.h>
#include <netinet/in_itron.h>

#include <netapp/netapp.h>
#include <netapp/echo.h>

/*
 *  ؿ
 */

#define ip2str		_tinet_ip2str
#define in_strtfn	_tinet_in_strtfn

extern UB *ip2str (UB *buf, UW ipaddr);
extern const char *in_strtfn (FN fncd);
extern const char *itron_strerror (ER ercd);

/*
 *  ѿ
 */

#define BUF_SIZE	2048

static UB	echo_rcv_buf[BUF_SIZE];

#ifdef USE_UDP_NON_BLOCKING

static T_IPV4EP		dst;
static int		len;

/*
 *  Υ֥å󥰥ΥХåؿ
 */

ER
callback_nblk_udp_echo_srv (ID cepid, FN fncd, VP p_parblk)
{
	static UB addr[sizeof("123.123.123.123")];

	len = (int)p_parblk;
	if (len < 0)	/* 0 ʲξϡ顼 */
		syslog(LOG_NOTICE, "[UDP ECHO SRV CB] recv, error: %s, error: %s",
		                   in_strtfn(fncd), itron_strerror(len));
	else if (fncd == TFN_UDP_RCV_DAT) {
		echo_rcv_buf[len] = '\0';
		ip2str(addr, dst.ipaddr);
		syslog(LOG_NOTICE, "[UDP ECHO SRV CB] recv, addr: %s:%d, len: %d, msg: '%s'",
		                   addr, dst.portno, len, echo_rcv_buf);
		}
	else if (fncd == TFN_UDP_SND_DAT)
		syslog(LOG_NOTICE, "[UDP ECHO SRV CB] send, len: %d", len);
	syscall(wup_tsk(UDP_ECHO_SRV_TASK));
	return E_OK;
	}

/*
 *  UDP ECHO Х
 */

void
udp_echo_srv_task(VP_INT exinf)
{
	ID	tskid;
	ER	error;

	get_tid(&tskid);
	syslog(LOG_NOTICE, "[UDP ECHO SRV (NBLK):%d,%d] started.", tskid, (ID)exinf);
	while (TRUE) {
		if ((error = udp_rcv_dat((ID)exinf, &dst, (VP)echo_rcv_buf, sizeof(echo_rcv_buf), TMO_NBLK)) != E_WBLK) {
			syslog(LOG_NOTICE, "[UDP ECHO SRV] recv, error: %s", itron_strerror(error));
			continue;
			}

		syscall(slp_tsk());
		if ((int)len > 0) {
			if ((error = udp_snd_dat((ID)exinf, &dst, (VP)echo_rcv_buf, len, TMO_NBLK)) != E_WBLK) {
				syslog(LOG_NOTICE, "[UDP ECHO SRV] send, error: %s", itron_strerror(error));
				continue;
				}

			syscall(slp_tsk());
			if (len >= 0)
				syslog(LOG_NOTICE, "[UDP ECHO SRV] send, len: %d", len);
			}
		}
	}

#else	/* of #ifdef USE_UDP_NON_BLOCKING */

#ifdef USE_UDP_CALL_BACK

/*
 *  Хåؿ
 */

ER
callback_udp_echo_srv (ID cepid, FN fncd, VP p_parblk)
{
	static UB addr[sizeof("123.123.123.123")];

	T_IPV4EP	dst;
	ER_UINT		len;

	if ((int)(len = udp_rcv_dat(cepid, &dst, (VP)echo_rcv_buf, sizeof(echo_rcv_buf), TMO_FEVR)) >= 0) {
		echo_rcv_buf[len] = '\0';
		ip2str(addr, dst.ipaddr);
		syslog(LOG_NOTICE, "[UDP ECHO SRV CB] recv, addr: %s:%d, len: %d, msg: '%s'",
		                   addr, dst.portno, len, echo_rcv_buf);
		if ((int)len > 0) {
			if ((int)(len = udp_snd_dat(cepid, &dst, (VP)echo_rcv_buf, len, TMO_FEVR)) < 0)
				syslog(LOG_NOTICE, "[UDP ECHO SRV CB] send, error: %s", itron_strerror(len));
			}
		len = E_OK;
		}
	else
		syslog(LOG_NOTICE, "[UDP ECHO SRV CB] recv, error: %s", itron_strerror(len));

	return len;
	}

#else	/* of #ifdef USE_UDP_CALL_BACK */

/*
 *  UDP ECHO Х
 */

void
udp_echo_srv_task(VP_INT exinf)
{
	static UB addr[sizeof("123.123.123.123")];

	T_IPV4EP	dst;
	ER_UINT		len;
	ID		tskid;

	get_tid(&tskid);
	syslog(LOG_NOTICE, "[UDP ECHO SRV:%d,%d] started.", tskid, (ID)exinf);
	while (TRUE) {
		if (((int)len = udp_rcv_dat((ID)exinf, &dst, (VP)echo_rcv_buf, sizeof(echo_rcv_buf), TMO_FEVR)) >= 0) {
			echo_rcv_buf[len] = '\0';
			ip2str(addr, dst.ipaddr);
			syslog(LOG_NOTICE, "[UDP ECHO SRV] recv, addr: %s:%d, len: %d, msg: '%s'",
			                   addr, dst.portno, len, echo_rcv_buf);
			if ((int)len > 0) {
				if ((len = udp_snd_dat((ID)exinf, &dst, (VP)echo_rcv_buf, len, TMO_FEVR)) < 0)
					syslog(LOG_NOTICE, "[UDP ECHO SRV] send, error: %s", itron_strerror(len));
				}
			}
		else
			syslog(LOG_NOTICE, "[UDP ECHO SRV] recv, error: %s", itron_strerror(len));
		}
	}

#endif	/* of #ifdef USE_UDP_CALL_BACK */

#endif	/* of #ifdef USE_UDP_NON_BLOCKING */
