/*
 *  TOPPERS/JSP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Just Standard Profile Kernel
 * 
 *  Copyright (C) 2000-2003 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 *  Copyright (C) 2001-2003 by Dep. of Computer Science and Engineering
 *                   Tomakomai National College of Technology, JAPAN
 *
 *  嵭Ԥϡʲ (1)(4) ξ狼Free Software Foundation 
 *  ˤäƸɽƤ GNU General Public License  Version 2 ˵
 *  ҤƤ˸¤ꡤܥեȥܥեȥ
 *  ѤΤޤࡥʲƱˤѡʣѡۡʰʲ
 *  ѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơŬѲǽ
 *  ޤơʤݾڤԤʤޤܥեȥѤˤľ
 *  ŪޤϴŪʤ»˴ؤƤ⡤Ǥʤ
 * 
 *  @(#) $Id: wwws.c,v 1.1.1.1 2004/04/21 00:45:44 abe Exp abe $
 */

/* 
 *  WWW Хץ
 */

#include <s_services.h>
#include <t_services.h>
#include "kernel_id.h"
#include "tinet_id.h"

#include <stdlib.h>
#include <string.h>

#include <tinet_defs.h>
#include <tinet_config.h>

#include <net/if.h>
#include <net/if_ppp.h>
#include <net/if_loop.h>
#include <net/ethernet.h>
#include <net/net.h>
#include <net/net_buf.h>
#include <net/net_timer.h>
#include <net/net_count.h>

#include <netinet/in.h>
#include <netinet/in_itron.h>

#include "netapp/wwws.h"

/*
 *  ؿ
 */

#define ip2str	_tinet_ip2str

extern UB *ip2str (UB *buf, UW ipaddr);
extern const char *itron_strerror (ER ercd);

/*
 *   API 
 */

#define EOF		(-1)
#define LINE_SIZE	80
#define NUM_FIELDS	4
#define BUF_SIZE	((1 << (sizeof(UB) * 8)) - sizeof(UB) * 3)

#ifdef USE_COPYSAVE_API

typedef struct buffer {
	UB	*buf;
	UH	len;
	UH	index;
	UB	unget;
	} T_BUFFER;

#else	/* of #ifdef USE_COPYSAVE_API */

typedef struct buffer {
	UB	len;
	UB	index;
	UB	unget;
	UB	buf[BUF_SIZE];
	} T_BUFFER;

#endif	/* of #ifdef USE_COPYSAVE_API */

typedef struct line {
	UB	len;
	UB	num;
	UB	off[NUM_FIELDS];
	UB	buf[LINE_SIZE + 1];
	} T_LINE;

typedef struct file {
	ER	(*func)();
	UB	*uri;
	} T_FILE;

typedef struct status {
	UH	code;
	UB	*reason;
	} T_STATUS;

/*
 *  ؿ
 */

static ER index_html(ID cepid);

#if NET_COUNT_ENABLE

static ER stat_html(ID cepid);

#endif	/* of #if NET_COUNT_ENABLE */

/*
 *  ѿ
 */

SYSTIM	srv_start;

static const T_FILE file[] = {
	{ index_html,	"/"		},
	{ index_html,	"/index.html"	},

#if NET_COUNT_ENABLE

	{ stat_html,	"/stat.html"	},

#endif	/* of #if NET_COUNT_ENABLE */
	};

#define NUM_FILES	(sizeof(file) / sizeof(T_FILE))

static const UB *status[] = {
	"200 OK",
	"404 Not Found",
	};

#define NUM_STATUS	(sizeof(status) / sizeof(T_STATUS))

#define ST_OK		0
#define ST_NOT_FOUND	1

/*
 *  get_char -- ʸϤ롣
 */

#ifdef USE_COPYSAVE_API

static int
get_char (ID cepid, T_BUFFER *rbuf)
{
	int	len, ch;
	ID	tskid;
	ER	error;

	if (rbuf->unget) {
		ch = rbuf->unget;
		rbuf->unget = 0;
		}
	else  {
		get_tid(&tskid);
		if (rbuf->index >= rbuf->len) {
			if ((error = tcp_rel_buf(cepid, rbuf->len)) != E_OK)
				syslog(LOG_WARNING, "[WWW:%d] tcp_rel_buf error: %s.",
				       tskid, itron_strerror(error));
			rbuf->index = 0;
			if ((len = tcp_rcv_buf(cepid, (VP*)&rbuf->buf, TMO_FEVR)) <= 0) {
				if (len < 0)
					syslog(LOG_WARNING, "[WWW:%d] tcp_rcv_buf error: %s.",
					       tskid, itron_strerror(len));
				rbuf->len = 0;
				return EOF;
				}
			else
				rbuf->len = len;
			}
		ch = rbuf->buf[rbuf->index ++];
		}
	return ch;
	}

#else	/* of #ifdef USE_COPYSAVE_API */

static int
get_char (ID cepid, T_BUFFER *rbuf)
{
	int	len, ch;
	ID	tskid;

	if (rbuf->unget) {
		ch = rbuf->unget;
		rbuf->unget = 0;
		}
	else  {
		if (rbuf->index >= rbuf->len) {
			if ((len = tcp_rcv_dat(cepid, rbuf->buf, BUF_SIZE, TMO_FEVR)) <= 0) {
				if (len < 0) {
					get_tid(&tskid);
					syslog(LOG_WARNING, "[WWW:%d] tcp_rcv_dat error: %s.",
					       tskid, itron_strerror(len));
					}
				return EOF;
				}
			else {
				rbuf->len   = len;
				rbuf->index = 0;
				}
			}
		ch = rbuf->buf[rbuf->index ++];
		}
	return ch;
	}

#endif	/* of #ifdef USE_COPYSAVE_API */

/*
 *  get_line -- Ϥ롣
 */

static int
get_line (ID cepid, T_LINE *line, T_BUFFER *rbuf)
{
	int	len, ch = 0;
	UB	*p, *t;

	p = line->buf;
	t = line->buf + LINE_SIZE;
	while (p < t && (ch = get_char(cepid, rbuf)) != EOF && ch != '\n' && ch != '\r')
		*p ++ = ch;
	*p = '\0';
	len = p - line->buf;
	if (p >= t) {
		while ((ch = get_char(cepid, rbuf)) != EOF && ch != '\n' && ch != '\r')
			len ++;
		}
	if (ch == '\r') {
		len ++;
		if ((ch = get_char(cepid, rbuf)) != EOF && ch != '\n')
			rbuf->unget = ch;
		}
	if (ch == '\n')
		len ++;
	line->len = len;
	return p - line->buf;
	}

/*
 *  put_str -- ʸϤ롣
 */

#ifdef USE_COPYSAVE_API

static int
put_str (ID cepid, const UB *str)
{
	ER	error;
	ID	tskid;
	ER_UINT	blen = 0;
	INT	off, len, put_len;
	UB	*buf;

	get_tid(&tskid);
	put_len = len = strlen(str);
	off = 0;
	while (len > 0 && (blen = tcp_get_buf(cepid, (VP*)&buf, TMO_FEVR)) >= 0) {
		if (len < blen)
			blen = len;
		memcpy(buf, str + off, blen);
		if ((error = tcp_snd_buf(cepid, blen)) != E_OK) {
			syslog(LOG_WARNING, "[WWW:%d] tcp_snd_buf error: %s.",
			       tskid, itron_strerror(error));
			return 0;
			}
		len -= blen;
		off += blen;
		}
	if (blen < 0)
		syslog(LOG_WARNING, "[WWW:%d] tcp_get_buf error: %s.",
		       tskid, itron_strerror(blen));
	return put_len;
	}

#else	/* of #ifdef USE_COPYSAVE_API */

static int
put_str (ID cepid, const UB *str)
{
	ID	tskid;
	ER_UINT	slen = E_OK;
	INT	off, len, plen;

	plen = len = strlen(str);
	off = 0;
	while (len > 0 && (slen = tcp_snd_dat(cepid, (UB*)str + off, len, TMO_FEVR)) >= 0) {
		len -= slen;
		off += slen;
		}
	if (len == 0)
		return plen;
	else {
		get_tid(&tskid);
		syslog(LOG_WARNING, "[WWW:%d] tcp_snd_dat error: %s.",
		       tskid, itron_strerror(slen));
		return 0;
		}
	}

#endif	/* of #ifdef USE_COPYSAVE_API */

#if NET_COUNT_ENABLE

/*
 *  convert -- Ѵ
 */

static int
convert (UB *buf, UD val, int radix, int width, BOOL minus, UB padchar)
{
	static const UB radhex[] = "0123456789abcdef";

	UB	digits[23], *start;
	int	ix, pad;

	ix = 0;
	start = buf;
	do {
		digits[ix ++] = radhex[val % radix];
		val /= radix;
		} while (val != 0);
	if (minus)
		digits[ix ++] = '-';
	for (pad = ix; pad < width; pad ++)
		*buf ++ = padchar;
	while (ix -- > 0)
		*buf ++ = digits[ix];
	*buf = '\0';
	return buf - start;
	}

#endif	/* of #if NET_COUNT_ENABLE */

/*
 * split_fields -- եɤʬ䤹롣
 */

static void
split_fields (T_LINE *line, UB *delim)
{
	UB	*p, quote;
	int	ix = 0;

	line->off[ix ++] = 0;
	for (p = line->buf; ix < NUM_FIELDS && *p; p ++) {
		if (strchr("\"'`", *p) != NULL) {
			for (quote = *p ++; *p && *p != quote; p ++)
				;
			}
		else if (strchr(delim, *p) != NULL) {
			*p = '\0';
			line->off[ix ++] = (UB)(p - line->buf + 1);
			}
		}
	line->num = ix;
	}

/*
 *  put_status -- status line Ϥ롣
 */

static int
put_status (ID cepid, int index)
{
	int len = 0;

	len += put_str(cepid, "HTTP/1.0 ");
	len += put_str(cepid, status[index]);
	len += put_str(cepid, "\r\n");
	return len;
	}

/*
 *  put_content_length -- Content-length Ϥ롣
 */

static int
put_content_length (ID cepid, int content_len)
{
	int len = 0;
#if 0
	UB length[11];

	convert(length, content_len, 10, 0, FALSE, ' ');
	len += put_str(cepid, "Content-length: ");
	len += put_str(cepid, length);
	len += put_str(cepid, "\r\n");
#endif	/* of #if 0 */
	return len;
	}

/*
 *  get_method -- GET ᥽åɤν
 */

static ER
get_method (ID cepid, T_LINE *line)
{
	int	ix;

	for (ix = NUM_FILES; ix -- > 0; )
		if (!strcmp(file[ix].uri, &line->buf[line->off[1]])) {
			return (*file[ix].func)(cepid);
			}
	put_status(cepid, ST_NOT_FOUND);
	return E_NOEXS;
	}

/*
 *  parse_request -- ꥯȤϤ롣
 */

static ER
parse_request (ID cepid, T_BUFFER *rbuf)
{
	int	len, blen = 0;
	T_LINE	method, line;
	ER	error = E_OK;

	if ((len = get_line(cepid, &method, rbuf)) == 0)
		return error;
	while ((len = get_line(cepid, &line, rbuf)) > 0) {	/* إå򥹥åפ롣*/
		split_fields(&line, ": ");
		if (strcmp("Content-Length", &line.buf[line.off[0]]) == 0) {
			blen = atoi(&line.buf[line.off[1]]);
			}
		}
	while (blen > 0 && (len = get_line(cepid, &line, rbuf)) > 0) {
		/* ƥƥܥǥ򥹥åפ롣*/
		blen -= line.len;
		}
	split_fields(&method, ": ");
	if (!strcmp(&method.buf[method.off[0]], "GET"))
		error = get_method(cepid, &method);
	return error;
	}

/*
 *  index_html -- /index.html ե
 */

static ER
index_html (ID cepid)
{
	static const UB response[] =
		"\r\n<!DOCTYPE html PUBLIC \"-//W3C//DTD html 3.2//EN\">\r\n"
		"<html><head>\r\n"
		"<meta http-euiv=\"Content-Type\" content=\"text/html; charset=EUC-JP\">\r\n"
		"<title>ITRON TCP/IP Protocol Stack</title>\r\n"
		"</head><body bgcolor=\"#ffffbb\">\r\n"
		"<hr> WWW Ф<br>"
		"JSP Kernel Release 1.3 (patchlevel = 0) for " TARGET_NAME " (" __DATE__ "," __TIME__ ") <br>\r\n"
		"ITRON TCP/IP ץȥ륹åˤꥵӥƤޤ<br><hr>\r\n"
		"<ul><li type=\"square\"><a href=\"stat.html\">ͥåȥ׾</a></ul><hr>\r\n"
		"FreeBSD: Copyright (c) 1982, 1986, 1988, 1990, 1993, 1994, 1995<br>\r\n"
		"The Regents of the University of California.  All rights reserved.<br><br>\r\n"

#ifdef SUPPORT_PPP

		"pppd: Copyright (c) 1989 Carnegie Mellon University.<br>\r\n"
		"All rights reserved.<br><br>\r\n"
		"ppp: Written by Toshiharu OHNO (tony-o@iij.ad.jp)<br>\r\n"
		"Copyright (C) 1993, Internet Initiative Japan, Inc. All rights reserverd.<br><br>\r\n"

#endif	/* of #ifdef SUPPORT_PPP */

#ifdef SUPPORT_ETHER

 		"if_ed: Copyright (c) 1995, David Greenman<br>\r\n"
		"All rights reserved.<br><br>\r\n"

#endif	/* of #ifdef SUPPORT_ETHER */

		"TOPPERS/JSP Kernel:<br>\r\n"
		"Toyohashi Open Platform for Embedded Real-Time Systems/Just Standard Profile Kernel<br>\r\n"
		"Copyright (C) 2000-2002 by Embedded and Real-Time Systems Laboratory<br>\r\n"
		"Toyohashi Univ. of Technology, JAPAN<br>\r\n"
		"Copyright (C) 2001 by Dep. of Computer Science and Engineering<br>\r\n"
		"Tomakomai National College of Technology, JAPAN<br><hr>\r\n"
		"</body></html>\r\n"
		;

	SYSTIM	start, finish;
	int	len = 0;
	ID	tskid;

	get_tim(&start);
	len += put_status(cepid, ST_OK);
	len += put_content_length(cepid, strlen(response) - 2);	/* 2 Ϻǽ \r\n */
	len += put_str(cepid, response);
	get_tim(&finish);
	get_tid(&tskid);
	syslog(LOG_NOTICE, "[WWW:%d] send index.html, len: %4d, time: %d [ms].",
	                   tskid, len, (finish - start) * 1000 / SYSTIM_HZ);
	return E_OK;
	}

#if NET_COUNT_ENABLE

#define TD_TEMPLATE1	"<tr><td></td><td align=\"right\"></td>\r\n<td align=\"right\"></td>\r\n<td align=\"right\"></td>\r\n<td align=\"right\"></td>\r\n<td align=\"right\"></td>\r\n<td align=\"right\"></td></tr>\r\n"
#define TD_TEMPLATE2	"<tr><td></td><td align=\"right\"></td><td align=\"right\"></td></tr>\r\n"
#define TD_TEMPLATE3	"<tr><td></td><td align=\"right\"></td></tr>\r\n"
#define TD_TEMPLATE4	"<tr><td></td><td align=\"right\"></td><td align=\"right\"></td><td align=\"right\"></td></tr>\r\n"

#define TD_LEN1(i)	(sizeof(i) +  sizeof(TD_TEMPLATE1) + TD_DIGITS  * 6 - 2)
#define TD_LEN2(i)	(sizeof(i) +  sizeof(TD_TEMPLATE2) + TD_DIGITS  * 2 - 2)
#define TD_LEN4(i)	(sizeof(i) +  sizeof(TD_TEMPLATE4) + TD_DIGITS  * 3 - 2)
#define TD_DIGITS	10

static const UB time_prefix[] =
	"в: "
	;

static const UB time_suffix[] =
	"<hr>\r\n"
	;

static const UB table_suffix[] = "</table><br><hr>";

static const UB table_prefix_tcp[] =
	"<h2>TCP</h2><table border>\r\n"
	"<tr><th></th><th></th></tr>\r\n"
	;

static const UB table_prefix_net_buf[] =
	"<h2>ͥåȥХåե</h2><table border>\r\n"
	"<tr><th></th>"
	"<th>׵</th>"
	"<th></th>"
	"<th>ƥ顼</th></tr>\r\n"
	;

#ifdef SUPPORT_PPP

static const UB table_prefix_ppp[] =
	"<h2>PPP ͥåȥ󥿥ե</h2><table border>\r\n"
	"<tr><th></th><th></th></tr>\r\n"
	;

static const UB *ppp_item[NC_PPP_SIZE] = {
	"ƥåȿ",
	"ƥåȿ",
	"ե졼",
	"ե졼",
	"顼ե졼",
	"顼ե졼",
	"ХåեƼԿ",
	};

#endif	/* of #ifdef SUPPORT_PPP */

#ifdef SUPPORT_ETHER

static const UB table_prefix_ether_nic[] =
	"<h2>ͥåȡͥåȥ󥿥ե</h2><table border>\r\n"
	"<tr><th></th><th></th></tr>\r\n"
	;

static const UB *ether_nic_item[NC_ETHER_NIC_SIZE] = {
	"ƥåȿ",
	"ƥåȿ",
	"ե졼",
	"ե졼",
	"顼ե졼",
	"顼ե졼",
	"Ϳ",
	"ꥻåȿ",
	"ХåեƼԿ",
	"ޥեֵѥС",
	"ޥեֵѥС",
	"ॢȿ",
	};

#endif	/* of #ifdef SUPPORT_ETHER */

static const UB *tcp_item[NC_TCP_SIZE] = {
	"ƥåȿ",
	"ǡƥåȿ",
	"ȿ",
	"ǡȿ",
	"۵ޥȿ",
	"إå",
	"å",
	" ACK ",
	"¿ ACK ",
	" RST ",
	"¿ſ",
	"˴",
	"ǡƥåȿ",
	"楻ȿ",
	"ȿ",
	"ȿ",
	"ǡȿ",
	"۵ޥȿ",
	" ACK ",
	" RST ",
	"RTT ",
	"ưץ",
	"ǽưץ",
	};

/*
 *  put_count_item1 -- 󥿤ƤϤ롣롼 1
 */

static int
put_count_item1 (ID cepid, const UB *item, T_NET_COUNT *counter)
{
	UB	buf[11];
	int	len = 0;

	len += put_str(cepid, "<tr><td>");
	len += put_str(cepid, item);
	len += put_str(cepid, "</td><td align=\"right\">");

	convert(buf, counter->in_octets, 10, TD_DIGITS, FALSE, ' ');
	len += put_str(cepid, buf);
	len += put_str(cepid, "</td>\r\n<td align=\"right\">");

	convert(buf, counter->out_octets, 10, TD_DIGITS, FALSE, ' ');
	len += put_str(cepid, buf);
	len += put_str(cepid, "</td>\r\n<td align=\"right\">");

	convert(buf, counter->in_packets, 10, TD_DIGITS, FALSE, ' ');
	len += put_str(cepid, buf);
	len += put_str(cepid, "</td>\r\n<td align=\"right\">");

	convert(buf, counter->out_packets, 10, TD_DIGITS, FALSE, ' ');
	len += put_str(cepid, buf);
	len += put_str(cepid, "</td>\r\n<td align=\"right\">");

	convert(buf, counter->in_err_packets, 10, TD_DIGITS, FALSE, ' ');
	len += put_str(cepid, buf);
	len += put_str(cepid, "</td>\r\n<td align=\"right\">");

	convert(buf, counter->out_err_packets, 10, TD_DIGITS, FALSE, ' ');
	len += put_str(cepid, buf);
	len += put_str(cepid, "</td></tr>\r\n");

	return len;
	}

#ifdef SUPPORT_PPP

/*
 *  put_count_item2 -- 󥿤ƤϤ롣롼 2
 */

static int
put_count_item2 (ID cepid, const UB *item, UW octets, UW packets)
{
	UB	buf[11];
	int	len = 0;

	len += put_str(cepid, "<tr><td>");
	len += put_str(cepid, item);
	len += put_str(cepid, "</td><td>");

	convert(buf, octets, 10, TD_DIGITS, FALSE, ' ');
	len += put_str(cepid, buf);
	len += put_str(cepid, "</td><td align=\"right\">");

	convert(buf, packets, 10, TD_DIGITS, FALSE, ' ');
	len += put_str(cepid, buf);
	len += put_str(cepid, "</td></tr>\r\n");

	return len;
	}

/*
 *  td_len_ppp -- put_count_ppp ǽϤʸ
 */

static int
td_len_ppp (void)
{
	int	ix, len = 0;

	for (ix = NC_PPP_SIZE; ix -- > 0; )
		len += strlen(ppp_item[ix]);
	return len + (sizeof(TD_TEMPLATE3) + TD_DIGITS - 1) * NC_PPP_SIZE;
	}

/*
 *  put_count_ppp --  (PPP) ƤϤ롣
 */

static int
put_count_ppp (ID cepid)
{

	UB	buf[TD_DIGITS + 1];
	int	len = 0;

	len += put_str(cepid, table_prefix_ppp);

	len += put_str(cepid, "<tr><td>");
	len += put_str(cepid, ppp_item[0]);
	len += put_str(cepid, "</td><td align=\"right\">");
	convert(buf, net_count_ppp.in_octets, 10, TD_DIGITS, FALSE, ' ');
	len += put_str(cepid, buf);
	len += put_str(cepid, "</td></tr>\r\n");

	len += put_str(cepid, "<tr><td>");
	len += put_str(cepid, ppp_item[1]);
	len += put_str(cepid, "</td><td align=\"right\">");
	convert(buf, net_count_ppp.out_octets, 10, TD_DIGITS, FALSE, ' ');
	len += put_str(cepid, buf);
	len += put_str(cepid, "</td></tr>\r\n");

	len += put_str(cepid, "<tr><td>");
	len += put_str(cepid, ppp_item[2]);
	len += put_str(cepid, "</td><td align=\"right\">");
	convert(buf, net_count_ppp.in_packets, 10, TD_DIGITS, FALSE, ' ');
	len += put_str(cepid, buf);
	len += put_str(cepid, "</td></tr>\r\n");

	len += put_str(cepid, "<tr><td>");
	len += put_str(cepid, ppp_item[3]);
	len += put_str(cepid, "</td><td align=\"right\">");
	convert(buf, net_count_ppp.out_packets, 10, TD_DIGITS, FALSE, ' ');
	len += put_str(cepid, buf);
	len += put_str(cepid, "</td></tr>\r\n");

	len += put_str(cepid, "<tr><td>");
	len += put_str(cepid, ppp_item[4]);
	len += put_str(cepid, "</td><td align=\"right\">");
	convert(buf, net_count_ppp.in_err_packets, 10, TD_DIGITS, FALSE, ' ');
	len += put_str(cepid, buf);
	len += put_str(cepid, "</td></tr>\r\n");

	len += put_str(cepid, "<tr><td>");
	len += put_str(cepid, ppp_item[5]);
	len += put_str(cepid, "</td><td align=\"right\">");
	convert(buf, net_count_ppp.out_err_packets, 10, TD_DIGITS, FALSE, ' ');
	len += put_str(cepid, buf);
	len += put_str(cepid, "</td></tr>\r\n");

	len += put_str(cepid, "<tr><td>");
	len += put_str(cepid, ppp_item[6]);
	len += put_str(cepid, "</td><td align=\"right\">");
	convert(buf, net_count_ppp_no_bufs, 10, TD_DIGITS, FALSE, ' ');
	len += put_str(cepid, buf);
	len += put_str(cepid, "</td></tr>\r\n");

	len += put_str(cepid, table_suffix);

	return len;
	}

#endif	/* of #ifdef SUPPORT_PPP */

/*
 *  td_len_tcp -- put_count_tcp ǽϤʸ
 */

static int
td_len_tcp (void)
{
	int	ix, len = 0;

	for (ix = NC_TCP_SIZE; ix -- > 0; )
		len += strlen(tcp_item[ix]);
	return len + (sizeof(TD_TEMPLATE3) + TD_DIGITS - 1) * NC_TCP_SIZE;
	}

/*
 *  put_count_tcp --  (TCP) ƤϤ롣
 */

static int
put_count_tcp (ID cepid)
{
	UB	buf[TD_DIGITS + 1];
	int	ix, len = 0;

	len += put_str(cepid, table_prefix_tcp);
	for (ix = NC_TCP_SIZE; ix -- > 0; ) {
		len += put_str(cepid, "<tr><td>");
		len += put_str(cepid, tcp_item[ix]);
		len += put_str(cepid, "</td><td align=\"right\">");
		convert(buf, net_count_tcp[ix], 10, TD_DIGITS, FALSE, ' ');
		len += put_str(cepid, buf);
		len += put_str(cepid, "</td></tr>\r\n");
		}
	len += put_str(cepid, table_suffix);

	return len;
	}

/*
 *  put_elapse_time -- в֤Ϥ롣
 */

static int
put_elapse_time (ID cepid)
{
	UB	buf[TD_DIGITS + 1];
	int	len = 0;
	SYSTIM	now, elapse;

	get_tim(&now);
	elapse = now - srv_start;

	len += put_str(cepid, time_prefix);

	convert(buf, elapse / (60 * 60 * SYSTIM_HZ), 10, 4, FALSE, ' ');
	len += put_str(cepid, buf);
	len += put_str(cepid, ":");

	convert(buf, (elapse / (60 * SYSTIM_HZ)) % 60, 10, 2, FALSE, ' ');
	len += put_str(cepid, buf);
	len += put_str(cepid, ":");

	convert(buf, (elapse / SYSTIM_HZ) % 60, 10, 2, FALSE, ' ');
	len += put_str(cepid, buf);

	len += put_str(cepid, time_suffix);

	return len;
	}

/*
 *  put_count_net_buf --  (TCP) ƤϤ롣
 */

static int
put_count_net_buf (ID cepid)
{

	UB			buf[TD_DIGITS + 1];
	int			ix, len = 0, size;
	T_NET_BUF_ENTRY		*entry;

	len += put_str(cepid, table_prefix_net_buf);
	size = MIN_NET_BUF_SIZE;
	for (ix = get_num_net_buf_entry(); ix -- > 0; ) {
		entry = get_net_buf_entry(ix);
		len += put_str(cepid, "<tr><td align=\"right\">");
		convert(buf, entry->size, 10, 4, FALSE, ' ');
		len += put_str(cepid, buf);
		len += put_str(cepid, "</td><td align=\"right\">");
		convert(buf, entry->requests, 10, TD_DIGITS, FALSE, ' ');
		len += put_str(cepid, buf);
		len += put_str(cepid, "</td><td align=\"right\">");
		convert(buf, entry->allocs, 10, TD_DIGITS, FALSE, ' ');
		len += put_str(cepid, buf);
		len += put_str(cepid, "</td><td align=\"right\">");
		convert(buf, entry->errors, 10, TD_DIGITS, FALSE, ' ');
		len += put_str(cepid, buf);
		len += put_str(cepid, "</td></tr>\r\n");
		size <<= 1;
		}
	len += put_str(cepid, table_suffix);

	return len;
	}

#ifdef SUPPORT_ETHER

/*
 *  td_len_ether_nic -- put_count_ether_nic ǽϤʸ
 */

static int
td_len_ether_nic (void)
{
	int	ix, len = 0;

	for (ix = NC_ETHER_NIC_SIZE; ix -- > 0; )
		len += strlen(ether_nic_item[ix]);
	return len + (sizeof(TD_TEMPLATE3) + TD_DIGITS - 1) * NC_ETHER_NIC_SIZE;
	}

/*
 *  put_count_ether_nic --  (ETHER_NIC) ƤϤ롣
 */

static int
put_count_ether_nic (ID cepid)
{

	UB	buf[TD_DIGITS + 1];
	int	len = 0;

	len += put_str(cepid, table_prefix_ether_nic);

	len += put_str(cepid, "<tr><td>");
	len += put_str(cepid, ether_nic_item[0]);
	len += put_str(cepid, "</td><td align=\"right\">");
	convert(buf, net_count_ether_nic.in_octets, 10, TD_DIGITS, FALSE, ' ');
	len += put_str(cepid, buf);
	len += put_str(cepid, "</td></tr>\r\n");

	len += put_str(cepid, "<tr><td>");
	len += put_str(cepid, ether_nic_item[1]);
	len += put_str(cepid, "</td><td align=\"right\">");
	convert(buf, net_count_ether_nic.out_octets, 10, TD_DIGITS, FALSE, ' ');
	len += put_str(cepid, buf);
	len += put_str(cepid, "</td></tr>\r\n");

	len += put_str(cepid, "<tr><td>");
	len += put_str(cepid, ether_nic_item[2]);
	len += put_str(cepid, "</td><td align=\"right\">");
	convert(buf, net_count_ether_nic.in_packets, 10, TD_DIGITS, FALSE, ' ');
	len += put_str(cepid, buf);
	len += put_str(cepid, "</td></tr>\r\n");

	len += put_str(cepid, "<tr><td>");
	len += put_str(cepid, ether_nic_item[3]);
	len += put_str(cepid, "</td><td align=\"right\">");
	convert(buf, net_count_ether_nic.out_packets, 10, TD_DIGITS, FALSE, ' ');
	len += put_str(cepid, buf);
	len += put_str(cepid, "</td></tr>\r\n");

	len += put_str(cepid, "<tr><td>");
	len += put_str(cepid, ether_nic_item[4]);
	len += put_str(cepid, "</td><td align=\"right\">");
	convert(buf, net_count_ether_nic.in_err_packets, 10, TD_DIGITS, FALSE, ' ');
	len += put_str(cepid, buf);
	len += put_str(cepid, "</td></tr>\r\n");

	len += put_str(cepid, "<tr><td>");
	len += put_str(cepid, ether_nic_item[5]);
	len += put_str(cepid, "</td><td align=\"right\">");
	convert(buf, net_count_ether_nic.out_err_packets, 10, TD_DIGITS, FALSE, ' ');
	len += put_str(cepid, buf);
	len += put_str(cepid, "</td></tr>\r\n");

	len += put_str(cepid, "<tr><td>");
	len += put_str(cepid, ether_nic_item[6]);
	len += put_str(cepid, "</td><td align=\"right\">");
	convert(buf, net_count_ether_nic_cols, 10, TD_DIGITS, FALSE, ' ');
	len += put_str(cepid, buf);
	len += put_str(cepid, "</td></tr>\r\n");

	len += put_str(cepid, "<tr><td>");
	len += put_str(cepid, ether_nic_item[7]);
	len += put_str(cepid, "</td><td align=\"right\">");
	convert(buf, net_count_ether_nic_resets, 10, TD_DIGITS, FALSE, ' ');
	len += put_str(cepid, buf);
	len += put_str(cepid, "</td></tr>\r\n");

	len += put_str(cepid, "<tr><td>");
	len += put_str(cepid, ether_nic_item[8]);
	len += put_str(cepid, "</td><td align=\"right\">");
	convert(buf, net_count_ether_nic_no_bufs, 10, TD_DIGITS, FALSE, ' ');
	len += put_str(cepid, buf);
	len += put_str(cepid, "</td></tr>\r\n");

	len += put_str(cepid, "<tr><td>");
	len += put_str(cepid, ether_nic_item[9]);
	len += put_str(cepid, "</td><td align=\"right\">");
	convert(buf, net_count_ether_nic_rxb_qovrs, 10, TD_DIGITS, FALSE, ' ');
	len += put_str(cepid, buf);
	len += put_str(cepid, "</td></tr>\r\n");

	len += put_str(cepid, "<tr><td>");
	len += put_str(cepid, ether_nic_item[10]);
	len += put_str(cepid, "</td><td align=\"right\">");
	convert(buf, net_count_ether_nic_txb_qovrs, 10, TD_DIGITS, FALSE, ' ');
	len += put_str(cepid, buf);
	len += put_str(cepid, "</td></tr>\r\n");

	len += put_str(cepid, "<tr><td>");
	len += put_str(cepid, ether_nic_item[11]);
	len += put_str(cepid, "</td><td align=\"right\">");
	convert(buf, net_count_ether_nic_timeouts, 10, TD_DIGITS, FALSE, ' ');
	len += put_str(cepid, buf);
	len += put_str(cepid, "</td></tr>\r\n");

	len += put_str(cepid, table_suffix);

	return len;
	}

#endif	/* of #ifdef SUPPORT_ETHER */

/*
 *  stat_html -- /stat.html ե
 */

static ER
stat_html (ID cepid)
{
	static const UB res_prefix[] =
		"\r\n<!DOCTYPE html PUBLIC \"-//W3C//DTD html 3.2//EN\">\r\n"
		"<html><head>\r\n"
		"<meta http-euiv=\"Content-Type\" content=\"text/html; charset=EUC-JP\">\r\n"
		"<title>ͥåȥ׾</title>\r\n"
		"</head><body bgcolor=\"#ffffbb\">\r\n"
		"<hr><h1 align=\"center\">ͥåȥ׾</h1><hr>\r\n"
		;

	static const UB res_suffix[] =
		"</body></html>\r\n"
		;

	static const UB table_prefix1[] =
		"<h2>롼 1</h2><table border>\r\n"
		"<tr><th></th>\r\n"
		"<th>ƥåȿ</th>"
		"<th>ƥåȿ</th>\r\n"
		"<th>ѥåȿ</th>"
		"<th>ѥåȿ</th>\r\n"
		"<th>顼ѥåȿ</th>"
		"<th>顼ѥåȿ</th></tr>\r\n"
		;

#ifdef SUPPORT_PPP

	static const UB table_prefix2[] =
		"<h2>롼 2</h2><table border>\r\n"
		"<tr><th></th>"
		"<th>ƥåȿ</th>"
		"<th>ե졼</th></tr>\r\n"
		;

#endif	/* of #ifdef SUPPORT_PPP */

	int	content_len, len = 0;
	SYSTIM	start, finish;
	ID	tskid;

	get_tim(&start);
	content_len = 0

#ifdef SUPPORT_PPP

	    + TD_LEN1("HDLC")

#endif	/* of #ifdef SUPPORT_PPP */

#ifdef SUPPORT_PPP

	    + td_len_ppp()
	    + TD_LEN2("LCP")
	    + TD_LEN2("IPCP")

#endif	/* of #ifdef SUPPORT_PPP */

#ifdef SUPPORT_ETHER

	    + TD_LEN1("ARP")
	    + td_len_ether_nic()

#endif	/* of #ifdef SUPPORT_ETHER */

	    + TD_LEN1("IP")
	    + TD_LEN1("ICMP")
	    + TD_LEN1("UDP")
	    + td_len_tcp()
	    + TD_LEN4("0123") * get_num_net_buf_entry();
	    ;

	len += put_status(cepid, ST_OK);
	len += put_content_length(cepid, strlen(res_prefix) 
	                        + strlen(res_suffix)
	                        + strlen(time_prefix)
	                        + strlen("1234:12:12")
	                        + strlen(time_suffix)
	                        + strlen(table_prefix1)
	                        + strlen(table_prefix_net_buf)
	                        + strlen(table_prefix_tcp)
	                        + strlen(table_suffix) * 3

#ifdef SUPPORT_PPP
	                        + strlen(table_prefix2)
	                        + strlen(table_prefix_ppp)
	                        + strlen(table_suffix) * 2

#endif	/* of #ifdef SUPPORT_PPP */

#ifdef SUPPORT_ETHER

	                        + strlen(table_prefix_ether_nic)
	                        + strlen(table_suffix) * 1

#endif	/* of #ifdef SUPPORT_ETHER */

	                        + content_len
	                        - 2);	/* 2 Ϻǽ \r\n */

	len += put_str(cepid, res_prefix);
	len += put_elapse_time(cepid);
	len += put_str(cepid, table_prefix1);

#ifdef SUPPORT_PPP

	len += put_count_item1(cepid, "HDLC", &net_count_hdlc);

#endif	/* of #ifdef SUPPORT_PPP */

#ifdef SUPPORT_ETHER

	len += put_count_item1(cepid, "Ethernet", &net_count_ether);
	len += put_count_item1(cepid, "ARP", &net_count_arp);

#endif	/* of #ifdef SUPPORT_ETHER */

	len += put_count_item1(cepid, "IP", &net_count_ip4);
	len += put_count_item1(cepid, "ICMP", &net_count_icmp4);
	len += put_count_item1(cepid, "UDP", &net_count_udp);

	len += put_str(cepid, table_suffix);

#ifdef SUPPORT_PPP

	len += put_str(cepid, table_prefix2);
	len += put_count_item2(cepid, "LCP", 
	                       net_count_ppp_lcp_in_octets,
	                       net_count_ppp_lcp_in_packets);
	len += put_count_item2(cepid, "IPCP", 
	                       net_count_ppp_ipcp_in_octets,
	                       net_count_ppp_ipcp_in_packets);
	len += put_str(cepid, table_suffix);

	len += put_count_ppp(cepid);

#endif	/* of #ifdef SUPPORT_PPP */

#ifdef SUPPORT_ETHER

	len += put_count_ether_nic(cepid);

#endif	/* of #ifdef SUPPORT_ETHER */

	len += put_count_tcp(cepid);

	len += put_count_net_buf(cepid);

	len += put_str(cepid, res_suffix);

	get_tim(&finish);
	get_tid(&tskid);
	syslog(LOG_NOTICE, "[WWW:%d] send stat.html, len: %4d, time: %d [ms].",
	                   tskid, len, (finish - start) * 1000 / SYSTIM_HZ);
	return E_OK;
	}

#endif	/* of #if NET_COUNT_ENABLE */

/*
 *  WWW Х
 */

void
www_srv_task(VP_INT exinf)
{
	T_BUFFER	rbuf;
	T_IPV4EP	dst;
	UB		addr[sizeof("123.123.123.123")];
	ID		tskid;
	ER		error;
	SYSTIM		time;

	get_tim(&srv_start);
	get_tid(&tskid);
	syslog(LOG_NOTICE, "[WWW:%d,%d] started.", tskid, (INT)exinf);
	rbuf.len = rbuf.unget = 0;
	while (TRUE) {
		if ((error = tcp_acp_cep((INT)exinf, WWW_SRV_REPID, &dst, TMO_FEVR)) != E_OK)
			syslog(LOG_WARNING, "[WWW:%d] accept error: %s.",
			       tskid, itron_strerror(error));
		else {
			ip2str(addr, dst.ipaddr);
			get_tim(&time);
			syslog(LOG_NOTICE, "[WWW:%d] connected: %5d.%03d, from %s:%d.",
			       tskid, time / SYSTIM_HZ, time % SYSTIM_HZ, addr, dst.portno);
			if ((error = parse_request((INT)exinf, &rbuf)) != E_OK)
				syslog(LOG_WARNING, "[WWW:%d] parse request error: %s.",
				       tskid, itron_strerror(error));
			if ((error = tcp_sht_cep((INT)exinf)) != E_OK)
				syslog(LOG_WARNING, "[WWW:%d] shutdown error: %s.",
				       tskid, itron_strerror(error));
			while (get_char((INT)exinf, &rbuf) != EOF)
				;
			if ((error = tcp_cls_cep((INT)exinf, TMO_FEVR)) != E_OK)
				syslog(LOG_WARNING, "[WWW:%d] close error: %s.",
				       tskid, itron_strerror(error));
			get_tim(&time);
			syslog(LOG_NOTICE, "[WWW:%d] finished:  %5d.%03d.",
			                   tskid, time / SYSTIM_HZ, time % SYSTIM_HZ);
			}
		}
	}
