/*
 *  TOPPERS/JSP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Just Standard Profile Kernel
 * 
 *  Copyright (C) 2000-2004 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 *  Copyright (C) 2001-2004 by Dep. of Computer Science and Engineering
 *                   Tomakomai National College of Technology, JAPAN
 *
 *  嵭Ԥϡʲ (1)(4) ξ狼Free Software Foundation 
 *  ˤäƸɽƤ GNU General Public License  Version 2 ˵
 *  ҤƤ˸¤ꡤܥեȥܥեȥ
 *  ѤΤޤࡥʲƱˤѡʣѡۡʰʲ
 *  ѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơŬѲǽ
 *  ޤơʤݾڤԤʤޤܥեȥѤˤľ
 *  ŪޤϴŪʤ»˴ؤƤ⡤Ǥʤ
 * 
 *  @(#) $Id: in_subr.c,v 1.1.1.1 2004/04/21 00:46:19 abe Exp abe $
 */

/*
 * Copyright (c) 1982, 1986, 1988, 1993
 *	The Regents of the University of California.  All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 3. All advertising materials mentioning features or use of this software
 *    must display the following acknowledgement:
 *	This product includes software developed by the University of
 *	California, Berkeley and its contributors.
 * 4. Neither the name of the University nor the names of its contributors
 *    may be used to endorse or promote products derived from this software
 *    without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE REGENTS AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 */

#include <t_services.h>

#include <tinet_defs.h>
#include <tinet_config.h>

#include <net/if.h>
#include <net/if_loop.h>
#include <net/if_ppp.h>
#include <net/ethernet.h>
#include <net/ppp_ipcp.h>
#include <net/net.h>
#include <net/net_var.h>
#include <net/net_buf.h>
#include <net/route.h>

#include <netinet/in.h>
#include <netinet/in_itron.h>
#include <netinet/ip.h>
#include <netinet/ip_var.h>
#include <netinet/tcp_timer.h>

/*
 *  ip2str -- IP ɥ쥹ʸѴ롣
 */

UB *
ip2str (UB *buf, UW ipaddr)
{
	UB *start;

	start = buf;
	buf += convert_hexdigit(buf, (ipaddr >> 24) & 0xff, 10, 0, FALSE, ' ');
	*(buf ++) = '.';
	buf += convert_hexdigit(buf, (ipaddr >> 16) & 0xff, 10, 0, FALSE, ' ');
	*(buf ++) = '.';
	buf += convert_hexdigit(buf, (ipaddr >>  8) & 0xff, 10, 0, FALSE, ' ');
	*(buf ++) = '.';
	buf += convert_hexdigit(buf,  ipaddr        & 0xff, 10, 0, FALSE, ' ');
	*buf = '\0';
	return start;
	}

/*
 *  in_get_datagram -- IP ǡإåꤹ롣
 *
 *		ͥåȥХåեNULL ʤ饨顼
 *	len	IP SDU 
 *	dstaddr	 IP ɥ쥹
 *	srcaddr	ȯ IP ɥ쥹
 *	proto	̥ץȥ
 *	tmout	ॢ
 */

ER
in_get_datagram (T_NET_BUF **nbuf, int len, UW dstaddr, UW srcaddr, UH proto, TMO tmout)
{
	T_IP4_HDR	*ip4h;
	ER		error;
	int		align;

	/* ǡĹ 4 ƥåȶĴ롣	*/
	align = (len + 3) >> 2 << 2;

	/* ͥåȥХåե롣	*/
	if ((error = tget_net_buf(nbuf, IF_IP4_HDR_SIZE + align, tmout)) != E_OK) {
		return error;
		}
	(*nbuf)->len = IF_IP4_HDR_SIZE + len;

	/* 4 ƥåȶޤǥѥǥ󥰤롣*/
	if (align > len)
		memset((VP)(GET_IP4_SDU(*nbuf) + len), 0, align - len);

	/* IP إåꤹ롣*/
	ip4h		= GET_IP4_HDR(*nbuf);
	ip4h->vhl	= IP4_MAKE_VHL(IPV4_VERSION, IP4_HDR_SIZE >> 2);
	ip4h->len	= htons(IP4_HDR_SIZE + len);
	ip4h->proto	= proto;
	ip4h->ttl	= ip4h->type = ip4h->id = ip4h->flg_off = ip4h->sum = 0;

	/* IP ɥ쥹ꤹ롣*/
	ip4h->dst	= htonl(dstaddr);

	if (srcaddr == IPV4_ADDRANY)
		ip4h->src = htonl(IF_IPV4_ADDR_LOCAL);
	else
		ip4h->src = htonl(srcaddr);

	return E_OK;
	}

/*
 *  in_cksum -- å׻ؿ
 *
 *  : data  4 ƥåñ̤ǥѥǥ󥰤뤳ȡ
 *        data  2 ƥåñ̤˥饤󤵤Ƥʤ
 *        㳰ȯǽ롣
 *        len   4 ƥåñ̤˥饤󤵤Ƥ뤳ȡ
 */

UH
in_cksum (VP data, UINT len /*ƥåñ*/)
{
	UW sum = 0, carry;

	for ( ; len > 0; len -= 2)
		sum += *((UH*)data) ++;

	while (sum >= 0x00010000) {
		carry = sum >> 16;
		sum   = (sum & 0xffff) + carry;
		}

	return (UH)~sum;
	}

/*
 *  dstaddr_accept -- 襢ɥ쥹Ȥå롣
 *
 *    : dstaddr ϥۥȥХȥ
 */

BOOL
dstaddr_accept (UW myaddr, UW dstaddr)
{
	if (myaddr == IPV4_ADDRANY)
		return dstaddr == IF_IPV4_ADDR_LOCAL;
	else
		return dstaddr == myaddr;
	}

#ifdef SUPPORT_ETHER

/*
 *  in4_add_ifaddr -- 󥿥ե IPv4 ɥ쥹ɲä롣
 */

ER
in4_add_ifaddr (UW addr, UW mask)
{
	IF_IPV4_ADDR_LOCAL	= addr;
	IF_IPV4_ADDR_LOCAL_MASK	= mask;
	return E_OK;
	}

/*
 *  in4_add_route -- ϩɽ˥ȥɲä롣
 */

ER
in4_add_route (int index, UW target, UW mask, UW gateway)
{

	if (0 <= index && index < NUM_ROUTE_ENTRY) {
		routing_tbl[index].target  = target;
		routing_tbl[index].mask    = mask;
		routing_tbl[index].gateway = gateway;
		return E_OK;
		}
	else
		return E_PAR;
	}

#endif	/* of #ifdef SUPPORT_ETHER */

/*
 *  in_strtfn -- API ǽɤʸɽ֤
 */

const char *
in_strtfn (FN fncd)
{
	switch (fncd) {

	/* TCP ط */

	case TFN_TCP_CRE_REP:
		return "TFN_TCP_CRE_REP";
		break;
	case TFN_TCP_DEL_REP:
		return "TFN_TCP_DEL_REP";
		break;
	case TFN_TCP_CRE_CEP:
		return "TFN_TCP_CRE_CEP";
		break;
	case TFN_TCP_DEL_CEP:
		return "TFN_TCP_DEL_CEP";
		break;
	case TFN_TCP_ACP_CEP:
		return "TFN_TCP_ACP_CEP";
		break;
	case TFN_TCP_CON_CEP:
		return "TFN_TCP_CON_CEP";
		break;
	case TFN_TCP_SHT_CEP:
		return "TFN_TCP_SHT_CEP";
		break;
	case TFN_TCP_CLS_CEP:
		return "TFN_TCP_CLS_CEP";
		break;
	case TFN_TCP_SND_DAT:
		return "TFN_TCP_SND_DAT";
		break;
	case TFN_TCP_RCV_DAT:
		return "TFN_TCP_RCV_DAT";
		break;
	case TFN_TCP_GET_BUF:
		return "TFN_TCP_GET_BUF";
		break;
	case TFN_TCP_SND_BUF:
		return "TFN_TCP_SND_BUF";
		break;
	case TFN_TCP_RCV_BUF:
		return "TFN_TCP_RCV_BUF";
		break;
	case TFN_TCP_REL_BUF:
		return "TFN_TCP_REL_BUF";
		break;
	case TFN_TCP_SND_OOB:
		return "TFN_TCP_SND_OOB";
		break;
	case TFN_TCP_RCV_OOB:
		return "TFN_TCP_RCV_OOB";
		break;
	case TFN_TCP_CAN_CEP:
		return "TFN_TCP_CAN_CEP";
		break;
	case TFN_TCP_SET_OPT:
		return "TFN_TCP_SET_OPT";
		break;
	case TFN_TCP_GET_OPT:
		return "TFN_TCP_GET_OPT";
		break;
	case TFN_TCP_ALL:
		return "ALL";
		break;

	/* UDP ط */

	case TFN_UDP_CRE_CEP:
		return "TFN_UDP_CRE_CEP";
		break;
	case TFN_UDP_DEL_CEP:
		return "TFN_UDP_DEL_CEP";
		break;
	case TFN_UDP_SND_DAT:
		return "TFN_UDP_SND_DAT";
		break;
	case TFN_UDP_RCV_DAT:
		return "TFN_UDP_RCV_DAT";
		break;
	case TFN_UDP_CAN_CEP:
		return "TFN_UDP_CAN_CEP";
		break;
	case TFN_UDP_SET_OPT:
		return "TFN_UDP_SET_OPT";
		break;
	case TFN_UDP_GET_OPT:
		return "TFN_UDP_GET_OPT";
		break;

	default:
		return "unknown TFN";
		}
	}
