/*
 *  TOPPERS/JSP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Just Standard Profile Kernel
 * 
 *  Copyright (C) 2000-2004 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 *  Copyright (C) 2001-2004 by Dep. of Computer Science and Engineering
 *                   Tomakomai National College of Technology, JAPAN
 *
 *  嵭Ԥϡʲ (1)(4) ξ狼Free Software Foundation 
 *  ˤäƸɽƤ GNU General Public License  Version 2 ˵
 *  ҤƤ˸¤ꡤܥեȥܥեȥ
 *  ѤΤޤࡥʲƱˤѡʣѡۡʰʲ
 *  ѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơŬѲǽ
 *  ޤơʤݾڤԤʤޤܥեȥѤˤľ
 *  ŪޤϴŪʤ»˴ؤƤ⡤Ǥʤ
 * 
 *  @(#) $Id: ip.h,v 1.1.1.1 2004/04/21 00:46:19 abe Exp abe $
 */

/*
 * Copyright (c) 1982, 1986, 1993
 *	The Regents of the University of California.  All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 3. All advertising materials mentioning features or use of this software
 *    must display the following acknowledgement:
 *	This product includes software developed by the University of
 *	California, Berkeley and its contributors.
 * 4. Neither the name of the University nor the names of its contributors
 *    may be used to endorse or promote products derived from this software
 *    without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE REGENTS AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 *
 *	@(#)ip.h	8.2 (Berkeley) 6/1/94
 * $FreeBSD: src/sys/netinet/ip.h,v 1.15.2.1 1999/08/29 16:29:38 peter Exp $
 */
 
#ifndef _IP4_H_
#define _IP4_H_

/*
 *  IPv4 RFC791 
 */

#define IPV4_VERSION		4

/*
 *  IPv4 إå
 */

typedef struct t_ip4_hdr {
	UB	vhl;		/* version << 4 | header length >> 2	*/
				/* length  4 octets ñ		*/
	UB	type;		/* type of services			*/
	UH	len;		/* total length				*/

	UH	id;		/* identification			*/
	UH	flg_off;	/* fragment flag & offset		*/

	UB	ttl;		/* time to live				*/
	UB	proto;		/* protocol				*/
	UH	sum;		/* checksum				*/

	UW	src;		/* source address			*/
	UW	dst;		/* destination address			*/
	} T_IP4_HDR;

#define IP4_HDR_SIZE			(sizeof(T_IP4_HDR))
#define IF_IP4_HDR_SIZE			(sizeof(T_IF_HDR) + IP4_HDR_SIZE)

#define GET_IP4_HDR(nbuf)		((T_IP4_HDR*)((nbuf)->buf + sizeof(T_IF_HDR)))
#define GET_IP4_SDU(nbuf)		((UB*)(nbuf)->buf + GET_IF_IP4_HDR_SIZE(nbuf))

#define GET_IP4_HDR_SIZE(iph)		(IP4_VHL_HL((iph)->vhl) << 2)
#define GET_IF_IP4_HDR_SIZE(nbuf)	(sizeof(T_IF_HDR) + (GET_IP4_HDR_SIZE(GET_IP4_HDR(nbuf))))

/*
 *  IPv4 إåؿޥ
 */

#define IP4_MAKE_VHL(v,hl)	(((v)<<4)|(hl))
#define IP4_VHL_V(vhl)		((vhl)>>4)
#define IP4_VHL_HL(vhl)		((vhl)&0x0f)

#define IP4_MAKE_FLGOFF(f,o)	((f)|(o))
#define IP4_FLGOFF_FLG(f)	((f)&~IP4_OFFMASK)
#define IP4_FLGOFF_OFF(o)	((o)&IP4_OFFMASK)

/*
 *  IPv4 إåΥեɤͤ
 */

#define IP4_VHL_BORING	0x45		/* ץ󤬤ʤ VHL 	*/
#define IP4_RF		0x8000		/* off: ͽ			*/
#define IP4_DF		0x4000		/* off: ʬػ			*/
#define IP4_MF		0x2000		/* off: ʬ䤢			*/
#define IP4_OFFMASK	0x1fff		/* եåΥޥ		*/

/*
 *  
 */

#define IP4_MAXPACKET	65535		/* ѥåȥ		*/
#define IP4_MAXTTL	255		/* TTL 			*/
#define IP4_DEFTTL	64		/* TTL  (RFC1340)		*/
#define IP4_FRAGTTL	60		/* ʬ䤵줿ǡ¸*/
#define IP4_MSS		576		/* 祻ȥε	*/

#endif	/* of #ifndef _IP4_H_ */
