/*
 *  TOPPERS/JSP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Just Standard Profile Kernel
 * 
 *  Copyright (C) 2000-2004 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 *  Copyright (C) 2001-2004 by Dep. of Computer Science and Engineering
 *                   Tomakomai National College of Technology, JAPAN
 *
 *  嵭Ԥϡʲ (1)(4) ξ狼Free Software Foundation 
 *  ˤäƸɽƤ GNU General Public License  Version 2 ˵
 *  ҤƤ˸¤ꡤܥեȥܥեȥ
 *  ѤΤޤࡥʲƱˤѡʣѡۡʰʲ
 *  ѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơŬѲǽ
 *  ޤơʤݾڤԤʤޤܥեȥѤˤľ
 *  ŪޤϴŪʤ»˴ؤƤ⡤Ǥʤ
 * 
 *  @(#) $Id: ip_icmp.c,v 1.1.1.1 2004/04/21 00:46:19 abe Exp abe $
 */

/*
 * Copyright (c) 1982, 1986, 1988, 1993
 *	The Regents of the University of California.  All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 3. All advertising materials mentioning features or use of this software
 *    must display the following acknowledgement:
 *	This product includes software developed by the University of
 *	California, Berkeley and its contributors.
 * 4. Neither the name of the University nor the names of its contributors
 *    may be used to endorse or promote products derived from this software
 *    without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE REGENTS AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 *
 *	@(#)ip_icmp.c	8.2 (Berkeley) 1/4/94
 * $FreeBSD: src/sys/netinet/ip_icmp.c,v 1.33.2.3 1999/10/14 11:49:38 des Exp $
 */

#include <t_services.h>

#include <tinet_defs.h>
#include <tinet_config.h>

#include <net/if.h>
#include <net/if_loop.h>
#include <net/if_ppp.h>
#include <net/ethernet.h>
#include <net/ppp_ipcp.h>
#include <net/net.h>
#include <net/net_buf.h>
#include <net/net_count.h>

#include <netinet/in.h>
#include <netinet/in_var.h>
#include <netinet/ip.h>
#include <netinet/ip_var.h>
#include <netinet/ip_icmp.h>
#include <netinet/tcp.h>
#include <netinet/tcp_timer.h>
#include <netinet/tcp_var.h>

/*
 *  ѿ
 */

static void (*icmp_reply) (T_NET_BUF *input) = NULL;

/*
 *  ؿ
 */

static void icmp_echo (T_NET_BUF *input);
static void icmp_unreach (T_NET_BUF *input);

/*
 *  icmp_ecoh -- ׵Ȥν
 *
 *    input ˤ IF إå IP إåޤޤƤ롣
 */

static void
icmp_echo (T_NET_BUF *input)
{
	T_IP4_HDR	*ip4h;
	T_ICMP4_HDR	*icmp4h;
	UW		addr;

	/* åη򥨥׵ (8)   (0) 	*/
	/* ѹ֤					*/

	icmp4h = GET_ICMP4_HDR(input);
	icmp4h->type = ICMP4_ECHO_REPLY;

	/* IP إåΰȯ򴹤롣*/
	ip4h      = GET_IP4_HDR(input);
	addr      = ip4h->src;
	ip4h->src = ip4h->dst;
	ip4h->dst = addr;

	/* å׻롣*/
	icmp4h->sum = 0;
	icmp4h->sum = in_cksum(icmp4h, ((input->len -
	                                 GET_IF_IP4_HDR_SIZE(input)) + 3) >> 2 << 2);

	/* 롣*/
	NET_COUNT_ICMP4(net_count_icmp4.out_octets,
	               input->len - GET_IF_IP4_HDR_SIZE(input));
	NET_COUNT_ICMP4(net_count_icmp4.out_packets, 1);
	ip_output(input, TMO_ICMP4_OUTPUT);
	}

/*
 *  icmp_unreach -- ICMP4_UNREACH Ȥν
 *
 *    input ˤ IF إå IP إåޤޤƤ롣
 */

static B code2error[] = {
	EV_HURCH,	/* ICMP4_UNREACH_NET			0 */
	EV_HURCH,	/* ICMP4_UNREACH_HOST			1 */
	EV_CNNRF,	/* ICMP4_UNREACH_PROTOCOL		2 */
	EV_CNNRF,	/* ICMP4_UNREACH_PORT			3 */
	EV_MSIZE,	/* ICMP4_UNREACH_FLAG			4 */
	EV_HURCH,	/* ICMP4_UNREACH_SRC_FAIL		5 */
	EV_HURCH,	/* ICMP4_UNREACH_NET_UNKNOWN		6 */
	EV_HURCH,	/* ICMP4_UNREACH_HOST_UNKNOWN		7 */
	EV_HURCH,	/* ICMP4_UNREACH_ISOLATED		8 */
	EV_HURCH,	/* ICMP4_UNREACH_NET_PROHIB		9 */
	EV_HURCH,	/* ICMP4_UNREACH_HOST_PROHIB		10 */
	EV_HURCH,	/* ICMP4_UNREACH_TOS_NET		11 */
	EV_HURCH,	/* ICMP4_UNREACH_TOS_HOST		12 */
	EV_HURCH,	/* ICMP4_UNREACH_FILTER_PROHIB		13 */
	EV_HURCH,	/* ICMP4_UNREACH_HOST_PRECEDENCE	14 */
	EV_HURCH,	/* ICMP4_UNREACH_PRECEDENCE_CUTOFF	15 */
	};

static void
icmp_unreach (T_NET_BUF *input)
{
	T_IP4_HDR	*ip4h;
	UB		code;
	ER		error;

	ip4h   = (T_IP4_HDR*)GET_ICMP4_SDU(input);
	code  = GET_ICMP4_HDR(input)->code;
	error = code2error[code];
	if (ip4h->proto == IPPROTO_TCP) {

#ifdef SUPPORT_TCP

		memcpy(GET_IP4_HDR(input), ip4h, input->len - (IP4_HDR_SIZE + ICMP4_HDR_SIZE));
		input->len -= IP4_HDR_SIZE + ICMP4_HDR_SIZE;
		tcp_notify(input, error);

#endif	/* of #ifdef SUPPORT_TCP */

		}
	else
		syslog(LOG_NOTICE, "[ICMP] error, code: %d.", code);
	}

/*
 *  icmp_input -- ICMP ϴؿ
 *
 *    input ˤ IF إå IP إåޤޤƤ롣
 */

void
icmp_input (T_NET_BUF *input)
{
	T_ICMP4_HDR	*icmp4h;
	UH		len, align;

	NET_COUNT_ICMP4(net_count_icmp4.in_octets,
	               input->len - GET_IF_IP4_HDR_SIZE(input));
	NET_COUNT_ICMP4(net_count_icmp4.in_packets, 1);

	/* ICMP إåĹå롣*/
	if (input->len < IF_IP4_ICMP4_HDR_SIZE) {
		NET_COUNT_ICMP4(net_count_icmp4.in_err_packets, 1);
		goto buf_rel;
		}

	icmp4h = GET_ICMP4_HDR(input);

	/* 4 ƥåȶΥǡĹ */
	len   = input->len - GET_IF_IP4_HDR_SIZE(input);
	align = (len + 3) >> 2 << 2;

	/* 4 ƥåȶޤǥѥǥ󥰤롣*/
	if (align > len)
		memset((VP)((UB*)input->buf + input->len), 0, align - len);

	/* å׻롣*/
	if (in_cksum(icmp4h, align) != 0) {
		NET_COUNT_ICMP4(net_count_icmp4.in_err_packets, 1);
		goto buf_rel;
		}

	/* åηˤʬ롣*/
	switch (icmp4h->type) {
	case ICMP4_ECHO_REQUEST:
		icmp_echo(input);
		return;
		break;
	case ICMP4_ECHO_REPLY:
		if (icmp_reply != NULL)
			(*icmp_reply)(input);
		break;
	case ICMP4_UNREACH:
		icmp_unreach(input);
		break;
	case ICMP4_REDIRECT:
		syslog(LOG_INFO, "[ICMP] redirect, addr: %08x.", icmp4h->data.addr);
		break;
	default:
		syslog(LOG_INFO, "[ICMP] unknown type: %d.", icmp4h->type);
		NET_COUNT_ICMP4(net_count_icmp4.in_err_packets, 1);
		break;
		}

buf_rel:
	syscall(rel_net_buf(input));
	}

/*
 *  set_icmp_reply -- ICMP REPLY åؿϿ롣
 *
 *    Ȥˤϡfunc  NULL ꤹ롣
 */

void
set_icmp_reply (void (*func)(T_NET_BUF *))
{
	icmp_reply = func;
	}

#ifdef ICMP4_REPLY_ERROR

/*
 *  icmp_error -- ICMP 顼ؿ
 *
 *    input ˤ IF إå IP إåޤޤƤ롣
 *    icmp_error ǤϡͥåȥХåե input ֵѤʤΤǡ
 *    ƽФ¦ǡƤ齪λ롣	
 */

void
icmp_error (UB code, T_NET_BUF *input)
{
	T_IP4_HDR	*ip4h;
	T_ICMP4_HDR	*icmp4h;
	T_NET_BUF	*output;
	UH		len, ip4hl, align;

	ip4h  = GET_IP4_HDR(input);
	ip4hl = GET_IP4_HDR_SIZE(ip4h);

	/* Ѥ IP ǡ롣*/
	if (input->len - ip4hl < 8)
		len = input->len - ip4hl;
	else
		len = 8;
	syscall(in_get_datagram(&output, ICMP4_HDR_SIZE + ip4hl + len,
	                        ip4h->src, IF_IPV4_ADDR_LOCAL, IPPROTO_ICMP, TMO_ICMP4_OUTPUT));

	/* ICMP إåꤹ롣*/
	icmp4h		= GET_ICMP4_HDR(output);
	icmp4h->type	= ICMP4_UNREACH;
	icmp4h->code	= code;
	icmp4h->data.addr= 0;

	/* 顼ȯ IP إå ǡ 8 ƥåȤ򥳥ԡ롣*/
	memcpy(GET_ICMP4_SDU(output), (VP)GET_IP4_HDR(input), ip4hl + len);

	/* 4 ƥåȶΥǡĹ */
	align = (len + 3) >> 2 << 2;

	/* 4 ƥåȶޤǥѥǥ󥰤롣*/
	if (align > len)
		memset((VP)((UB*)GET_ICMP4_SDU(output) + ip4hl + len), 0, align - len);

	/* å׻롣*/
	icmp4h->sum = 0;
	icmp4h->sum = in_cksum(icmp4h, ICMP4_HDR_SIZE + ip4hl + align);

	/* 롣*/
	NET_COUNT_ICMP4(net_count_icmp4.out_octets,
	               output->len - GET_IF_IP4_HDR_SIZE(output));
	NET_COUNT_ICMP4(net_count_icmp4.out_packets, 1);
	ip_output(output, TMO_ICMP4_OUTPUT);
	}

#endif	/* of #ifdef ICMP4_REPLY_ERROR */
