/*
 *  TOPPERS/JSP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Just Standard Profile Kernel
 * 
 *  Copyright (C) 2000-2004 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 *  Copyright (C) 2001-2004 by Dep. of Computer Science and Engineering
 *                   Tomakomai National College of Technology, JAPAN
 *
 *  嵭Ԥϡʲ (1)(4) ξ狼Free Software Foundation 
 *  ˤäƸɽƤ GNU General Public License  Version 2 ˵
 *  ҤƤ˸¤ꡤܥեȥܥեȥ
 *  ѤΤޤࡥʲƱˤѡʣѡۡʰʲ
 *  ѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơŬѲǽ
 *  ޤơʤݾڤԤʤޤܥեȥѤˤľ
 *  ŪޤϴŪʤ»˴ؤƤ⡤Ǥʤ
 * 
 *  @(#) $Id: ip_input.c,v 1.1.1.1 2004/04/21 00:46:19 abe Exp abe $
 */

/*
 * Copyright (c) 1982, 1986, 1988, 1993
 *	The Regents of the University of California.  All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 3. All advertising materials mentioning features or use of this software
 *    must display the following acknowledgement:
 *	This product includes software developed by the University of
 *	California, Berkeley and its contributors.
 * 4. Neither the name of the University nor the names of its contributors
 *    may be used to endorse or promote products derived from this software
 *    without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE REGENTS AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 *
 *	@(#)input.c	8.2 (Berkeley) 1/4/94
 * $FreeBSD: src/sys/netinet/input.c,v 1.111.2.4 1999/11/01 22:23:53 des Exp $
 *	$ANA: input.c,v 1.5 1996/09/18 14:34:59 wollman Exp $
 */

#include <t_services.h>
#include "kernel_id.h"

#include <tinet_defs.h>
#include <tinet_config.h>

#include <net/if.h>
#include <net/if_ppp.h>
#include <net/if_loop.h>
#include <net/ethernet.h>
#include <net/ppp_ipcp.h>
#include <net/net.h>
#include <net/net_buf.h>
#include <net/net_count.h>
#include <net/net_timer.h>

#include <netinet/in.h>
#include <netinet/in_var.h>
#include <netinet/ip.h>
#include <netinet/ip_var.h>
#include <netinet/ip_icmp.h>
#include <netinet/tcp.h>
#include <netinet/tcp_timer.h>
#include <netinet/tcp_var.h>
#include <netinet/udp.h>
#include <netinet/udp_var.h>

/*
 *  ip_input -- IP ϴؿ
 */

void
ip_input (T_NET_BUF *input)
{
	T_IP4_HDR	*ip4h;
	UW		dst, src;
	UH		hlen;

	NET_COUNT_IP4(net_count_ip4.in_octets , input->len - sizeof(T_IF_HDR));
	NET_COUNT_IP4(net_count_ip4.in_packets, 1);

	/* IP إåĹå롣*/
	if (input->len < IF_IP4_HDR_SIZE)
		goto buf_rel;

	ip4h  = GET_IP4_HDR(input);
	hlen = GET_IP4_HDR_SIZE(ip4h);

	/* Сå롣*/
	if (IP4_VHL_V(ip4h->vhl) != IPV4_VERSION)
		goto buf_rel;

	/* IP إåĹåץϤ롣*/
	if (hlen > IP4_HDR_SIZE) {
		/* %%% ץβ %%% */

		/* ̤ ICMP ʳϥץõ롣*/
		if (ip4h->proto != IPPROTO_ICMP)
			memset((VP)ip4h + IP4_HDR_SIZE, 0, hlen - IP4_HDR_SIZE);
		}

	/* ǡĹå롣*/
	if (ntohs(ip4h->len) > input->len - sizeof(T_IF_HDR))
		goto buf_rel;

	/* ͥåȥХåեĹǡĹĴ롣*/
	input->len = ntohs(ip4h->len) + sizeof(T_IF_HDR);

	/* åå롣*/
	if (in_cksum(ip4h, hlen) != 0)
		goto buf_rel;

	/* ɥ쥹å롣*/
	src = ntohl(ip4h->src);

#ifdef SUPPORT_LOOP

	if (src == IF_IPV4_ADDR_LOCAL_BC ||
	    src == IPV4_ADDR_BROADCAST   ||
	    src == IPV4_ADDRANY)
		goto buf_rel;

#else	/* of #ifdef SUPPORT_LOOP */

	if (src == IF_IPV4_ADDR_LOCAL    ||
	    src == IF_IPV4_ADDR_LOCAL_BC ||
	    src == IPV4_ADDR_BROADCAST   ||
	    src == IPV4_ADDRANY)
		goto buf_rel;

#endif	/* of #ifdef SUPPORT_LOOP */

	/* 襢ɥ쥹å롣*/
	dst = ntohl(ip4h->dst);

#ifdef DHCP_CFG

	/*
	 *  DHCP_CFG ƤȤϡ륢ɥ쥹̤
	 *  ǡ롣
	 */

	if ((IF_IPV4_ADDR_LOCAL != IPV4_ADDRANY) &&
	    (!(dst == IF_IPV4_ADDR_LOCAL    ||
	       dst == IF_IPV4_ADDR_LOCAL_BC ||
	       dst == IPV4_ADDR_BROADCAST   ||
	       dst == IPV4_ADDRANY))) {
		goto buf_rel;
		}

#else	/* of #ifdef DHCP_CFG */

	if (!(dst == IF_IPV4_ADDR_LOCAL    ||
	      dst == IF_IPV4_ADDR_LOCAL_BC ||
	      dst == IPV4_ADDR_BROADCAST   ||
	      dst == IPV4_ADDRANY))
		goto buf_rel;

#endif	/* of #ifdef DHCP_CFG */

	/* ʬ䤵Ƥ뤫å롣*/
	if (ntohs(ip4h->flg_off) & (IP4_RF | IP4_MF | IP4_OFFMASK)) {
		syslog(LOG_WARNING, "[IP] flaged src: %08x.", ntohl(ip4h->src));
		goto buf_rel;
		}

	/* ץȥ򤹤 */
	switch (ip4h->proto) {

#ifdef SUPPORT_UDP
	case IPPROTO_UDP:
		udp_input(input);
		return;
		break;
#endif	/* of #ifdef SUPPORT_UDP */

#ifdef SUPPORT_TCP
	case IPPROTO_TCP:
		tcp_input(input);
		return;
		break;
#endif	/* of #ifdef SUPPORT_UDP */

	case IPPROTO_ICMP:
		icmp_input(input);
		return;
		break;
	default:
		/*  IP ɥ쥹ϤǡΤ ICMP 顼Τ롣*/
		if (dst == IF_IPV4_ADDR_LOCAL) {
			syslog(LOG_INFO, "[IP] unexp proto: %d, src=%08x.", ip4h->proto, ip4h->src);
			icmp_error(ICMP4_UNREACH_PROTOCOL, input);
			}
		/*
		 *  icmp_error ǤϡͥåȥХåե input ֵѤʤΤ
		 *  Ƥ齪λ롣
		 */
		break;
		}

buf_rel:
	NET_COUNT_IP4(net_count_ip4.in_err_packets, 1);
	syscall(rel_net_buf(input));
	}
