/*
 *  TOPPERS/JSP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Just Standard Profile Kernel
 * 
 *  Copyright (C) 2000-2004 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 *  Copyright (C) 2001-2004 by Dep. of Computer Science and Engineering
 *                   Tomakomai National College of Technology, JAPAN
 *
 *  嵭Ԥϡʲ (1)(4) ξ狼Free Software Foundation 
 *  ˤäƸɽƤ GNU General Public License  Version 2 ˵
 *  ҤƤ˸¤ꡤܥեȥܥեȥ
 *  ѤΤޤࡥʲƱˤѡʣѡۡʰʲ
 *  ѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơŬѲǽ
 *  ޤơʤݾڤԤʤޤܥեȥѤˤľ
 *  ŪޤϴŪʤ»˴ؤƤ⡤Ǥʤ
 * 
 *  @(#) $Id: udp_input.c,v 1.1.1.1 2004/04/21 00:46:19 abe Exp abe $
 */

/*
 * Copyright (c) 1982, 1986, 1988, 1990, 1993, 1995
 *	The Regents of the University of California.  All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 3. All advertising materials mentioning features or use of this software
 *    must display the following acknowledgement:
 *	This product includes software developed by the University of
 *	California, Berkeley and its contributors.
 * 4. Neither the name of the University nor the names of its contributors
 *    may be used to endorse or promote products derived from this software
 *    without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE REGENTS AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 */

#include <t_services.h>
#include "kernel_id.h"

#include <tinet_defs.h>
#include <tinet_config.h>

#include <net/if.h>
#include <net/if_loop.h>
#include <net/if_ppp.h>
#include <net/ethernet.h>
#include <net/ppp_ipcp.h>
#include <net/net.h>
#include <net/net_buf.h>
#include <net/net_count.h>

#include <netinet/in.h>
#include <netinet/in_var.h>
#include <netinet/in_itron.h>
#include <netinet/ip.h>
#include <netinet/ip_var.h>
#include <netinet/ip_icmp.h>
#include <netinet/udp.h>
#include <netinet/udp_var.h>

#ifdef DHCP_CFG

/*
 *  udp_dstaddr_accept -- UDP Τ襢ɥ쥹å롣
 *
 *    DHCP_CFG ƤȤϡʲΥǡ롣
 *
 *      襢ɥ쥹֥ɥ㥹
 *      륢ɥ쥹̤
 */

static BOOL
udp_dstaddr_accept (UW myaddr, UW dstaddr)
{
	if (IF_IPV4_ADDR_LOCAL == IPV4_ADDRANY ||
	    dstaddr == IPV4_ADDR_BROADCAST || dstaddr == IF_IPV4_ADDR_LOCAL_BC)
		return TRUE;
	else
		return dstaddr_accept(myaddr, dstaddr);
	}

#else	/* of #ifdef DHCP_CFG */

/*
 *  udp_dstaddr_accept -- UDP Τ襢ɥ쥹å롣
 *
 *    ʲξǡ롣
 *
 *      襢ɥ쥹֥ɥ㥹
 */

static BOOL
udp_dstaddr_accept (UW myaddr, UW dstaddr)
{
	if (dstaddr == IPV4_ADDR_BROADCAST || dstaddr == IF_IPV4_ADDR_LOCAL_BC)
		return TRUE;
	else
		return dstaddr_accept(myaddr, dstaddr);
	}

#endif	/* of #ifdef DHCP_CFG */

/*
 *  udp_input -- UDP ϴؿ
 *
 *	: input ˤ IF إå IP إåƬˤ롣
 */

void
udp_input (T_NET_BUF *input)
{
	T_UDP_CCEP	*cep;
	T_UDP_HDR	*udph;
	T_IP4_HDR	*ip4h;
	INT		ix, len;
	UH		hlen, ulen;

	hlen = GET_IF_IP4_HDR_SIZE(input);

	NET_COUNT_UDP(net_count_udp.in_octets,  input->len - hlen);
	NET_COUNT_UDP(net_count_udp.in_packets, 1);

	/* إåĹå롣*/
	if (input->len < hlen + UDP_HDR_SIZE)
		goto buf_rel;

	udph = GET_UDP_HDR(input);

	/* ǡĹå */
	ulen  = ntohs(udph->ulen);
	if (ulen != input->len - hlen)
		goto buf_rel;

	/* ݡȤ 0 Υǡ˴롣RFC768 */
	if (udph->dport == 0)
		goto buf_rel;

#ifdef UDP_CFG_IN_CHECKSUM

	/* åå */
	if (udph->sum) {
		T_PIP4_HDR	*ipph;
		UH		sum, align;

		/*  IP إå롣*/
		ipph = GET_PIP4_HDR(input);
		ipph->proto = htons(IPPROTO_UDP);
		ipph->len   = udph->ulen;	/* Ǥ˥ͥåȥХȥ */

		/* 4 ƥåȶΥǡĹ */
		align = (ulen + 3) >> 2 << 2;

		/* 4 ƥåȶޤǥѥǥ󥰤롣*/
		if (align > ulen)
			memset((VP)(input->buf + hlen + ulen), 0, align - ulen);

		sum = in_cksum((VP)GET_PIP4_HDR(input), align + PIP4_HDR_SIZE(GET_IP4_HDR(input)));

		if (sum != 0)
			goto buf_rel;
		}

#endif	/* of #ifdef UDP_CFG_IN_CHECKSUM */

	ip4h = GET_IP4_HDR(input);

	/* ݡȤå */
	for (ix = tmax_udp_ccepid; ix -- > 0; ) {
		cep = &udp_ccep[ix];
		if (udp_dstaddr_accept(cep->myaddr.ipaddr, ntohl(ip4h->dst)) &&
		    ntohs(udph->dport) == cep->myaddr.portno) {
			len = ntohs(udph->ulen) - UDP_HDR_SIZE;

			if (cep->rcv_tskid != TA_NULL) {	/* Υ֥å󥰥ǥڥǥ */
				if (psnd_dtq(cep->rcvqid, (VP_INT)input) != E_OK)
					goto buf_rel;
				}
			else if (cep->rcv_p_dstaddr != NULL) {	/* Υ֥å󥰥ǥڥǥ */

				/* p_dstaddr ꤹ롣*/
				cep->rcv_p_dstaddr->portno = ntohs(udph->sport);
				cep->rcv_p_dstaddr->ipaddr = ntohl(GET_IP4_HDR(input)->src);

				/* ǡХåե˰ܤ*/
				memcpy(cep->rcv_data, input->buf + IF_IP4_UDP_HDR_SIZE,
				       len < cep->rcv_len ? len : cep->rcv_len);
				syscall(rel_net_buf(input));

				if (cep->callback == NULL)
					syslog(LOG_WARNING, "[udp_input] no call back.");
				else
					(*cep->callback)(GET_UDP_CCEPID(cep), TFN_UDP_RCV_DAT, (VP)len);
				cep->rcv_p_dstaddr = NULL;
				}
			else if (cep->callback != NULL) {
				if (psnd_dtq(cep->cb_rcvqid, (VP_INT)input) != E_OK)
					goto buf_rel;

				(*cep->callback)(GET_UDP_CCEPID(cep), TFN_UDP_RCV_DAT, (VP)len);

				/*
				 *  ǡ塼ϥǡСХåؿ
				 *  ǡɤ߽ФʤäȤˤʤΤǡΤƤ롣
				 */
				if (prcv_dtq(cep->cb_rcvqid, (VP_INT*)&input) == E_OK)
					syscall(rel_net_buf(input));
				}
			else
				goto buf_rel;
			return;
			}
		}

	/*  IP ɥ쥹ϤǡΤ ICMP 顼Τ롣*/
	if (ntohl(ip4h->dst) == IF_IPV4_ADDR_LOCAL) {
		syslog(LOG_INFO, "[UDP] unexp port: %d.", ntohs(udph->dport));
		icmp_error(ICMP4_UNREACH_PORT, input);
		/* icmp_error ǤϡͥåȥХåե input ֵѤʤΤǲȴ롣*/
		}

buf_rel:
	NET_COUNT_UDP(net_count_udp.in_err_packets, 1);
	syscall(rel_net_buf(input));
	}
