/*
 *  TOPPERS/JSP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Just Standard Profile Kernel
 * 
 *  Copyright (C) 2000-2004 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 *  Copyright (C) 2001-2004 by Dep. of Computer Science and Engineering
 *                   Tomakomai National College of Technology, JAPAN
 *
 *  嵭Ԥϡʲ (1)(4) ξ狼Free Software Foundation 
 *  ˤäƸɽƤ GNU General Public License  Version 2 ˵
 *  ҤƤ˸¤ꡤܥեȥܥեȥ
 *  ѤΤޤࡥʲƱˤѡʣѡۡʰʲ
 *  ѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơŬѲǽ
 *  ޤơʤݾڤԤʤޤܥեȥѤˤľ
 *  ŪޤϴŪʤ»˴ؤƤ⡤Ǥʤ
 * 
 *  @(#) $Id: udp_output.c,v 1.1.1.1 2004/04/21 00:46:19 abe Exp abe $
 */

/*
 * Copyright (c) 1982, 1986, 1988, 1993
 *	The Regents of the University of California.  All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 3. All advertising materials mentioning features or use of this software
 *    must display the following acknowledgement:
 *	This product includes software developed by the University of
 *	California, Berkeley and its contributors.
 * 4. Neither the name of the University nor the names of its contributors
 *    may be used to endorse or promote products derived from this software
 *    without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE REGENTS AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 */

#include <t_services.h>
#include "kernel_id.h"

#include <tinet_defs.h>
#include <tinet_config.h>

#include <net/if.h>
#include <net/if_ppp.h>
#include <net/if_loop.h>
#include <net/ethernet.h>
#include <net/net.h>
#include <net/net_buf.h>
#include <net/net_count.h>

#include <netinet/in.h>
#include <netinet/in_var.h>
#include <netinet/in_itron.h>
#include <netinet/ip.h>
#include <netinet/ip_var.h>
#include <netinet/ip_icmp.h>
#include <netinet/udp.h>
#include <netinet/udp_var.h>

/*
 *  ؿ
 */

static void udp_output (T_UDP_CCEP *cep);

/*
 *  UDP ϥ
 *  Υ֥å󥰥Ȥ߹ȤѤ롣
 */

static void
udp_output (T_UDP_CCEP *cep)
{
	T_NET_BUF	*output;
	T_UDP_HDR	*udph;
	ER_UINT		error;

#ifdef UDP_CFG_OUT_CHECKSUM
	UH	sum;
#endif	/* of #ifdef UDP_CFG_OUT_CHECKSUM */


	/* IP ǡƤ롣*/
	if (in_get_datagram(&output, UDP_HDR_SIZE + cep->snd_len, cep->snd_p_dstaddr->ipaddr,
	        	                    cep->myaddr.ipaddr, IPPROTO_UDP, TMO_UDP_OUTPUT) != E_OK) {
		NET_COUNT_UDP(net_count_udp.out_err_packets, 1);
		if (cep->callback == NULL)
			syslog(LOG_WARNING, "[udp_output] no call back.");
		else
			(*cep->callback)(GET_UDP_CCEPID(cep), TFN_UDP_SND_DAT, (VP)E_NOMEM);
		}
	else {

		/* UDP إå˾ꤹ롣*/
		udph		= GET_UDP_HDR(output);
		udph->sport	= htons(cep->myaddr.portno);
		udph->dport	= htons(cep->snd_p_dstaddr->portno);
		udph->ulen	= htons(UDP_HDR_SIZE + cep->snd_len);
		udph->sum	= 0;

		/* ǡ򥳥ԡ롣*/
		memcpy((VP)GET_UDP_SDU(output), cep->snd_data, cep->snd_len);

#ifdef UDP_CFG_OUT_CHECKSUM

		/*  IP إå˾ꤹ롣*/
		GET_PIP4_HDR(output)->len = htons(UDP_HDR_SIZE + cep->snd_len);

		sum = in_cksum((VP)GET_PIP4_HDR(output),
		               UDP_HDR_SIZE + PIP4_HDR_SIZE(GET_IP4_HDR(output)) + ((cep->snd_len + 3) >> 2 << 2));

		/* ׻åͤ 0 ʤ 0xffff 롣*/
		if (sum == 0)
			sum = 0xffff;
		udph->sum = sum;

		/* ͥåȥХåեĹĴ롣*/
		output->len = IF_IP4_UDP_HDR_SIZE + cep->snd_len;

#endif	/* of #ifdef UDP_CFG_OUT_CHECKSUM */

		/* ͥåȥ (IP) νϴؿƤӽФ*/
		error = ip_output(output, TMO_UDP_OUTPUT);

		if (cep->callback == NULL)
			syslog(LOG_WARNING, "[udp_output] no call back.");
		else if (error == E_OK)
			(*cep->callback)(GET_UDP_CCEPID(cep), TFN_UDP_SND_DAT, (VP)cep->snd_len);
		else
			(*cep->callback)(GET_UDP_CCEPID(cep), TFN_UDP_SND_DAT, (VP)error);
		cep->snd_p_dstaddr = NULL;
		}
	}

/*
 *  UDP ϥ
 *  Υ֥å󥰥Ȥ߹ȤѤ롣
 */

void
udp_output_task (VP_INT exinf)
{
	ID	tskid;
	int	ix;

	get_tid(&tskid);
	syslog(LOG_NOTICE, "[UDP OUTPUT:%d] started.", tskid);
	while (TRUE) {

		/* ϤݥȤޤԤġ*/
		syscall(wai_sem(SEM_UDP_POST_OUTPUT));

		for (ix = tmax_udp_ccepid; ix -- > 0; ) {

			if (udp_ccep[ix].flags & UDP_CEP_FLG_POST_OUTPUT) {
				udp_ccep[ix].flags &= ~UDP_CEP_FLG_POST_OUTPUT;
				udp_output(&udp_ccep[ix]);
				}
			}
		}
	}
